## 系统说明
tau-ceti: 预示着它是一个平台

## 目录结构
查看模块说明

## 核心依赖
| 依赖                  |     版本 |
|:---------------------|---------:|
| Spring Boot          |   2.4.11 |
| Spring Cloud         | 2020.0.3 |
| Spring Cloud Alibaba |   2021.1 |
| Spring Security      |    5.4.8 |
| Mybatis Plus         |  3.4.3.3 |

## 模块说明
```

tau-ceti
├── tau-ceti-dependencies-bom       -- 依赖版本管理. 继承自 spring-cloud-depencencies
├── tau-ceti-parent                 -- 父模块. 提供依赖版本管理和默认打包插件. 继承自 tau-ceti-dependencies-bom
├── tau-ceti-support                -- 基础拓展. 它非常简单, 只包含一些最简单，但又很常用的类，且不会依赖任何三方组件, 其他所有模块都会依赖它.
├── tau-ceti-tools                  -- 工具模块. 里面聚集了常用的工具类，有些需要依赖三方组件，但如果你不适用它，则依赖不是必须的。
├── tau-ceti-http-client            -- httpclient模块. 依赖 tau-ceti-tools, apache-httpcomponents. 
├── tau-ceti-acme                   -- 异步Acme协议客户端. 它的目的是解决批量证书申请时的效率问题，依赖 tau-ceti-http-client
├── tau-ceti-generator              -- 代码生成器. 依赖Mybatis-generator
├── tau-ceti-payment-sdk            -- 支付SDK开发包。
└── tau-ceti-proxy                  -- 代理服务
    ├── tau-ceti-proxy-http         -- http 代理
    └── tau-ceti-proxy-socks5       -- socks5 代理
└── rbac2                           -- rbac2 权限模块.
    ├── tau-ceti-rbac2-service      -- rbac2 service. 包含rbac2权限的增删改查服务.
    └── tau-ceti-rbac2-rest         -- rbac2 接口. 包含rbac2权限的所有web接口
├── tau-ceti-rowquery               -- rowquery模块. 对mybaits-plus 的service接口做部分增强. 将查询单条记录的返回值从 T 改为 Optianl<T>, 增加 rowquery 查询
└── tau-ceti-spring                 -- spring相关模块
    ├── tau-ceti-boots              -- 提供各种 EnableXXXX 功能。
    └── tau-ceti-spring-starters    -- 提供各种开箱即用的 starter
        ├── tau-ceti-limit-starter  -- 方法调用限制. 如同一时间web请求限制
        ├── tau-ceti-rbac2-starter  -- rbac2 的开箱即用
        ├── tau-ceti-shiro-jwt..    -- shiro jwt开箱即用
        ├── tau-ceti-shiro-spring.. -- shiro开箱即用
        └── tau-ceti-sys-log..amqp  -- 日志开箱即用
└── tau-ceti-web3j                  -- 以太坊web3j工具包
```

### 关于冷热 Flux
1. Sinks
   1. Sinks.many().multicast() 如果没有订阅者，那么接收的消息直接丢弃
   2. Sinks.many().unicast()  如果没有订阅者，那么保存接受的消息知道第一个订阅者订阅
   3. Sinks.many().replay() 不管有多少订阅者，都保存所有消息。
