package com.chuang.tauceti.acme.v2;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiPredicate;

public interface IUpdatable<T extends IUpdatable<T>> {

    CompletableFuture<T> update();

    CompletableFuture<T> update(long waitTime, int retryTimes, BiPredicate<T, Throwable> retry);

    void stopUpdate();
}
