package com.chuang.tauceti.acme.v2;

import com.chuang.tauceti.acme.v2.model.enums.OrderStatus;

import java.util.concurrent.CompletableFuture;

public abstract class OrderStatusUpdatable<T extends IUpdatable<T>> extends AbstractUpdatable<T> {

    public abstract OrderStatus getStatus();

    public synchronized CompletableFuture<T> update(long waitTime, int retryTimes) {
        return update(waitTime, retryTimes, (t, throwable) -> !getStatus().isDone());
    }

}
