package com.chuang.tauceti.acme.v2.connection;

import com.chuang.tauceti.acme.v2.Session;

import java.net.URI;
import java.net.URL;
import java.util.function.Function;

public class DefaultConnection implements Connection {

    private final Session session;
    private final Function<URI, URL> uriResolve;

    public DefaultConnection(Session session, Function<URI, URL> uriResolve) {
        this.session = session;
        this.uriResolve = uriResolve;
    }

    @Override
    public Session getSession() {
        return this.session;
    }

    @Override
    public Function<URI, URL> uriResolve() {
        return this.uriResolve;
    }

}
