package com.chuang.tauceti.acme.v2.exception;

import com.chuang.tauceti.acme.v2.Problem;

import java.net.URI;
import java.util.Objects;

public class AcmeServerException extends AcmeException {
    private static final long serialVersionUID = 5971622508467042792L;

    private final Problem problem;

    /**
     * Creates a new {@link AcmeServerException}.
     *
     * @param problem
     *            {@link Problem} that caused the exception
     */
    public AcmeServerException(Problem problem) {
        super(Objects.requireNonNull(problem).toString());
        this.problem = problem;
    }

    /**
     * Returns the error type.
     */
    public URI getType() {
        return problem.getType();
    }

    /**
     * Returns the {@link Problem} that caused the exception
     */
    public Problem getProblem() {
        return problem;
    }

}
