package com.chuang.tauceti.acme.v2.model.enums;

import org.bouncycastle.asn1.cmp.Challenge;

import java.util.Arrays;
import java.util.Optional;

public enum  ChallengeType {
    HTTP("http-01"), DNS("dns-01"), TLS_ALPN("tls-alpn-01");

    private final String code;
    ChallengeType(String code) {
        this.code = code;
    }

    public String getCode() {
        return code;
    }

    public static Optional<ChallengeType> codeOf(String code) {
        return Arrays.stream(ChallengeType.values())
                .filter(challengeType -> challengeType.code.equals(code))
                .findFirst();
    }
}
