package com.chuang.tauceti.acme.v2.provider;

import java.net.URI;

/**
 * 通用的ACME服务提供者。
 * 这个现实假设scheme为 http|https 的都能支持。
 */
public class GenericAcmeProvider implements AcmeProvider {

    @Override
    public boolean support(URI serverUri) {
        return "http".equals(serverUri.getScheme())
                || "https".equals(serverUri.getScheme());
    }

    @Override
    public String name() {
        return "generic";
    }


}
