package com.chuang.tauceti.acme.v2.store;

import com.chuang.tauceti.acme.v2.Account;
import com.chuang.tauceti.acme.v2.connection.Connection;
import com.chuang.tauceti.acme.v2.exception.AcmeStoreException;
import com.chuang.tauceti.acme.v2.provider.AcmeProvider;

import java.security.KeyPair;
import java.security.cert.X509Certificate;
import java.util.Collection;
import java.util.Optional;

/**
 *
 */
public interface AcmeStore {

    void setProvider(AcmeProvider provider);

    void save(Account account) throws AcmeStoreException;

    void delete(String keyRef);

    Optional<Account> loadAccount(String keyRef, Connection connection);

    Optional<KeyPair> loadOrderKeyPair(String orderRef);
    void saveOrderKeyPair(String orderRef, KeyPair keyPair) throws AcmeStoreException;

    void deleteOrder(String orderRef);

    void saveOrderCsr(String orderRef, byte[] csr) throws AcmeStoreException;
    Optional<byte[]> loadOrderCsr(String orderRef);


    void saveOrderCertificate(String orderRef, Collection<X509Certificate> x509Certificates) throws AcmeStoreException;

    Optional<String> loadOrderLocation(String orderRef);
    void saveOrderLocation(String orderRef, String orderLocation);
}
