package com.chuang.tauceti.blockchain.payment.client;

import org.web3j.abi.datatypes.Type;

import java.util.concurrent.CompletableFuture;

/**
 * 智能合约客户端
 */
public interface IContractClient {

    /**
     * 本币的标识
     * @return 本币标识，如以太坊的本币标识 ETH, BSC链的本币标识是 BNB
     */
    String getValueSymbol();

    /**
     * 调用智能合约
     * @param contractAddress 合约地址
     * @param funcName        方法名
     * @param from            调用地址
     * @param fromPrivateKey  私钥
     * @param args            调用参数
     * @return 交易哈希
     */
    CompletableFuture<String> functionCall(String contractAddress, String funcName, String from, String fromPrivateKey, Type<?>... args);
}
