package com.chuang.tauceti.blockchain.payment.client.eth;

import org.web3j.utils.Convert;

import java.math.BigInteger;

public interface GasProvider {

    GasProvider DEFAULT = new GasProvider() {
        @Override
        public BigInteger getGasPrice(String function) {
            return Convert.toWei("5", Convert.Unit.GWEI).toBigInteger();
        }

        @Override
        public BigInteger getGasLimit(String function) {
            return BigInteger.valueOf(80000);
        }
    };

    /**
     * 根据币种确定每次交易的 gas price
     * @param function 方法
     * @return gas price
     */
    BigInteger getGasPrice(String function);

    /**
     * 根据币种确定每次交易的 gas limit
     * @param function 方法
     * @return gas limit
     */
    BigInteger getGasLimit(String function);
    }
