package com.chuang.tauceti.blockchain.payment.client.eth;

import com.chuang.tauceti.blockchain.payment.BlockChainUtils;

import java.math.BigInteger;

public class InputDataReader {

    private String method;
    private final String input;

    private String next;

    public InputDataReader(String input) {
        this.input = input;
        reset();
    }

    public void reset() {
        this.method = input.substring(0, 10);
        next = input.substring(10);
    }

    public boolean hasNext() {
        return !next.isEmpty();
    }

    public String nextAddress() {
        String str =  next();
        if(str.toLowerCase().startsWith("0x")) {
            return "0x" + str.substring(26);
        } else {
            return "0x" + str.substring(24);
        }

    }

    public BigInteger nextNumber() {
        return BlockChainUtils.hexToInt(next());
    }


    public String next() {
        String n = next.substring(0, 64);
        next = next.substring(64);
        return n;
    }

    public String getMethod() {
        return method;
    }


}
