package com.chuang.tauceti.blockchain.payment.watch;

import org.jetbrains.annotations.Nullable;

import java.util.function.Consumer;
import java.util.function.Function;

public class WatcherWrapper<T, R> implements IWatcher<R> {

    private final IWatcher<T> watcher;
    private final Function<T, R> map;

    public WatcherWrapper(IWatcher<T> watcher, Function<T, R> map) {
        this.watcher = watcher;
        this.map = map;
    }

    @Override
    public void start() {
        watcher.start();
    }

    @Override
    public void watch(Consumer<R> next, @Nullable Consumer<Throwable> error, @Nullable Runnable completed) {
        watcher.watch(t -> next.accept(map.apply(t)), error, completed);
    }

    @Override
    public void restart() {
        watcher.restart();
    }

    @Override
    public void shutdown() {
        watcher.shutdown();
    }
}
