//package com.chuang.tauceti.blockchain.payment.test;
//
//import com.chuang.tauceti.blockchain.payment.Fluxes;
//import com.chuang.tauceti.blockchain.payment.client.eth.BscClient;
//import com.chuang.tauceti.blockchain.payment.event.Topics;
//import com.chuang.tauceti.blockchain.payment.model.eth.EthBlock;
//import com.chuang.tauceti.blockchain.payment.model.eth.EthTransaction;
//import com.chuang.tauceti.blockchain.payment.model.eth.Log;
//import com.chuang.tauceti.blockchain.payment.watch.BlockRange;
//import com.chuang.tauceti.blockchain.payment.watch.BlockWatcher;
//import com.chuang.tauceti.blockchain.payment.watch.IWatcher;
//import com.chuang.tauceti.blockchain.payment.watch.eth.LogWatcher;
//import org.junit.jupiter.api.Test;
//import org.reactivestreams.Subscription;
//import reactor.core.publisher.BaseSubscriber;
//
//import java.math.BigInteger;
//import java.util.ArrayList;
//import java.util.List;
//import java.util.concurrent.CountDownLatch;
//
//public class BlockRangeTest {
//
//    BscClient bscClient = BlockChainClientTest.bscClient;
//    @Test
//    public void testRangeAsc() {
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("17962719"), new BigInteger("17962729"));
//        range.forEach(System.out::println);
//    }
//
//    @Test
//    public void testRangeDesc() {
//
//        // TODO 倒叙有问题
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("1010"), new BigInteger("1000"));
//        range.forEach(System.out::println);
//    }
//
//    @Test
//    public void testRangeUnLimit() {
//        // 同步方式会阻塞调用线程
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("17964034"));
//        range.forEach(bigInteger ->  System.out.println(Thread.currentThread().getName() + "->" + bigInteger));
//    }
//
//    @Test
//    public void testRangeAsync() throws InterruptedException {
//        CountDownLatch latch = new CountDownLatch(1);
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("18038594"));
//        Fluxes.range(range).subscribe(new BaseSubscriber<BigInteger>() {
//            @Override
//            protected void hookOnSubscribe(Subscription subscription) {
//                request(1);
//            }
//
//            @Override
//            protected void hookOnNext(BigInteger value) {
//                System.out.println(value);
//                request(1);
//            }
//
//            @Override
//            protected void hookOnComplete() {
//                latch.countDown();
//            }
//
//            @Override
//            protected void hookOnError(Throwable throwable) {
//                throwable.printStackTrace();
//            }
//        });
//
//        latch.await();
//    }
//
//    @Test
//    public void testRangeUnLimitFlux() {
//        // 异步方式，不阻塞，打印的线程名是 okhttp 的工作线程
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("17963357"));
//
//        printAscRange(range);
//
//        waiting();
//    }
//
//    private void waiting() {
//        try {
//            Thread.sleep(100000000);
//        } catch (InterruptedException e) {
//            e.printStackTrace();
//        }
//    }
//
//    @Test
//    public void testWatchBlock() throws InterruptedException {
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("18067524"), new BigInteger("18067534"));
////        printAscRange(range);
//
//        List<EthBlock> list = new ArrayList<>();
//        CountDownLatch latch = new CountDownLatch(1);
//
//        BlockWatcher<EthBlock, EthTransaction> watcher = bscClient.watch(range, null, 0);
//        watcher.watch(list::add, Throwable::printStackTrace, () -> {
//            System.out.println("====================================\n\n\n\n\n\n\n\n");
//            list.forEach(ethBlock -> {
//                System.out.println("block_hash :-> " + ethBlock.getHash() + ", number :-> " + ethBlock.getNumber() + ",count -> " + ethBlock.getTransactions().size());
//            });
//            latch.countDown();
//        });
//        watcher.start();
//
//        latch.await();
//        System.out.println(bscClient.getLastBlockNum().join());
//    }
//
//    @Test
//    public void testRangeEach() {
//
//        BlockRange.each(BigInteger.valueOf(140), BigInteger.valueOf(140), System.out::println);
//    }
//
//    @Test
//    public void testBetween() {
//        boolean between = BlockRange.between(BigInteger.valueOf(140), BigInteger.valueOf(140), BigInteger.valueOf(140));
//        System.out.println("140 - 140 > 140 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(130), BigInteger.valueOf(140), BigInteger.valueOf(140));
//        System.out.println("130 - 140 > 140 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(130), BigInteger.valueOf(140), BigInteger.valueOf(130));
//        System.out.println("130 - 140 > 130 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(140), BigInteger.valueOf(130), BigInteger.valueOf(130));
//        System.out.println("140 - 130 > 130 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(140), BigInteger.valueOf(130), BigInteger.valueOf(140));
//        System.out.println("140 - 130 > 140 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(140), BigInteger.valueOf(130), BigInteger.valueOf(150));
//        System.out.println("140 - 130 > 150 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(130), BigInteger.valueOf(140), BigInteger.valueOf(150));
//        System.out.println("130 - 140 > 150 " + between);
//
//        between = BlockRange.between(BigInteger.valueOf(140), BigInteger.valueOf(130), BigInteger.valueOf(110));
//        System.out.println("140 - 130 > 110 " + between);
//    }
//
//    @Test
//    public void testWatchBlockLog() throws InterruptedException {
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("18074359"), null);
//
////        printAscRange(range);
//
//        List<Log> list = new ArrayList<>();
//        CountDownLatch latch = new CountDownLatch(1);
//        IWatcher<Log> watcher = bscClient.watchLog(range, Topics.token20Topic(), "0x8Dcff5Ba47aa24CFEb73A2262b7cD6D18739600c");
//
//        watcher.watch(list::add, Throwable::printStackTrace, () -> {
//            list.forEach(log -> {
//                System.out.println("block_hash :-> " + log.getBlockHash() + ", number :-> " + log.getBlockNumber() + ",tx_hash: -> " + log.getTransactionHash() + " => " + log.getDataValue());
//            });
//            latch.countDown();
//        });
//
//        watcher.start();
//
//        latch.await();
//    }
//
//    @Test
//    public void testBufferedWatchLog() throws InterruptedException {
//        BlockRange range = BlockRange.create(bscClient, new BigInteger("18075311"), new BigInteger("18077627"));
//
////        printAscRange(range);
//
//        List<Log> list = new ArrayList<>();
//        CountDownLatch latch = new CountDownLatch(1);
//        LogWatcher watcher = bscClient.watchBufferedLog(range, Topics.token20Topic(), 100, 6,"0x8Dcff5Ba47aa24CFEb73A2262b7cD6D18739600c");
//
//        watcher.watch(list::add, Throwable::printStackTrace, () -> {
//            list.forEach(log -> {
//                System.out.println("block_hash :-> " + log.getBlockHash() + ", number :-> " + log.getBlockNumber() + ",tx_hash: -> " + log.getTransactionHash() + " => " + log.getDataValue());
//            });
//            latch.countDown();
//        });
//        watcher.logNumber(true);
//        watcher.start();
//
//        latch.await();
//    }
//
//
//    private void printAscRange(BlockRange range) {
//        CountDownLatch latch = new CountDownLatch(1);
//        ((BlockRange.AscIteratorImpl)range.iterator()).nextFlux().subscribe(bigInteger -> {
//            System.out.println(Thread.currentThread().getName() + "->" + bigInteger);
//        }, Throwable::printStackTrace, latch::countDown);
//
//        try {
//            latch.await();
//        } catch (InterruptedException ignore) {}
//    }
//}
