package com.chuang.tauceti.blockchain.client.contract.ether;

import org.web3j.protocol.core.DefaultBlockParameterName;
import org.web3j.protocol.core.methods.response.EthGetTransactionCount;

import java.math.BigInteger;
import java.util.concurrent.CompletableFuture;

public interface NonceProvider {

    /**
     * 获取nonce
     */
    default CompletableFuture<BigInteger> getNonce(EthClient client, String address) {
        return client.getImpl().ethGetTransactionCount(address, DefaultBlockParameterName.PENDING).sendAsync()
                .thenApply(EthGetTransactionCount::getTransactionCount);
    }
}
