package com.chuang.tauceti.blockchain.event;

import com.chuang.tauceti.blockchain.watch.eth.ITopic;
import org.web3j.abi.EventEncoder;
import org.web3j.abi.TypeReference;
import org.web3j.abi.datatypes.Address;
import org.web3j.abi.datatypes.Event;
import org.web3j.abi.datatypes.generated.Uint256;

import java.util.Arrays;

public abstract class Topics {

    public static ITopic token20Topic() {
        return () -> EventEncoder.encode(token20Transfer());
    }

    public static ITopic create(String methodName, TypeReference<?>... args) {
        return () -> EventEncoder.encode(event(methodName, args));
    }

    public static ITopic create(String topic) {
        return () -> topic;
    }

    private static Event token20Transfer() {
        return event("Transfer",
                new TypeReference<Address>() {},
                new TypeReference<Address>() {},
                new TypeReference<Uint256>() {});
    }

    private static Event event(String methodName, TypeReference<?>... args) {
        return new Event(methodName, Arrays.asList(args));
    }
}
