package com.chuang.tauceti.blockchain.model;

import java.math.BigInteger;
import java.util.List;

/**
 * 区块信息
 */
public interface IBlock<T extends ITransaction> extends IStorage {

    /**
     * 区块哈希
     */
    String getHash();
    /**
     *  区块高度
     */
    BigInteger getNumber();
    /**
     *  父区块哈希
     **/
    String getParentHash();
    /**
     * Nonce值
     */
    BigInteger getNonce();

    /**
     *  交易 Merkle 树根
     **/
    String getTransactionsRoot();

    /**
     * 区块产出的时间戳
     */
    BigInteger getTimestamp();
    /**
     *  交易记录
     **/
    List<T> getTransactions();


}
