package com.chuang.tauceti.blockchain.model;

import java.math.BigInteger;

/**
 * 交易信息
 */
public interface ITransaction extends IStorage {

    /**
     * 所在区块哈希
     */
    String getBlockHash();

    /**
     * 交易哈希
     */
    String getTransactionHash();

    /**
     * 额度
     */
    BigInteger getValue();

    /**
     * 发起地址
     */
    String getFrom();

    /**
     * 接收地址
     */
    String getTo();

}
