package com.chuang.tauceti.blockchain.watch.eth;

import com.chuang.tauceti.blockchain.event.Topics;

/**
 * 区块链日志主题，由于以太坊 Topic 都是通过 Event 实现的。因此，可以使用
 * EventEncoder.encode(event) 的方式计算 topic，更多方法可以看 {@link Topics}
 * 可以直接到链上查询相关的topic，比如 bsc 链上 SHIB(0x2859e4544C4bB03966803b044A93563Bd2D0DD4D) 交易记录的 topic 查找方式是：
 * 1. 进入 https://bscscan.com/address/0x2859e4544C4bB03966803b044A93563Bd2D0DD4D
 * 2. 在 Transactions 选项卡中 Method 为 Transfer 中人选一条进去查看。 Transfer 方法是 ERC20 的交易方法。因此要找这个。
 * 3. 进入 Logs 选项卡，找 Topics 0 对应的哈希。
 *
 */
public interface ITopic {
    String topic();
}
