package com.chuang.tauceti.blockchain.watch.strategy;

import com.chuang.tauceti.blockchain.model.IStorage;

import java.util.Optional;

/**
 * 存储策略
 */
public interface StorageStrategy<T extends IStorage> {

    /**
     * 保存区块
     */
    void storage(String chainName, T t);

    /**
     * 加载区块
     * @param num 区块高度
     */
    Optional<T> load(String chainName, String key);

    static <T extends IStorage> StorageStrategy<T> empty() {
        return new StorageStrategy<T>() {
            @Override
            public void storage(String chainName, T t) {}

            @Override
            public Optional<T> load(String chainName, String key) {
                return Optional.empty();
            }
        };
    }
}
