package com.test;

import com.chuang.tauceti.blockchain.client.contract.ether.BscClient;
import com.chuang.tauceti.blockchain.client.contract.ether.GasProvider;
import org.junit.jupiter.api.Test;
import org.web3j.tx.gas.DefaultGasProvider;

import java.math.BigInteger;


public class BlockchainTest {

    public static final BscClient bscClient = new BscClient("https://bsc-dataseed1.binance.org", gasProvider(), null);

    public static final String TEST_SENDER = "0x4efdd61aa0d08da97748482d16443fe0d4347bb9";

    @Test
    public void testBalance() {
        System.out.println(bscClient.getBalanceAsDecimal(TEST_SENDER).join());
    }

    @Test
    public void testNonce() {
        System.out.println(bscClient.getNonce(TEST_SENDER).join());
    }

    @Test
    public void testLastBlockNum() {
        System.out.println(bscClient.getLastBlockNum().join());
    }

    @Test
    public void testLastBlockHash() {
        System.out.println(bscClient.getLastBlockHash().join());
    }

    private static GasProvider gasProvider() {
        return new GasProvider() {
            @Override
            public BigInteger getGasPrice(String function) {
//                return Convert.toWei("5", Convert.Unit.GWEI).toBigInteger();
                return DefaultGasProvider.GAS_PRICE;
            }
            @Override
            public BigInteger getGasLimit(String function) {
//                return BigInteger.valueOf(80000);
                return DefaultGasProvider.GAS_LIMIT;
            }
        };
    }
}
