package com.chuang.tauceti.generator.convert;

import com.baomidou.mybatisplus.generator.config.ITypeConvert;
import com.baomidou.mybatisplus.generator.config.converts.select.BranchBuilder;
import com.baomidou.mybatisplus.generator.config.converts.select.Selector;
import com.baomidou.mybatisplus.generator.config.rules.IColumnType;

/**
 * 自定义类型转换器
 * @author ATH
 */
public abstract class CustomTypeConvert implements ITypeConvert {
    /**
     * 使用指定参数构建一个选择器
     * @param fieldType 字段类型
     * @return 转换器
     */
    protected static Selector<String, IColumnType> use(String fieldType) {
        return new Selector<>(fieldType.toLowerCase());
    }

    protected static BranchBuilder<String, IColumnType> contains(CharSequence value) {
        return BranchBuilder.of(s -> s.contains(value));
    }

    protected static BranchBuilder<String, IColumnType> containsAny(CharSequence... values) {
        return BranchBuilder.of(s -> {
            for (CharSequence value : values) {
                if (s.contains(value)) {
                    return true;
                }
            }
            return false;
        });
    }
}
