package com.chuang.tauceti.sdk.payment;

/**
 * 银行枚举，其主要目的是统一银行名称。
 * 类似于在线支付接口中定义的银行编号总有差别，在订制接口时不方便。
 * 统一名称后再在实现中区分有利于接口统一。
 * Created by ath on 2016/7/7.
 */
public enum Bank {
    /** 招商银行 */
    CMB,
    /** 工商银行 */
    ICBC,
    /** 交通银行 */
    BOCOM,
    /** 建设银行 */
    CCB,
    /** 农业银行 */
    ABC,
    /** 光大银行 */
    CEB,
    /** 民生银行 */
    CMBC,
    /** 平安银行 */
    PAB,
    /** 浦发银行 */
    SPDB,
    /** 兴业银行 */
    CIB,
    /** 中国银行 */
    BOCSH,
    /** 中信银行 */
    CITIC,
    /** 北京银行 */
    BOB,
    /** 南京银行 */
    NJCB,
    /** 广发银行 */
    GDB,
    /** 华夏银行 */
    HXBC,
    /** 邮政储蓄 */
    PSBC,
    /** 深圳发展银行 */
    SDB,
    /** 东亚银行 */
    BEA,
    /** 上海银行 */
    BOS,
    /** 徽商银行 */
    HSB,
    /** 浙商银行 */
    ZSB,
    /** 北京农商银行 */
    BJAB,
    /** 杭州银行 */
    HZBC,
    /** 宁波银行 */
    NBBC,
    /** 厦门银行 */
    XMB
}
