package com.chuang.tauceti.rowquery;

import com.chuang.tauceti.support.rowquery.RowQuery;
import com.chuang.tauceti.support.rowquery.filters.TextFilter;
import com.chuang.tauceti.tools.basic.collection.CollectionKit;
import com.chuang.tauceti.tools.basic.reflect.BeanKit;

import java.util.Arrays;
import java.util.Optional;
import java.util.function.Function;

/**
 * @author ATH
 */
public class RowQueryUtil {

    public static void querySelf(RowQuery<?> rowQuery, String loginUser) {
        TextFilter filter = new TextFilter();
        filter.setField("creator");
        filter.setOption("equals");
        filter.setValue(loginUser);
        RowQuery.Filter[] fs = CollectionKit.append(rowQuery.getFilters(), filter);
        rowQuery.setFilters(fs);
    }
    
    public static Optional<RowQuery.Filter> getFilter(RowQuery<?> rowQuery, String field) {
        return Arrays.stream(rowQuery.getFilters()).filter(filter -> filter.getField().equals(field)).findFirst();
    }

    public static <T> void setFilterValue(RowQuery<?> rowQuery, String field, T value) {
        getFilter(rowQuery, field).ifPresent(filter -> BeanKit.setFieldValue(filter, field, value));
    }

    public static <V> void mapFilterValue(RowQuery<?> rowQuery, String field, Function<Object, V> map) {
        getFilter(rowQuery, field).ifPresent(filter -> {
            BeanKit.getFieldValue(filter, "value").ifPresent(o -> {
                V v = map.apply(o);
                BeanKit.setFieldValue(filter, "value", v);
            });

        });
    }
}
