package com.chuang.tauceti.rowquery.controller.basic;

import org.apache.shiro.SecurityUtils;

/**
 * @author ath
 */
public interface IAutoPermissionController {

	/**
	 * 获取权限前缀
	 *
	 * @return 权限前缀
	 */
	default String basePermission() {
		return null;
	}

	/**
	 * 检查权限
	 *
	 * @param suffix 权限后缀
	 */
	default void checkPermission(String suffix) {
		String base = basePermission();
		if (base != null) {
			SecurityUtils.getSubject().checkPermission(basePermission() + suffix);
		}
	}
}
