package com.chuang.tauceti.limit.annotations;

import com.chuang.tauceti.support.enums.Whether;

import java.lang.annotation.*;

/**
 * 请求限制
 * @author ATH
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface Limit {


    Whether value() default Whether.UNKNOWN;

    /** 同一时间最多几个 */
    int maxMulti() default 0;

    /** 隔离方式 */
    String quarantine() default "";

    /** 分组，优先级高于groupName() */
    String group() default "";

    /** 分组映射名 */
    String groupName() default "";
}
