package com.chuang.tauceti.limit.aop;

import com.chuang.tauceti.limit.LimitInfo;
import com.chuang.tauceti.limit.LimitProperties;
import com.chuang.tauceti.limit.Limiter;
import com.chuang.tauceti.limit.annotations.Limit;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.lang.reflect.Method;

/**
 * @author ATH
 */
@Aspect
@Slf4j
@Component
public class LimitAspect {

    @Resource private Limiter limiter;

    @Pointcut("@annotation(com.chuang.tauceti.limit.annotations.Limit)")
    public void limitPointcut() {}

    @Around(value = "limitPointcut()")
    public Object handlerControllerMethod(ProceedingJoinPoint pjp) throws Throwable {
        return limiter.doLimit(pjp);
    }



}
