package com.chuang.tauceti.limit.configuration;


import com.chuang.tauceti.limit.counter.LimitCountRunner;
import com.chuang.tauceti.limit.LimitProperties;
import com.chuang.tauceti.limit.counter.LocalCountRunner;
import com.chuang.tauceti.support.exception.SystemException;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

/**
 * @author ATH
 */
@ConditionalOnProperty(name = "tau-ceti.limit.enabled", matchIfMissing = true)
@Configuration
@EnableConfigurationProperties(LimitProperties.class)
@ComponentScan("com.chuang.tauceti.limit")
public class LimitAutoConfiguration {



    @Bean
    @ConditionalOnMissingBean
    public LimitCountRunner limitCountRunner() {
        return new LocalCountRunner();
    }

//    @Bean
//    public Limiter limiter() {
//        return new Limiter(limitQuotes(), limitGroupMappings(), limitCountRunner());
//    }
}
