package com.chuang.tauceti.limit.counter;

import com.chuang.tauceti.limit.Runner;
import com.chuang.tauceti.limit.exception.LimitException;

/**
 * @author ATH
 */
public interface LimitCountRunner {

    /**
     * 用于验证指定隔离的方法是否执行
     * @param group 隔离组
     * @param quarantine 隔离字符
     * @param maxMulti 最大次数
     * @param getter 执行操作
     * @param <T> 返回结果类型
     * @return 操作结果
     */
    <T> T countRun(String group, String quarantine, int maxMulti, Runner<T> getter) throws Throwable;
}
