package com.chuang.tauceti.limit.quote;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint;
import org.springframework.stereotype.Component;

import java.lang.reflect.Method;
import java.lang.reflect.Parameter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author ATH
 */
@Component
public class MethodArgsQuote implements IQuote {
    @Override
    public String refer() {
        return METHOD_ARGS;
    }

    @Override
    public Object quote(ProceedingJoinPoint pjp) {
        Object[] args = pjp.getArgs();
        Map<String, Object> map = new HashMap<>(args.length);
        Method method = ((MethodSignature) pjp.getSignature()).getMethod();

        List<String> names = Arrays.stream(method.getParameters()).map(Parameter::getName).collect(Collectors.toList());
        for (int i = 0; i < names.size(); i++) {
            map.put(names.get(i), args[i]);
        }
        return map;
    }
}
