package com.chuang.tauceti.shiro.spring.web.jwt;

import org.apache.shiro.authc.AuthenticationException;

import java.util.List;
import java.util.stream.Collectors;

public class MultiAuthenticationException extends AuthenticationException {

    private final List<AuthenticationException> errors;
    public MultiAuthenticationException(List<AuthenticationException> errors) {
        this.errors = errors;
    }

    public List<AuthenticationException> getErrors() {
        return errors;
    }
    @Override
    public String getMessage() {
        return errors.stream().map(Throwable::getMessage).collect(Collectors.joining(","));
    }
}
