package com.chuang.tauceti.shiro.spring.web.jwt.properties;

import lombok.Data;

import java.util.UUID;

/**
 * @author ATH
 */
@Data
public class JwtProperties {

    private int refreshStatus = 200;

    private String tokenHeader = "Authorization";

    private String secret = UUID.randomUUID().toString();

    private long expire = 3600000;

    private String issuer;

    /** 主题 */
    private String subject;

    /**
     * 刷新时机，设定到期时间小于这个值时token才会刷新,推荐这个时间接近过期时间一点，太短很容易让人感觉短时间就过期了
     * 目前的设置相当于100秒内不刷新 jwt。 这样就既不会频繁刷新jwt，也不至于短时间不操作就到期。
     */
    private long refreshCountdown = 3500000;

    private boolean autoRefresh = true;
}
