package com.chuang.tauceti.shiro.spring.web.jwt.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.NestedConfigurationProperty;

import java.util.LinkedHashMap;
import java.util.List;

/**
 * @author ATH
 */
@Data
@ConfigurationProperties(prefix = "shiro")
public class ShiroProperties {

    private boolean enabled = true;

    private String loginUrl = "/login";

    private List<String[]> auth;

    private String successUrl = "/";

    private String unauthorizedUrl;

    /** 是否委托shiro进行验证 */
    private boolean loginHosting = true;

    /**
     * 设置无需权限路径集合
     */
    private List<String[]> anon;

    /**
     * 设置无需权限路径集合, 作用和 anon 一样。
     */
    private List<String[]> anonExt;

    private LinkedHashMap<String, String> filterChainDefinitions;

    @NestedConfigurationProperty
    private HashedCredentialProperties hashedCredential = new HashedCredentialProperties();

    @NestedConfigurationProperty
    private JwtProperties jwt = new JwtProperties();
}
