package com.chuang.tauceti.shiro.spring.web.config;

import org.apache.shiro.SecurityUtils;
import org.apache.shiro.mgt.SecurityManager;
import org.apache.shiro.subject.PrincipalCollection;

import java.util.Collection;

/**
 * @author ATH
 */
public class ShiroUtils {

    public static boolean hasPermission(String permission) {
        return SecurityUtils.getSecurityManager().isPermitted(
                SecurityUtils.getSubject().getPrincipals(),
                permission
        );
    }

    public static boolean canAll(Collection<String> roles, Collection<String> abilities) {
        PrincipalCollection principals = SecurityUtils.getSubject().getPrincipals();

        boolean canRole = SecurityUtils.getSecurityManager().hasAllRoles(principals, roles);
        boolean canAbility = SecurityUtils.getSecurityManager().isPermittedAll(principals, abilities.toArray(new String[0]));

        return canRole && canAbility;
    }
    public static boolean canAny(Collection<String> roles, Collection<String> abilities) {
        PrincipalCollection principals = SecurityUtils.getSubject().getPrincipals();
        SecurityManager manager = SecurityUtils.getSecurityManager();
        boolean canRole = roles.stream().anyMatch(s -> manager.hasRole(principals, s));
        boolean canAbility = abilities.stream().anyMatch(s -> manager.isPermitted(principals, s));
        return canRole && canAbility;
    }

}
