//package com.chuang.tauceti.syslog.amqp.aop;
//
//import com.alibaba.fastjson.JSONObject;
//import com.chuang.tauceti.syslog.amqp.*;
//import com.chuang.tauceti.syslog.amqp.annotation.SysLog;
//import com.chuang.tauceti.tools.basic.ExceptionKit;
//import com.chuang.tauceti.tools.third.servlet.HttpKit;
//import lombok.extern.slf4j.Slf4j;
//import org.aspectj.lang.ProceedingJoinPoint;
//import org.aspectj.lang.annotation.Around;
//import org.aspectj.lang.annotation.Aspect;
//import org.aspectj.lang.reflect.MethodSignature;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Qualifier;
//import org.springframework.context.annotation.Lazy;
//import org.springframework.messaging.Message;
//import org.springframework.messaging.MessageChannel;
//import org.springframework.messaging.support.GenericMessage;
//import org.springframework.messaging.support.MessageBuilder;
//import org.springframework.stereotype.Component;
//
//import javax.annotation.Resource;
//import javax.servlet.http.HttpServletRequest;
//import java.lang.reflect.Method;
//import java.util.Optional;
//
///**
// * @author ATH
// */
//@Aspect
//@Component
//@Slf4j
//public class SysLogAspect {
//
//    @Resource
//    @Qualifier("sendSysLog-out-0")
//    private MessageChannel outputMsg;
//
//    @Resource private ISender sender;
//    @Resource private SysLogProperties properties;
//
//    @Around(value = "@annotation(org.springframework.web.bind.annotation.RequestMapping)")
//    public Object handlerControllerMethod(ProceedingJoinPoint pjp) throws Throwable {
//
//        Optional<SysLogDTO> sysLogOpt = getSysLog(((MethodSignature)pjp.getSignature()).getMethod());
//
//        if (sysLogOpt.isPresent()) {
//            SysLogDTO dto = sysLogOpt.get();
//            long startTime = System.currentTimeMillis();
//            Throwable err = null;
//            try {
//                return pjp.proceed();
//            } catch (Throwable e) {
//                err = e;
//                throw e;
//            } finally {
//                // 本次操作用时（毫秒）
//                long elapsedTime = System.currentTimeMillis() - startTime;
//                if(log.isDebugEnabled()) {
//                    log.debug("[{}]use time: {}", pjp.getSignature(), elapsedTime);
//                }
//                dto.setStatus(null == err ? OperationStatusEnum.FAIL.getCode() : OperationStatusEnum.SUCCESS.getCode())
//                        .setException(null == err ? null : ExceptionKit.getTrace(err))
//                        .setTime(String.valueOf(elapsedTime));
//
//                // 发送消息到 系统日志队列
//                sysLogOpt.ifPresent(sysLog -> outputMsg.send(MessageBuilder.withPayload(dto).build()));
//            }
//        } else {
//            return pjp.proceed();
//        }
//    }
//
//    private Optional<SysLogDTO> getSysLog(Method method) {
//        if (this.properties.isEnable()) {
//            return Optional.empty();
//        }
//        Class<?> clazz = method.getDeclaringClass();
//
//        if (!clazz.isAnnotationPresent(SysLog.class) && !method.isAnnotationPresent(SysLog.class)) {
//            return Optional.empty();
//        }
//
//        SysLogDTO sysLogDTO = new SysLogDTO()
//                .setParams(JSONObject.toJSONString(HttpKit.getRequestParameters()))
//                .setRemoteAddr(HttpKit.getIpAddress().orElse(HttpKit.UNKNOWN))
//                .setMethod(HttpKit.getRequest().map(HttpServletRequest::getMethod).orElse(HttpKit.UNKNOWN))
//                .setRequestUri(HttpKit.getRequest().map(HttpServletRequest::getRequestURI).orElse(HttpKit.UNKNOWN))
//                .setUserAgent(HttpKit.getRequest().map(request -> request.getHeader("User-Agent")).orElse(HttpKit.UNKNOWN))
//                .setCreator(sender.getSender(method));
//
//        if (clazz.isAnnotationPresent(SysLog.class)) {
//            SysLog log = clazz.getAnnotation(SysLog.class);
//            sysLogDTO.setServiceId(log.serviceId())
//                    .setModuleName(log.moduleName())
//                    .setActionName(log.actionName());
//        }
//
//        if(method.isAnnotationPresent(SysLog.class)) {
//            SysLog log = method.getAnnotation(SysLog.class);
//            sysLogDTO.setServiceId(log.serviceId())
//                    .setModuleName(log.moduleName())
//                    .setActionName(log.actionName());
//        }
//
//        if(null == sysLogDTO.getServiceId()) {
//            sysLogDTO.setServiceId(properties.getServiceId());
//        }
//
//        if(null == sysLogDTO.getModuleName()) {
//            sysLogDTO.setModuleName(properties.getModuleName());
//        }
//
//        if(null == sysLogDTO.getActionName()) {
//            sysLogDTO.setActionName(properties.getActionName());
//        }
//
//        return Optional.of(sysLogDTO);
//
//    }
//}
