package com.chuang.tauceti.support.enums;

/**
 * 当我们需要判断一个行为是否成功时总会想到 boolean 类型。用二进制的 0 和 1 表示 false和 true
 * 但我们忽略了一个重要的事情，那就是我们可能并不知道结果究竟是成功还是失败。
 * 据说老毛子的计算机是3进制的，2表示未知。
 * @author ATH
 */

public enum Whether {
    /** 是, true */
    YES,
    /** 否, false */
    NO,
    /** 未知 */
    UNKNOWN;

    public boolean isSuccess() {
        return YES == this;
    }
}
