package com.chuang.tauceti.support.rowquery;

/**
 * Created by ath on 2018/4/28.
 */

import lombok.Data;

import java.util.List;

/**
 * 查询条件
 */
@Data
public class RowQuery<T> {
    /**
     * 页码
     */
    private Long pageNum;

    /**
     * 页大小
     */
    private Long pageSize;

    /**
     * 排序模型
     */
    private SortModel[] sorts;
    /**
     * 过滤器模型(条件)
     */
    private Filter[] filters;

    private String[] fields;
    /**
     * 树查询
     */
    private String[] treePath;

//    /**
//     * 行组（暂时未实现）
//     */
//    private ColumnQry[] rowGroupCols;
//    /**
//     * 规定只查询的列（暂时未实现）
//     */
//    private ColumnQry[] valueCols;

    private StatisticRow[] statisticRows;


    @Data
    public static class StatisticRow {
        private List<String> fields;
        private Func func;
    }

    public enum Func {
        sum;
    }

    @Data
    public static class SortModel {
        private String field;
        private String sort;
    }

    @Data
    public static class ColumnQry {
        private String id;
        private String displayName;
        private String field;
        private String aggFunc;
    }

    public interface Filter {
        String getField();
        FilterType getFilterType();
    }

//    public void asc(Function<T> getter) {
//
//    }
//
//    public void desc(Function<T, > getter) {
//
//    }

}
