package com.chuang.tauceti.support.vg;

import java.util.Optional;

public class DefaultValueGetter<T> implements ValueGetter<T> {

    private volatile T tmp;

    @Override
    public void set(T obj) {
        this.tmp = obj;
    }

    @Override
    public void release() {
        this.tmp = null;
    }

    @Override
    public Optional<T> get() {
        return Optional.ofNullable(tmp);
    }
}
