package com.chuang.tauceti.support.vg;


import java.util.Optional;
import java.util.function.Supplier;

/**
 * 操作者管理器
 * @author ath
 */
public class OperatorManager extends ThreadLocalValueGetter<String> implements ValueGetter<String> {

    private final Supplier<Optional<String>> operatorGetter;

    private OperatorManager(Supplier<Optional<String>> operatorGetter) {
        this.operatorGetter = operatorGetter;
    }

    public void init() {
        this.set(operatorGetter.get().orElse(null));
    }

    public static OperatorManager createOpt(Supplier<Optional<String>> operatorGetter) {
        return new OperatorManager(operatorGetter);
    }

    public static OperatorManager create(Supplier<String> operatorGetter) {
        return new OperatorManager(() -> Optional.ofNullable(operatorGetter.get()));
    }
}
