package com.chuang.tauceti.support.vg;

import java.util.Optional;

/**
 * @author ATH
 */
public class ThreadLocalValueGetter<T> implements ValueGetter<T> {
    private final ThreadLocal<T> objectThreadLocal = new ThreadLocal<>();

    @Override
    public Optional<T> get() {
        T obj = objectThreadLocal.get();
        return Optional.ofNullable(obj);
    }

    @Override
    public void set(T obj) {
        this.objectThreadLocal.set(obj);
    }

    @Override
    public void release() {
        this.objectThreadLocal.set(null);
    }
}
