package com.chuang.tauceti.ui.table;

import com.chuang.tauceti.support.BiValue;
import com.chuang.tauceti.tools.basic.reflect.BeanKit;

import javax.swing.table.AbstractTableModel;
import java.lang.reflect.Field;
import java.util.*;
import java.util.stream.Collectors;

public class TableModel<T extends RowId> extends AbstractTableModel {

    private final List<T> data = new ArrayList<>();
    private final List<Field> fields;
    private final Map<String, BiValue<T, Integer>> dataMap = new HashMap<>();

    public TableModel(Class<T> clazz) {
        fields = BeanKit.getFields(clazz, false, field -> field.getAnnotation(TableField.class) != null)
                .stream()
                .sorted(Comparator.comparing(field -> field.getAnnotation(TableField.class).order()))
                .collect(Collectors.toList());

    }

    public void addRow(T t) {
        addRow0(t);
        fireTableRowsInserted(data.size() - 1, data.size() - 1);
    }

    public void addRows(Collection<T> t) {
        t.forEach(this::addRow0);
        fireTableRowsInserted(data.size() - t.size() - 1, data.size() - 1);
    }



    public void delete(T t) {

    }

    private void addRow0(T t) {
        data.add(t);
        dataMap.put(t.rowId(), new BiValue<>(t, data.size()));
    }

    private void deleteRow(T t) {

    }

    private void deleteRow(int index) {

    }

    private void deleteRow0(T t) {
        BiValue<T, Integer> bi = dataMap.get(t.rowId());
        int idx = bi.getTwo();

    }

    @Override
    public int getRowCount() {
        return data.size();
    }

    @Override
    public int getColumnCount() {
        return fields.size();
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        T t = data.get(rowIndex);
        return BeanKit.getFieldValue(t, fields.get(columnIndex));
    }
}
