package com.chuang.telegram.bot;

import com.chuang.tauceti.httpclient.annotations.AsyncHttpClient;
import com.chuang.tauceti.httpclient.async.IAsyncHttpClient;
import com.chuang.telegram.bot.configs.TelegramBotConfig;
import com.chuang.telegram.bot.interfaces.BotApiMethod;
import com.chuang.telegram.bot.interfaces.Sender;
import com.google.inject.Inject;
import com.google.inject.Singleton;

import java.io.Serializable;
import java.util.concurrent.CompletableFuture;

@Singleton
public class DefaultSender implements Sender {

    private final IAsyncHttpClient httpClient;
    private final TelegramBotConfig config;

    @Inject
    public DefaultSender(@AsyncHttpClient IAsyncHttpClient httpClient, TelegramBotConfig config) {
        this.httpClient = httpClient;
        this.config = config;
    }

    @Override
    public <T extends Serializable, M extends BotApiMethod<T>> CompletableFuture<T> asyncSend(String botKey, M method) {
        return method.send(config.getApi(), botKey, httpClient);
    }
}
