package com.chuang.telegram.bot.enums;

public enum AllowedUpdates {
    /***/
    MESSAGE("message"),
    EDITED_MESSAGE("edited_message"),
    CHANNEL_POST("channel_post"),
    EDITED_CHANNEL_POST("edited_channel_post"),
    INLINE_QUERY("inline_query"),
    CHOSEN_INLINE_RESULT("chosen_inline_result"),
    CALLBACK_QUERY("callback_query");




    private final String text;

    AllowedUpdates(String text) {
        this.text = text;
    }

    @Override
    public String toString() {
        return text;
    }

    public static AllowedUpdates of(String text) {
        if (text == null) {
            return null;
        }
        return AllowedUpdates.valueOf(text.toUpperCase());
    }
}
