package com.chuang.telegram.bot.exception;

import com.chuang.telegram.bot.interfaces.BotApiMethod;
import com.chuang.telegram.bot.interfaces.InputBotApiObject;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief Exception from method validations
 * @date 16 of September of 2016
 */
public class TelegramApiValidationException extends TelegramApiException {
    private BotApiMethod<?> method;
    private InputBotApiObject object;

    public TelegramApiValidationException(String message, BotApiMethod<?> method) {
        super(message);
        this.method = method;
    }

    public TelegramApiValidationException(String message, InputBotApiObject object) {
        super(message);
        this.object = object;
    }

    public BotApiMethod<?> getMethod() {
        return method;
    }

    public InputBotApiObject getObject() {
        return object;
    }

    @Override
    public String toString() {
        if (method != null) {
            return super.toString() + " in method: " + method.toString();
        }
        if (object != null) {
            return super.toString() + " in object: " + object.toString();
        }
        return super.toString();
    }
}
