package com.chuang.telegram.bot.interfaces;

import com.chuang.tauceti.support.exception.BusinessException;
import com.chuang.telegram.bot.exception.TelegramCallApiException;
import com.chuang.telegram.bot.model.BotApiResponse;
import com.chuang.telegram.bot.model.Message;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;

import java.io.Serializable;

public interface AnyBotApiMethod extends BotApiMethod<Serializable> {

    @Override
    default Serializable deserialize(String answer) {
        try {
            BotApiResponse<Boolean> bar = OBJECT_MAPPER.readValue(answer, new TypeReference<BotApiResponse<Boolean>>() {});
            if (bar.getOk()) {
                return bar.getResult();
            } else {
                throw new TelegramCallApiException(
                        getMethod() + " request 错误:->" + bar.getErrorDescription(),
                        bar.getErrorCode(),
                        bar.getParameters());
            }
        } catch (JsonProcessingException e) {
            try {
                BotApiResponse<Message> bar = OBJECT_MAPPER.readValue(answer, new TypeReference<BotApiResponse<Message>>() {});
                if (bar.getOk()) {
                    return bar.getResult();
                } else {
                    throw new TelegramCallApiException(
                            getMethod() + " request 错误:->" + bar.getErrorDescription(),
                            bar.getErrorCode(),
                            bar.getParameters());
                }
            } catch (JsonProcessingException e1) {
                throw new BusinessException(getMethod() + " response JSON 解析异常", e);
            }
        }
    }
}
