package com.chuang.telegram.bot.interfaces;

import java.io.Serializable;
import java.util.concurrent.CompletableFuture;

/**
 * 消息发送
 */
public interface Sender {


    default <T extends Serializable, M extends BotApiMethod<T>> T send(String botKey, M method) {
        return asyncSend(botKey, method).join();
    }

    <T extends Serializable, M extends BotApiMethod<T>> CompletableFuture<T> asyncSend(String botKey, M method);

}
