package com.chuang.telegram.bot.interfaces;

import com.chuang.telegram.bot.exception.TelegramApiValidationException;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief Interface that can be implemented by objects that knows how to validate their fields
 * @date 16 of September of 2016
 */
public interface Validable {
    /**
     * Validates that mandatory fields are filled and optional objects
     */
    void validate() throws TelegramApiValidationException;

    default <T> T checkNotNull(T t) {
        if(null == t) {
            throw new NullPointerException();
        } else {
            return t;
        }
    }
}
