package com.chuang.telegram.bot.methods.stickers;

import com.chuang.telegram.bot.exception.TelegramApiValidationException;
import com.chuang.telegram.bot.interfaces.BotApiMethod;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.experimental.Accessors;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * Use this method to delete a sticker from a set created by the bot. Returns True on success.
 */
@Data
@Accessors(chain = true)
public class DeleteStickerFromSet implements BotApiMethod<Boolean> {
    private static final String PATH = "deleteStickerFromSet";

    private static final String STICKER_FIELD = "sticker";

	/**  File identifier of the sticker */
    @JsonProperty(STICKER_FIELD)
    private String sticker;

    public DeleteStickerFromSet() {
        super();
    }

    public DeleteStickerFromSet(String sticker) {
        super();
        this.sticker = checkNotNull(sticker);
    }

    @Override
    public String getMethod() {
        return PATH;
    }

    @Override
    public void validate() throws TelegramApiValidationException {
        if (sticker == null || sticker.isEmpty()) {
            throw new TelegramApiValidationException("sticker can't be null", this);
        }
    }
}
