package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;


@Data
public class Audio implements BotApiObject {

    private static final String FILE_ID_FIELD = "file_id";
    private static final String DURATION_FIELD = "duration";
    private static final String MIMETYPE_FIELD = "mime_type";
    private static final String FILESIZE_FIELD = "file_size";
    private static final String TITLE_FIELD = "title";
    private static final String PERFORMER_FIELD = "performer";
    private static final String THUMB_FIELD = "thumb";

    /** < Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** < Long	Duration of the audio in seconds as defined by sender */
    @JsonProperty(DURATION_FIELD)
    private Long duration;
    /** < Optional. MIME type of the file as defined by sender */
    @JsonProperty(MIMETYPE_FIELD)
    private String mimeType;
    /** < Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;
    /** < Optional. Title of the audio as defined by sender or by audio tags */
    @JsonProperty(TITLE_FIELD)
    private String title;
    /** < Optional. Performer of the audio as defined by sender or by audio tags */
    @JsonProperty(PERFORMER_FIELD)
    private String performer;
    /** < Optional. Thumbnail of the album cover to which the music file belongs */
    @JsonProperty(THUMB_FIELD)
    private PhotoSize thumb;


}
