package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * This object represents a chat photo.
 */
@Data
public class ChatPhoto implements BotApiObject {
    private static final String SMALL_FILEID_FIELD = "small_file_id";
    private static final String BIG_FILEID_FIELD = "big_file_id";

    /** < Unique file identifier of small (160x160) chat photo. This file_id can be used only for photo download. */
    @JsonProperty(SMALL_FILEID_FIELD)
    private String smallFileId;
    /** < Unique file identifier of big (640x640) chat photo. This file_id can be used only for photo download. */
    @JsonProperty(BIG_FILEID_FIELD)
    private String bigFileId;

}
