package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * This object represents a phone contact.
 */
@Data
public class Contact implements BotApiObject {

    private static final String PHONE_NUMBER_FIELD = "phone_number";
    private static final String FIRSTNAME_FIELD = "first_name";
    private static final String LASTNAME_FIELD = "last_name";
    private static final String USERID_FIELD = "user_id";
    private static final String VCARD_FIELD = "vcard";

    /** < Contact's phone number */
    @JsonProperty(PHONE_NUMBER_FIELD)
    private String phoneNumber;
    /** < Contact's first name */
    @JsonProperty(FIRSTNAME_FIELD)
    private String firstName;
    /** < Optional. Contact's last name */
    @JsonProperty(LASTNAME_FIELD)
    private String lastName;
    /** < Optional. Contact's user identifier in Telegram */
    @JsonProperty(USERID_FIELD)
    private Long userId;
    /** < Optional. Additional data about the contact in the form of a vCard */
    @JsonProperty(VCARD_FIELD)
    private String vCard;

}
