package com.chuang.telegram.bot.model;

import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *  Types of messages entities
 */
public interface EntityType {
    /** @username */
    String MENTION = "mention";
    /** #hashtag */
    String HASHTAG = "hashtag";
    /** $USD */
    String CASHTAG = "cashtag";
    /** /botcommand */
    String BOTCOMMAND = "bot_command";
    /** http://url.url */
    String URL = "url";
    /** email@email.com */
    String EMAIL = "email";
    /** +4299999999 */
    String PHONENUMBER = "phone_number";
    /** Bold text */
    String BOLD = "bold";
    /** Italic text */
    String ITALIC = "italic";
    /** Monowidth string */
    String CODE = "code";
    /** Monowidth block */
    String PRE = "pre";
    /** Clickable urls */
    String TEXTLINK = "text_link";
    /** for users without usernames */
    String TEXTMENTION = "text_mention";

}

