package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents a point on the map.
 * @date 20 of June of 2015
 */
@Data
public class Location implements BotApiObject {

    private static final String LONGITUDE_FIELD = "longitude";
    private static final String LATITUDE_FIELD = "latitude";

    /** Longitude as defined by sender */
    @JsonProperty(LONGITUDE_FIELD)
    private Float longitude;
    /** Latitude as defined by sender */
    @JsonProperty(LATITUDE_FIELD)
    private Float latitude;

}
