package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents one size of a photo or a file / sticker thumbnail.
 * @date 20 of June of 2015
 */
@Data
public class PhotoSize implements BotApiObject {

    private static final String FILE_ID_FIELD = "file_id";
    private static final String WIDTH_FIELD = "width";
    private static final String HEIGHT_FIELD = "height";
    private static final String FILESIZE_FIELD = "file_size";
    private static final String FILEPATH_FIELD = "file_path";

    /**  Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /**  Photo width */
    @JsonProperty(WIDTH_FIELD)
    private Integer width;
    /**  Photo height */
    @JsonProperty(HEIGHT_FIELD)
    private Integer height;
    /**  Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;
    /**  Undocumented field. Optional. Can contain the path to download the file direclty without calling to getFile */
    @JsonProperty(FILEPATH_FIELD)
    private String filePath;

    public boolean hasFilePath() {
        return filePath != null && !filePath.isEmpty();
    }
}
