package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class User implements BotApiObject {

    private static final String ID_FIELD = "id";
    private static final String FIRSTNAME_FIELD = "first_name";
    private static final String BOT_FIELD = "is_bot";
    private static final String LASTNAME_FIELD = "last_name";
    private static final String USERNAME_FIELD = "username";
    private static final String LANGUAGE_CODE_FIELD = "language_code";

    /** < Unique identifier for this user or bot */
    @JsonProperty(ID_FIELD)
    private String id;
    /** < User‘s or bot’s first name */
    @JsonProperty(FIRSTNAME_FIELD)
    private String firstName;
    /** < True, if this user is a bot */
    @JsonProperty(BOT_FIELD)
    private Boolean bot;
    /** < Optional. User‘s or bot’s last name */
    @JsonProperty(LASTNAME_FIELD)
    private String lastName;
    /** < Optional. User‘s or bot’s username */
    @JsonProperty(USERNAME_FIELD)
    private String userName;
    /** < Optional. IETF language tag of the user's language */
    @JsonProperty(LANGUAGE_CODE_FIELD)
    private String languageCode;

}
