package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represent a user's profile pictures.
 * @date 22 of June of 2015
 */
@Data
public class UserProfilePhotos implements BotApiObject {

    private static final String TOTAL_COUNT_FIELD = "total_count";
    private static final String PHOTOS_FIELD = "photos";

    /** Total number of profile pictures the target user has */
    @JsonProperty(TOTAL_COUNT_FIELD)
    private Long totalCount;
    /** Requested profile pictures (in up to 4 sizes each) */
    @JsonProperty(PHOTOS_FIELD)
    private List<List<PhotoSize>> photos;

}
