package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * This object represents a venue.
 */
@Data
public class Venue implements BotApiObject {
    private static final String LOCATION_FIELD = "location";
    private static final String TITLE_FIELD = "title";
    private static final String ADDRESS_FIELD = "address";
    private static final String FOURSQUARE_ID_FIELD = "foursquare_id";
    private static final String FOURSQUARE_TYPE_FIELD = "foursquare_type";

    /** Venue location */
    @JsonProperty(LOCATION_FIELD)
    private Location location;
    /** Name of the venue */
    @JsonProperty(TITLE_FIELD)
    private String title;
    /** Address of the venue */
    @JsonProperty(ADDRESS_FIELD)
    private String address;
    /** Optional. Foursquare identifier of the venue */
    @JsonProperty(FOURSQUARE_ID_FIELD)
    private String foursquareId;
    /** Optional. Foursquare type of the venue. */
    @JsonProperty(FOURSQUARE_TYPE_FIELD)
    private String foursquareType;

}
