package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents a video file.
 * @date 20 of June of 2015
 */
@Data
public class Video implements BotApiObject {

    private static final String FILE_ID_FIELD = "file_id";
    private static final String WIDTH_FIELD = "width";
    private static final String HEIGHT_FIELD = "height";
    private static final String DURATION_FIELD = "duration";
    private static final String THUMB_FIELD = "thumb";
    private static final String MIMETYPE_FIELD = "mime_type";
    private static final String FILESIZE_FIELD = "file_size";

    /** Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** Video width as defined by sender */
    @JsonProperty(WIDTH_FIELD)
    private Integer width;
    /** Video height as defined by sender */
    @JsonProperty(HEIGHT_FIELD)
    private Long height;
    /** Duration of the video in seconds as defined by sender */
    @JsonProperty(DURATION_FIELD)
    private Long duration;
    /** Video thumbnail */
    @JsonProperty(THUMB_FIELD)
    private PhotoSize thumb;
    /** Optional. Mime type of a file as defined by sender */
    @JsonProperty(MIMETYPE_FIELD)
    private String mimeType;
    /** Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;
}
