
package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *
 * This object represents a video message (available in Telegram apps as of v.4.0).
 */
@Data
public class VideoNote implements BotApiObject {
    private static final String FILE_ID_FIELD = "file_id";
    private static final String LENGTH_FIELD = "length";
    private static final String DURATION_FIELD = "duration";
    private static final String THUMB_FIELD = "thumb";
    private static final String FILESIZE_FIELD = "file_size";

    /** Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** Video width and height as defined by sender */
    @JsonProperty(LENGTH_FIELD)
    private Integer length;
    /** Duration of the video in seconds as defined by sender */
    @JsonProperty(DURATION_FIELD)
    private Long duration;
    /** Optional. Video thumbnail */
    @JsonProperty(THUMB_FIELD)
    private PhotoSize thumb;
    /** Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;

}
