package com.chuang.telegram.bot.model;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents a voice note
 * @date 16 of July of 2015
 */
@Data
public class Voice implements BotApiObject {
    private static final String FILE_ID_FIELD = "file_id";
    private static final String DURATION_FIELD = "duration";
    private static final String MIMETYPE_FIELD = "mime_type";
    private static final String FILESIZE_FIELD = "file_size";

    /** Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** Long	Duration of the audio in seconds as defined by sender */
    @JsonProperty(DURATION_FIELD)
    private Long duration;
    /** Optional. MIME type of the file as defined by sender */
    @JsonProperty(MIMETYPE_FIELD)
    private String mimeType;
    /** Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;

}
