package com.chuang.telegram.bot.model.games;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.chuang.telegram.bot.model.User;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents one row of a game high scores table
 * @date 25 of September of 2016
 */
@Data
public class GameHighScore implements BotApiObject {
    private static final String POSITION_FIELD = "position";
    private static final String USER_FIELD = "user";
    private static final String SCORE_FIELD = "score";

    /** Position in the game high score table */
    @JsonProperty(POSITION_FIELD)
    private Long position;
    /** User */
    @JsonProperty(USER_FIELD)
    private User user;
    /** Score */
    @JsonProperty(SCORE_FIELD)
    private Long score;

}
