package com.chuang.telegram.bot.model.passport;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

/**
 * @author Ruben Bermudez
 * @version 4.0.0
 * Contains information about Telegram Passport data shared with the bot by the user.
 */
@Data
public class PassportData implements BotApiObject {
    private static final String DATA_FIELD = "data";
    private static final String CREDENTIALS_FIELD = "credentials";

    /** Array with information about documents and other Telegram Passport data that was shared with the bot */
    @JsonProperty(DATA_FIELD)
    private List<EncryptedPassportElement> data;
    /** Array with information about documents and other Telegram Passport data shared with the bot. */
    @JsonProperty(CREDENTIALS_FIELD)
    private EncryptedCredentials credentials;

    public PassportData() {
    }

    public PassportData(List<EncryptedPassportElement> data, EncryptedCredentials credentials) {
        this.data = data;
        this.credentials = credentials;
    }

}
