package com.chuang.telegram.bot.model.passport;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 4.0.0
 * This object represents a file uploaded to Telegram Passport.
 * Currently all Telegram Passport files are in JPEG format when decrypted and don't exceed 10MB.
 */
@Data
public class PassportFile implements BotApiObject {
    private static final String FILE_ID_FIELD = "file_id";
    private static final String FILE_SIZE_FIELD = "file_size";
    private static final String FILE_DATE_FIELD = "file_date";

    /** Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** File size */
    @JsonProperty(FILE_SIZE_FIELD)
    private Long fileSize;
    /** Unix time when the file was uploaded */
    @JsonProperty(FILE_DATE_FIELD)
    private Long fileDate;

    public PassportFile() {
    }

    public PassportFile(String fileId, Long fileSize, Long fileDate) {
        this.fileId = fileId;
        this.fileSize = fileSize;
        this.fileDate = fileDate;
    }

}
