package com.chuang.telegram.bot.model.payment;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.chuang.telegram.bot.model.PhotoSize;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *
 * This object contains basic information about an invoice.
 */
@Data
public class Invoice implements BotApiObject {
    private static final String TITLE_FIELD = "title";
    private static final String DESCRIPTION_FIELD = "description";
    private static final String START_PARAMETER_FIELD = "start_parameter";
    private static final String CURRENCY_FIELD = "currency";
    private static final String TOTAL_AMOUNT_FIELD = "total_amount";
    private static final String PHOTO_FIELD = "photo";

    /** Product name */
    @JsonProperty(TITLE_FIELD)
    private String title;
    /** Product description */
    @JsonProperty(DESCRIPTION_FIELD)
    private String description;
    /** Unique bot deep-linking parameter for generation of this invoice */
    @JsonProperty(START_PARAMETER_FIELD)
    private String startParameter;
    /** Three-letter ISO 4217 currency code */
    @JsonProperty(CURRENCY_FIELD)
    private String currency;
    /**
     * Total price in the smallest units of the currency (Long, not float/double).
     * For example, for a price of US$ 1.45 pass amount = 145.
     */
    @JsonProperty(TOTAL_AMOUNT_FIELD)
    private Long totalAmount;
    /** Optional. Goods photo */
    @JsonProperty(PHOTO_FIELD)
    private PhotoSize photo;

}
