package com.chuang.telegram.bot.model.payment;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *
 * This object represents information about an order.
 */
@Data
public class OrderInfo implements BotApiObject {
    private static final String NAME_FIELD = "name";
    private static final String PHONE_NUMBER_FIELD = "phone_number";
    private static final String EMAIL_FIELD = "email";
    private static final String SHIPPING_ADDRESS_FIELD = "shipping_address";

    /** Optional. User name */
    @JsonProperty(NAME_FIELD)
    private String name;
    /** Optional. User's phone number */
    @JsonProperty(PHONE_NUMBER_FIELD)
    private String phoneNumber;
    /** Optional. User email */
    @JsonProperty(EMAIL_FIELD)
    private String email;
    /** Optional. First line for the address */
    @JsonProperty(SHIPPING_ADDRESS_FIELD)
    private ShippingAddress shippingAddress;

}
