package com.chuang.telegram.bot.model.payment;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *
 * 2-letter ISO 3166-1 alpha-2 country code
 */
@Data
public class ShippingAddress implements BotApiObject {
    private static final String COUNTRY_CODE_FIELD = "country_code";
    private static final String STATE_FIELD = "state";
    private static final String CITY_FIELD = "city";
    private static final String STREET_LINE1_FIELD = "street_line1";
    private static final String STREET_LINE2_FIELD = "street_line2";
    private static final String POST_CODE_FIELD = "post_code";

    /** Two-letter ISO 3166-1 alpha-2 country code */
    @JsonProperty(COUNTRY_CODE_FIELD)
    private String countryCode;
    /** State, if applicable */
    @JsonProperty(STATE_FIELD)
    private String state;
    /** City */
    @JsonProperty(CITY_FIELD)
    private String city;
    /** First line for the address */
    @JsonProperty(STREET_LINE1_FIELD)
    private String streetLine1;
    /** Second line for the address */
    @JsonProperty(STREET_LINE2_FIELD)
    private String streetLine2;
    /** Address post code */
    @JsonProperty(POST_CODE_FIELD)
    private String postCode;

}
