package com.chuang.telegram.bot.model.payment;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.chuang.telegram.bot.model.User;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 *
 * This object contains information about incoming shipping query.
 */
@Data
public class ShippingQuery implements BotApiObject {
    private static final String ID_FIELD = "id";
    private static final String FROM_FIELD = "from";
    private static final String INVOICE_PAYLOAD_FIELD = "invoice_payload";
    private static final String SHIPPING_ADDRESS_FIELD = "shipping_address";

    /** Unique query identifier */
    @JsonProperty(ID_FIELD)
    private String id;
    /** User who sent the query */
    @JsonProperty(FROM_FIELD)
    private User from;
    /** Bot specified invoice payload */
    @JsonProperty(INVOICE_PAYLOAD_FIELD)
    private String invoicePayload;
    /** User specified shipping address */
    @JsonProperty(SHIPPING_ADDRESS_FIELD)
    private ShippingAddress shippingAddress;

}
