
package com.chuang.telegram.bot.model.stickers;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.chuang.telegram.bot.model.PhotoSize;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * @brief This object represents a sticker.
 */
@Data
public class Sticker implements BotApiObject {

    private static final String FILE_ID_FIELD = "file_id";
    private static final String WIDTH_FIELD = "width";
    private static final String HEIGHT_FIELD = "height";
    private static final String THUMB_FIELD = "thumb";
    private static final String FILESIZE_FIELD = "file_size";
    private static final String EMOJI_FIELD = "emoji";
    private static final String SET_NAME_FIELD = "set_name";
    private static final String MASK_POSITION_FIELD = "mask_position";

    /** Unique identifier for this file */
    @JsonProperty(FILE_ID_FIELD)
    private String fileId;
    /** Sticker width */
    @JsonProperty(WIDTH_FIELD)
    private Integer width;
    /** Sticker height */
    @JsonProperty(HEIGHT_FIELD)
    private Integer height;
    /** Optional. Sticker thumbnail in .webp or .jpg format */
    @JsonProperty(THUMB_FIELD)
    private PhotoSize thumb;
    /** Optional. File size */
    @JsonProperty(FILESIZE_FIELD)
    private Long fileSize;
    /** Optional. Emoji associated with the sticker */
    @JsonProperty(EMOJI_FIELD)
    private String emoji;
    /** Optional. Name of the sticker set to which the sticker belongs */
    @JsonProperty(SET_NAME_FIELD)
    private String setName;
    /** Optional. For mask stickers, the position where the mask should be placed */
    @JsonProperty(MASK_POSITION_FIELD)
    private String maskPosition;

}
