package com.chuang.telegram.bot.model.stickers;

import com.chuang.telegram.bot.interfaces.BotApiObject;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

/**
 * @author Ruben Bermudez
 * @version 1.0
 * This object represents a sticker set.
 */
@Data
public class StickerSet implements BotApiObject {
    private static final String NAME_FIELD = "name";
    private static final String TITLE_FIELD = "title";
    private static final String CONTAINS_MASKS_FIELD = "contains_masks";
    private static final String STICKERS_FIELD = "stickers";

    @JsonProperty(NAME_FIELD)
    private String name;
    @JsonProperty(TITLE_FIELD)
    private String title;
    @JsonProperty(CONTAINS_MASKS_FIELD)
    private Boolean containsMasks;
    @JsonProperty(STICKERS_FIELD)
    private List<Sticker> stickers;

}
