package com.chuang.test.tgbot;

import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.name.Names;
import org.junit.jupiter.api.Test;

public class ApiContextTest {

    @Test
    public void testImpl() {
        Injector injector = Guice.createInjector(binder -> {
            binder.bind(Animal.class).annotatedWith(Names.named("Human")).to(Human.class);
            binder.bind(Animal.class).annotatedWith(AHuman.class).to(Human.class);
        });

        Shower shower = injector.getInstance(Shower.class);

        shower.show();
    }

    public static class Shower {

        private final Animal animal;

        @Inject
        public Shower(Animal animal) {
            this.animal = animal;
        }

        public void show() {
            animal.speak();
        }
    }

    public interface Animal {
        void speak();
    }

    public static class Human implements Animal {
        @Override
        public void speak() {
            System.out.println("i am a Human");
        }
    }

    public @interface AHuman {

    }
}
