package com.chuang.test.tgbot.sdk;

import com.chuang.telegram.bot.ApiContext;
import com.chuang.telegram.bot.configs.TelegramBotConfig;
import com.chuang.telegram.bot.interfaces.Sender;
import com.chuang.telegram.bot.interfaces.WebHookBots;
import com.chuang.telegram.bot.methods.AnswerCallbackQuery;
import com.chuang.telegram.bot.methods.GetMe;
import com.chuang.telegram.bot.methods.groupadmin.GetChatMemberCount;
import org.junit.jupiter.api.Test;

public class SdkTest {

    private final String BOT = "5250897653:AAFa4Rl7QZI1Hqe4mFKln-FltR6ae2S1wVo";
    private final String CHAT_ID = "-1001790810613";


    static {
        ApiContext.init();
        ApiContext.registerInstance(TelegramBotConfig.class, new TelegramBotConfig("https://api.telegram.org", "https://test.com"));
    }

    @Test
    public void testSendAlert() {
        Sender sender = ApiContext.getInstance(Sender.class);
        new AnswerCallbackQuery()
                .setCallbackQueryId("8848310066933370614")
                .setText("this is alert Test").send(sender, BOT).join();

    }

    @Test
    public void testPayment() {

    }


    @Test
    public void testGetMe() {
        Sender sender = ApiContext.getInstance(Sender.class);
        new GetMe().send(sender, BOT).thenAccept(System.out::println).join();
    }

    @Test
    public void testChatMemberCount() {
        Sender sender = ApiContext.getInstance(Sender.class);
        new GetChatMemberCount().setChatId(CHAT_ID).send(sender, BOT).thenAccept(System.out::println).join();
    }

    @Test
    public void testFlux() {
        WebHookBots bots = ApiContext.getInstance(WebHookBots.class);

        new Thread(() -> {
            while(true) {
                bots.fireKeyUpdate(BOT, null);
                sleep(2000);
            }
        }).start();

        bots.listen(BOT, "test", "/test", true, true);
        bots.asFlux().subscribe(hookUpdate -> {
            System.out.println(hookUpdate.getBot().getBotKey());
        });

        sleep(100000);
    }

    private void sleep(long time) {
        try {
            Thread.sleep(time);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
