package com.chuang.tauceti.tools.basic;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.chuang.tauceti.support.Result;
import com.chuang.tauceti.support.enums.Whether;

public class ResultKit {

    public static <T> Result<T> fromJSON(JSONObject json, Class<T> dataClass) {
        Whether whether = Whether.valueOf(json.getString("whether"));
        int code = json.getIntValue("code");
        String message = json.getString("message");

        T data = json.getObject("data", dataClass);

        return Result.create(whether, code, data, message);
    }

    public static <T> Result<T> fromJSON(String json, Class<T> dataClass) {
        return fromJSON(JSONObject.parseObject(json), dataClass);
    }

    public static <T> Result<T> fromJSON(String json, TypeReference<T> typeReference) {
        return fromJSON(JSONObject.parseObject(json), typeReference);
    }

    public static <T> Result<T> fromJSON(JSONObject json, TypeReference<T> typeReference) {
        Whether whether = Whether.valueOf(json.getString("whether"));
        int code = json.getIntValue("code");
        String message = json.getString("message");

        T data = json.getObject("data", typeReference);

        return Result.create(whether, code, data, message);
    }

}
