package com.chuang.tauceti.tools.basic.gui;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.concurrent.atomic.AtomicReference;
import java.util.function.Supplier;

public class ImageKit {


    public static void show(Image img) {

        JPanel panel = imagePanel(img);

        JFrame frame = new JFrame("图片展示");
        frame.setLayout(new BorderLayout());
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.setLocationRelativeTo(null);

        frame.add(panel, BorderLayout.CENTER);

        frame.setSize(panel.getWidth(), panel.getHeight());

        frame.setVisible(true);

    }

    public static void show(Supplier<Image> getter) {


        JFrame frame = new JFrame("图片展示");
        frame.setLayout(new BorderLayout());
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.setLocationRelativeTo(null);


        JButton touchBtn = new JButton("刷新");
        frame.add(touchBtn, BorderLayout.NORTH);

        AtomicReference<JPanel> imgPanelRef = new AtomicReference<>();

        Runnable action = () -> {
            if(imgPanelRef.get() != null) {
                frame.remove(imgPanelRef.get());
            }

            JPanel panel = imagePanel(getter.get());
            frame.add(panel, BorderLayout.CENTER);
            frame.setSize(panel.getWidth(), panel.getHeight());
            frame.repaint();
            imgPanelRef.set(panel);
        };

        touchBtn.addActionListener(e -> action.run());

        frame.setVisible(true);

        action.run();
    }

    public static JPanel imagePanel(Image img) {
        JPanel panel = new JPanel() {
            @Override
            public void paint(Graphics g) {
                super.paint(g);
                Color c = g.getColor();

                g.drawImage(img, 0, 0, getWidth(), getHeight(), this);

                g.setColor(c);
            }
        };
        panel.setSize(new Dimension(img.getWidth(panel), img.getHeight(panel)));
        panel.setPreferredSize(new Dimension(img.getWidth(panel), img.getHeight(panel)));

        return panel;
    }

    public static void main(String[] args) throws IOException {
        Image img = ImageIO.read(new File("d://qr-code-icon.png"));

        show(img);
    }
}
