### 模块端口
1. otc: 7000 - 7999
2. payment: 6000 - 6999
3. star-ring: 5000 - 5999


### 关于事务的注解
1. 不再手动注解 @EnableTransactionManager , springboot 自带 org.springframework.boot.autoconfigure.transaction.TransactionAutoConfiguration. 采用的aspectJ
2. 不建议将@Transactional 写在接口上，而应该写在实现类上。原因如下
   1. 写在接口上 aspectJ 和 动态代理 的代理模式将导致事务无效。
   2. 官方建议写在实现类上，Java中的注解是不会被继承的。所以官方也建议写在实现类上。
   3. 实际上，是否采用事务本身也是具体实现的细节，注解在实现类上也符合设计。当然，这更多是心理安慰。
3. 通过 `TransactionSynchronizationManager.getCurrentTransactionName()` 可以检测是否有事务

### 关于乐观锁
1. 乐观锁的原理是利用数据库where条件中使用的`总是最新版本的值`这个特性，通过每次进行更新加上版本号，并在更新时递增版本号的方式来避免跨版本更新。从而实现乐观锁。
2. 乐观锁的锁粒度：乐观锁的粒度是 查询对象  到 更新对象之间的部分才能确保被乐观锁影响。
3. 如果乐观锁没有产生效果，需要确认更新时 影响条数为 0 时是否有抛出异常。默认 RowQueryService 的 updateById 都会自动抛出乐观锁异常。
4. 乐观锁只针对 updateById 和 update(entity, wrapper); 但这里只建议使用 updateId 的乐观锁
5. 乐观锁更新失败后会直接报错给前台，有时候这样做可能不友好。可以使用 @NeedRetry 注解来确定是否要重试，重试几次。注意，这里强烈建议不要将 NeedRetry 用在 controller, task等入口处以外的地方。如：service，dao.
