package com.chuang.urras.admin;

import com.chuang.tauceti.spring.boots.task.EnableAsyncTaskPool;
import com.chuang.urras.admin.configuration.ShiroConfiguration;
import com.chuang.urras.admin.configuration.WebsocketBrokerConfigurer;
import com.chuang.urras.common.swagger.annotation.EnableUrrasSwagger2;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Import;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 *
 * EnableAsyncTaskPool: 线程池
 * EnableDiscoveryClient: 服务发现
 * RefreshScope: 动态刷新
 * @author ATH
 */
@Slf4j
@EnableScheduling
@EnableAsyncTaskPool
@EnableUrrasSwagger2
@Import({ShiroConfiguration.class, WebsocketBrokerConfigurer.class})
@SpringBootApplication(scanBasePackages = "com.chuang.urras.admin")
public class Application {

    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);
    }
}
