package com.chuang.urras.admin.configuration;

import com.chuang.tauceti.rbac2.rest.model.ShiroUser;
import com.chuang.tauceti.shiro.spring.web.jwt.AuthErrorMsg;
import com.chuang.tauceti.shiro.spring.web.jwt.ShiroUtils;
import com.chuang.tauceti.support.vg.OperatorManager;
import org.apache.shiro.authc.CredentialsException;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Optional;

@Configuration
public class ShiroConfiguration {
    @Bean
    public OperatorManager operatorManager() {
        return OperatorManager.createOpt(() -> {
            try {
                Optional<ShiroUser> user = ShiroUtils.loggedUser();

                return user.map(ShiroUser::getUsername);
            } catch (Exception e) {
                return Optional.empty();
            }
        });
    }

    @Bean
    public AuthErrorMsg authErrorMsg() {
        return error -> {
            if(error instanceof CredentialsException) {
                return "认证错误";
            } else {
                return error.getMessage();
            }
        };
    }

}
