import { Inject, Injectable, Injector } from '@angular/core';
import { Router } from '@angular/router';
import { DA_SERVICE_TOKEN, ITokenService } from '@delon/auth';
import { _HttpClient, Menu } from '@delon/theme';
import { Observable } from 'rxjs';
import {map, tap} from 'rxjs/operators';

@Injectable({
  providedIn: 'root',
})
export class UserMenuService {
  constructor(private httpClient: _HttpClient) {}

  all(): Observable<Menu[]> {
    return this.httpClient.get('/api/sys/menu/all').pipe(map(value => value.data));
  }

  fastAll(): Observable<string[]> {
    return this.httpClient.get('/api/sys/menu/fast/all').pipe(map(value => value.data));
  }

  settingFast(fast: string[]): Observable<boolean> {
    return this.httpClient.post('/api/sys/menu/fast/setting', fast).pipe(map(value => value.data));
  }
}
