import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class ArticleService {
  constructor(private http: _HttpClient) {}

  /**
   * 统计
   */
  public statistics(): Observable<Array<{ one: string; two: number }>> {
    return this.http.get('/api/star-ring/article/statistics');
  }

  public publish(num: number, domains: string[]): Observable<boolean> {
    return this.http.post('/api/star-ring/article/batch-publish', { number: num, domains });
  }
}
