import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class DomainProposalService {
  constructor(private http: _HttpClient) {}

  public lock(id: number): Observable<any> {
    return this.http.post(`/api/star-ring/seo-domain-proposal/lock/${id}`);
  }

  public audit(id: number, pass: boolean, remark: string): Observable<any> {
    return this.http.post('/api/star-ring/seo-domain-proposal/audit', { id, pass, remark });
  }

  public changeTmp(ids: number[], selectedGroupId: number): Observable<any> {
    return this.http.post(`/api/star-ring/seo-domain-proposal/change-template/${selectedGroupId}`, { ids });
  }

  public offline(id: number): Observable<any> {
    return this.http.post(`/api/star-ring/seo-domain-proposal/offline/${id}`);
  }

  public batchPass(ids: any[]): Observable<any> {
    return this.http.post('/api/star-ring/seo-domain-proposal/audit/batch', { ids, pass: true, remark: 'batch-audit' });
  }
}
