import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class DownloadTaskService {
  constructor(private http: _HttpClient) {}

  public download(id: number): Observable<any> {
    return this.http.post(`/api/star-ring/download-task/download/${id}`, '');
  }

  public check(website: string): Observable<any> {
    return this.http.post(`/api/star-ring/download-task/check`, `website=${website}`);
  }

  public random(website: string): Observable<any> {
    return this.http.post(`/api/star-ring/download-task/random`, `website=${website}`);
  }

  public downloadFor(website: string, failOnly: boolean): Observable<any> {
    return this.http.post(`/api/star-ring/download-task/download${failOnly ? '/fail' : '/suc'}/${website}`, ``);
  }

  public downloadNohave(website: string): Observable<any> {
    return this.http.post(`/api/star-ring/download-task/download/nohave/${website}`);
  }
}
