import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

@Injectable({
  providedIn: 'root'
})
export class SpiderPlatformService {
  constructor(private http: _HttpClient) {}

  public cookies(): Observable<any[]> {
    return this.http.get('/api/star-ring/platform-cookie/all').pipe(map(value => value as any[]));
  }

  public submit(cookieId: string, dms: string): Observable<string[]> {
    return this.http.post(`/api/star-ring/platform-check-content/submit/${cookieId}`, dms);
  }

  public submitByContentId(ids: number[]): Observable<string> {
    return this.http.post('/api/star-ring/platform-check-content/submit/by-id', { ids });
  }

  public push(ids: number[]): Observable<any> {
    return this.http.post('/api/star-ring/platform-check-content/push/links', { ids });
  }

  public pushSitemap(ids: number[]): Observable<any> {
    return this.http.post('/api/star-ring/platform-check-content/push/sitemap', { ids });
  }
}
