import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class TargetDomainService {
  constructor(private http: _HttpClient) {}

  public useXinhuan(id: number): Observable<boolean> {
    return this.http.post(`/api/star-ring/target-domain/use/xinhuan/${id}`, ``);
  }

  public add(urls: string[], xinghuan: boolean): Observable<any> {
    return this.http.post('/api/star-ring/target-domain/add/batch', { urls, xinHuanOnly: xinghuan });
  }

  public spider(urls: string[]): Observable<any> {
    return this.http.post('/api/star-ring/target-domain/add/spider', urls);
  }

  public order(urls: string[]): Observable<any> {
    return this.http.post('/api/star-ring/target-domain/add/order', urls);
  }
}
