import { Injectable } from '@angular/core';
import { _HttpClient } from '@delon/theme';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class TemplateService {
  constructor(private http: _HttpClient) {}

  public audit(id: number, like: boolean, remark: string): Observable<any> {
    return this.http.post('/api/star-ring/seo-template/audit', { id, like, remark });
  }

  /**
   */
  public group(ids: number[], groupId: number): Observable<any> {
    return this.http.post('/api/star-ring/seo-template/group', { ids, groupId });
  }

  /**
   */
  public reFetch(id: number): Observable<any> {
    return this.http.post(`/api/star-ring/seo-template/re-fetch/${id}`, '');
  }

  public reFetchPage(id: number, page: string): Observable<any> {
    return this.http.post(`/api/star-ring/seo-template/re-fetch/${page}/${id}`, '');
  }

  public hidden(id: number): Observable<any> {
    return this.http.post(`/api/star-ring/seo-template/hidden/${id}`, '');
  }
}
