import { Component, Inject, OnInit } from '@angular/core';
import { DA_SERVICE_TOKEN, ITokenService } from '@delon/auth';
import {environment} from "@env/environment";

@Component({
  selector: 'layout-passport',
  templateUrl: './passport.component.html',
  styleUrls: ['./passport.component.less']
})
export class LayoutPassportComponent implements OnInit {
  links = [
    {
      title: '帮助',
      href: ''
    },
    {
      title: '隐私',
      href: ''
    },
    {
      title: '条款',
      href: ''
    }
  ];

  name = 'Star Ring';
  description = '没有骚话';

  constructor(@Inject(DA_SERVICE_TOKEN) private tokenService: ITokenService) {
    this.name = environment['name'];
    this.description = environment['description'];
  }

  ngOnInit(): void {
    this.tokenService.clear();
  }
}
