import {Component, Input, OnInit} from '@angular/core';
import {SFSchema} from '@delon/form';
import {NzModalRef} from 'ng-zorro-antd/modal';
import {ScheduleStatus} from "@shared";

@Component({
  selector: 'app-view-scheduler',
  templateUrl: './view.component.html',
})
export class SchedulerViewComponent implements OnInit {

  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      jobName: {type: 'string', title: '任务名称', readOnly: true},
      jobGroup: {type: 'string', title: '分组名称', readOnly: true},
      jobClass: {type: 'string', title: '任务类全名', readOnly: true},
      cron: {type: 'string', title: 'Cron表达式', readOnly: true},
      description: {type: 'string', title: '任务描述', readOnly: true},
      params: {type: 'string', title: '执行参数', readOnly: true},
      // 所有未知的复杂类型都当作枚举处理
      state: {
        type: 'string',
        title: '任务状态',
        enum: ScheduleStatus,
        readOnly: true,
        ui: {placeholder: '任务状态', widget: 'select'}
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: {span: 24}
    }
  };

  constructor(
    private modal: NzModalRef
  ) {
  }

  ngOnInit(): void {

  }

  close(): void {
    this.modal.destroy();
  }
}
