import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { ACME_ORDER_STATUS } from '../../seo.enums';

@Component({
  selector: 'app-view-acme-order',
  templateUrl: './view.component.html',
})
export class AcmeOrderViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      account: { type: 'string', title: 'acme账号', readOnly: true },
      // 所有未知的复杂类型都当作枚举处理
      status: {
        type: 'string',
        title: '状态',
        enum: ACME_ORDER_STATUS,
        readOnly: true,
        ui: { placeholder: '状态', widget: 'select' },
      },
      provider: { type: 'string', title: 'acme提供者', readOnly: true },
      orderReference: { type: 'string', title: '订单(可以用域名)', readOnly: true },
      domain: { type: 'string', title: '顶级域名', readOnly: true },
      sec: { type: 'string', title: '二级域名', readOnly: true },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
