import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-view-domain-fetch-log',
  templateUrl: './view.component.html',
})
export class DomainFetchLogViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      domain: {
        type: 'string',
        title: '域名',
        readOnly: true,
      },
      times: { type: 'number', title: '抓取次数', readOnly: true },
      logDate: {
        type: 'string',
        title: '更新时间',
        format: 'date-time',
        readOnly: true,
      },
      internal: {
        type: 'boolean',
        title: '内部网站',
        enum: [
          { label: '是', value: true },
          { label: '否', value: false },
        ],
        default: true,
        readOnly: true,
        ui: { placeholder: '是否启用', widget: 'select' },
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
