import { Component, Input, OnInit } from '@angular/core';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { SFSchema } from '@delon/form';
import { TASK_STATUS } from '../../seo.enums';

@Component({
  selector: 'app-view-download-task',
  templateUrl: './view.component.html',
})
export class DownloadTaskViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      website: {
        type: 'string',
        title: '资源站点',
        readOnly: true,
      },
      url: {
        type: 'string',
        title: '资源url',
        readOnly: true,
      },
      savePath: {
        type: 'string',
        title: '资源保存地址',
        readOnly: true,
      },
      // 所有未知的复杂类型都当作枚举处理
      state: {
        type: 'array',
        title: '状态',
        enum: TASK_STATUS,
        default: 0,
        readOnly: true,
        ui: { placeholder: '状态', widget: 'select' },
      },
      error: {
        type: 'string',
        title: '错误',
        readOnly: true,
      },
      failTimes: { type: 'number', title: '下载错误次数', readOnly: true },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close() {
    this.modal.destroy();
  }
}
