import { Component, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { _HttpClient } from '@delon/theme';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-create-exempt-domain',
  templateUrl: './create.component.html',
})
export class ExemptDomainCreateComponent implements OnInit {
  rolePrefix = 'exempt-domain:';

  // test : {
  //   type: 'string',
  //   title: '测试',
  //   pattern: '^\\w+$',
  //   ui: {
  //     widget: 'string',
  //     placeholder: '唯一标识,不可重复,由字母,下划线,数字组合',
  //     errors: {
  //       pattern: '仅支持输入字母、下划线、数字'
  //     }
  //   }
  // },

  schema: SFSchema = {
    properties: {
      domain: { type: 'string', title: '豁免域名' },
    },
    required: ['domain'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(
    private modal: NzModalRef,
    private msgSrv: NzMessageService,

    public http: _HttpClient,
  ) {}

  ngOnInit(): void {}

  save(value: any): void {
    this.http.post(`/api/star-ring/exempt-domain/create`, value).subscribe((res) => {
      this.msgSrv.success('添加成功');
      this.modal.close(res);
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
