import { Component, Input, OnInit } from '@angular/core';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { SFSchema } from '@delon/form';

@Component({
  selector: 'app-view-js-group',
  templateUrl: './view.component.html',
})
export class JsGroupViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      js: {
        type: 'string',
        title: 'js',
        readOnly: true,
        ui: {
          widget: 'string',
        },
      },
      name: {
        type: 'string',
        title: '名称',
        readOnly: true,
        ui: {
          widget: 'string',
        },
      },
      gamePlatform: {
        type: 'string',
        title: '平台',
        readOnly: true,
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close() {
    this.modal.destroy();
  }
}
