import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { _HttpClient } from '@delon/theme';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { PAGE_TYPE } from '../../seo.enums';

@Component({
  selector: 'app-edit-sentence-article',
  templateUrl: './edit.component.html',
})
export class SentenceArticleEditComponent implements OnInit {
  rolePrefix = 'sentence-article:';

  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      domain: { type: 'string', title: '域名' },
      title: { type: 'string', title: '标题' },
      page: { type: 'string', title: '页面类型', enum: PAGE_TYPE, ui: { placeholder: '页面类型', widget: 'select' } },
    },
    required: ['domain', 'title', 'page'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(
    private modal: NzModalRef,
    private msgSrv: NzMessageService,

    public http: _HttpClient,
  ) {}

  ngOnInit(): void {}

  save(value: any): void {
    this.http.post(`/api/star-ring/sentence-article/update`, value).subscribe((res) => {
      this.msgSrv.success('修改成功');
      this.modal.close(res);
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
