import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { PAGE_TYPE, TASK_STATUS } from '../../seo.enums';

@Component({
  selector: 'app-view-sentence-article',
  templateUrl: './view.component.html',
})
export class SentenceArticleViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      domain: { type: 'string', title: '域名', readOnly: true },
      title: { type: 'string', title: '标题', readOnly: true },
      page: { type: 'string', title: '页面类型', enum: PAGE_TYPE, readOnly: true, ui: { placeholder: '页面类型', widget: 'select' } },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
