import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-view-sentence',
  templateUrl: './view.component.html',
})
export class SentenceViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      sentence: { type: 'string', title: '句子', readOnly: true },
      md5: { type: 'string', title: 'md5', readOnly: true },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
