import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { _HttpClient } from '@delon/theme';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-edit-server',
  templateUrl: './edit.component.html',
})
export class ServerEditComponent implements OnInit {
  rolePrefix = 'server:';

  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      serverName: { type: 'string', title: '服务器名称' },
      serverIp: { type: 'string', title: '服务器ip' },
      intranetIp: { type: 'string', title: '内网ip' },
      sshPort: { type: 'string', title: 'ssh端口' },
      serverUser: { type: 'string', title: '服务器用户' },
      serverPass: { type: 'string', title: '服务器密码' },
    },
    required: ['serverName', 'serverIp', 'serverUser', 'serverPass', 'intranetIp', 'sshPort'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(
    private modal: NzModalRef,
    private msgSrv: NzMessageService,

    public http: _HttpClient,
  ) {}

  ngOnInit(): void {}

  save(value: any): void {
    this.http.post(`/api/star-ring/server/update`, value).subscribe((res) => {
      this.msgSrv.success('修改成功');
      this.modal.close(res);
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
