import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-view-server',
  templateUrl: './view.component.html',
})
export class ServerViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      serverName: { type: 'string', title: '服务器名称', readOnly: true },
      serverIp: { type: 'string', title: '服务器ip', readOnly: true },
      serverUser: { type: 'string', title: '服务器用户', readOnly: true },
      serverPass: { type: 'string', title: '服务器密码', readOnly: true },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
