import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { _HttpClient } from '@delon/theme';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-edit-spider-log',
  templateUrl: './edit.component.html',
})
export class SpiderLogEditComponent implements OnInit {
  rolePrefix = 'spiderLog:';

  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      baidu: { type: 'number', title: '百度蜘蛛个数' },
      haosou: { type: 'number', title: '360蜘蛛' },
      sogou: { type: 'number', title: '搜狗' },
      yisou: { type: 'number', title: '易搜' },
      other: { type: 'number', title: '其他' },
      logDate: {
        type: 'string',
        title: '日期',
        format: 'date-time',
      },
    },
    required: ['baidu', 'haosou', 'sogou', 'yisou', 'other', 'log_date'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(
    private modal: NzModalRef,
    private msgSrv: NzMessageService,

    public http: _HttpClient,
  ) {}

  ngOnInit(): void {}

  save(value: any) {
    this.http.post(`/api/star-ring/spider/log/update`, value).subscribe((res) => {
      this.msgSrv.success('修改成功');
      this.modal.close(res);
    });
  }

  close() {
    this.modal.destroy();
  }
}
