import { Component, Input, OnInit } from '@angular/core';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { SFSchema } from '@delon/form';

@Component({
  selector: 'app-view-spider-log',
  templateUrl: './view.component.html',
})
export class SpiderLogViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      baidu: { type: 'number', title: '百度蜘蛛个数', readOnly: true },
      haosou: { type: 'number', title: '360蜘蛛', readOnly: true },
      sogou: { type: 'number', title: '搜狗', readOnly: true },
      yisou: { type: 'number', title: '易搜', readOnly: true },
      other: { type: 'number', title: '其他', readOnly: true },
      logDate: {
        type: 'string',
        title: '日期',
        format: 'date-time',
        readOnly: true,
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close() {
    this.modal.destroy();
  }
}
