import { Component, Input, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-view-sprocket',
  templateUrl: './view.component.html',
})
export class SprocketViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      domain: { type: 'string', title: '域名', readOnly: true },
      targetDomain: { type: 'string', title: '跳转域名', readOnly: true },
      ring: {
        type: 'boolean',
        title: '是否为链轮',
        enum: [
          { label: '是', value: true },
          { label: '否', value: false },
        ],
        default: true,
        readOnly: true,
        ui: { placeholder: '是否启用', widget: 'select' },
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
