import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { AcmeAccountComponent } from './acme-account/acme-account.component';
import { AcmeOrderComponent } from './acme-order/acme-order.component';
import { ArticleComponent } from './article/article.component';
import { DomainFetchLogComponent } from './domain-fetch-log/domain-fetch-log.component';
import { DownloadTaskComponent } from './download-task/download-task.component';
import { ExemptDomainComponent } from './exempt-domain/exempt-domain.component';
import { JsGroupComponent } from './js-group/js-group.component';
import { PlatformCheckContentComponent } from './platform-check-content/platform-check-content.component';
import { PlatformCookieComponent } from './platform-cookie/platform-cookie.component';
import { SentenceArticleComponent } from './sentence-article/sentence-article.component';
import { SentenceComponent } from './sentence/sentence.component';
import { SeoDomainProposalComponent } from './seo-domain-proposal/seo-domain-proposal.component';
import { SeoDomainComponent } from './seo-domain/seo-domain.component';
import { SeoTemplateComponent } from './seo-template/seo-template.component';
import { TitleComponent } from './title/title.component';
import { ServerComponent } from './server/server.component';
import { SpiderLogComponent } from './spider-log/spider-log.component';
import { SprocketComponent } from './sprocket/sprocket.component';
import { TargetDomainComponent } from './target-domain/target-domain.component';
import { TemplateGroupComponent } from './template-group/template-group.component';
import { TemplateUploadUserComponent } from './template-upload-user/template-upload-user.component';

const routes: Routes = [
  { path: 'article', component: ArticleComponent },
  { path: 'domain/fetch-log', component: DomainFetchLogComponent },
  { path: 'domain/target', component: TargetDomainComponent },
  { path: 'download-task', component: DownloadTaskComponent },
  { path: 'js-group', component: JsGroupComponent },
  { path: 'platform/check-content', component: PlatformCheckContentComponent },
  { path: 'platform/cookie', component: PlatformCookieComponent },
  { path: 'seo/domain', component: SeoDomainComponent },
  { path: 'seo/domain/proposal', component: SeoDomainProposalComponent },
  { path: 'seo/template', component: SeoTemplateComponent },
  { path: 'seo/template-group', component: TemplateGroupComponent },
  { path: 'seo/template/upload-user', component: TemplateUploadUserComponent },
  { path: 'spider-log', component: SpiderLogComponent },
  { path: 'acme/account', component: AcmeAccountComponent },
  { path: 'acme/order', component: AcmeOrderComponent },
  { path: 'seo/title', component: TitleComponent },
  { path: 'seo/sentence', component: SentenceComponent },
  { path: 'seo/sentence-article', component: SentenceArticleComponent },
  { path: 'seo/server', component: ServerComponent },
  { path: 'sprocket', component: SprocketComponent },
  { path: 'exempt', component: ExemptDomainComponent }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class StarRingRoutingModule {}
