import { ScrollingModule } from '@angular/cdk/scrolling';
import { NgModule, Type } from '@angular/core';
import { IconDefinition } from '@ant-design/icons-angular';
import { SharedModule } from '@shared';
import { NzIconModule } from 'ng-zorro-antd/icon';

import { AcmeAccountComponent } from './acme-account/acme-account.component';
import { AcmeAccountCreateComponent } from './acme-account/modal/create.component';
import { AcmeAccountViewComponent } from './acme-account/modal/view.component';
import { AcmeOrderComponent } from './acme-order/acme-order.component';
import { AcmeOrderBatchCreateComponent } from './acme-order/modal/batch-create.component';
import { AcmeOrderCreateComponent } from './acme-order/modal/create.component';
import { AcmeOrderEditComponent } from './acme-order/modal/edit.component';
import { AcmeOrderViewComponent } from './acme-order/modal/view.component';
import { ArticleComponent } from './article/article.component';
import { ArticleEditComponent } from './article/modal/edit.component';
import { ArticleViewComponent } from './article/modal/view.component';
import { DomainFetchLogComponent } from './domain-fetch-log/domain-fetch-log.component';
import { DomainFetchLogEditComponent } from './domain-fetch-log/modal/edit.component';
import { DomainFetchLogViewComponent } from './domain-fetch-log/modal/view.component';
import { DownloadTaskComponent } from './download-task/download-task.component';
import { DownloadTaskCreateComponent } from './download-task/modal/create.component';
import { DownloadTaskEditComponent } from './download-task/modal/edit.component';
import { DownloadTaskViewComponent } from './download-task/modal/view.component';
import { ExemptDomainComponent } from './exempt-domain/exempt-domain.component';
import { ExemptDomainCreateComponent } from './exempt-domain/modal/create.component';
import { ExemptDomainEditComponent } from './exempt-domain/modal/edit.component';
import { ExemptDomainViewComponent } from './exempt-domain/modal/view.component';
import { JsGroupComponent } from './js-group/js-group.component';
import { JsGroupCreateComponent } from './js-group/modal/create.component';
import { JsGroupEditComponent } from './js-group/modal/edit.component';
import { JsGroupViewComponent } from './js-group/modal/view.component';
import { PlatformCheckContentCreateComponent } from './platform-check-content/modal/create.component';
import { PlatformCheckContentEditComponent } from './platform-check-content/modal/edit.component';
import { PlatformCheckContentViewComponent } from './platform-check-content/modal/view.component';
import { PlatformCheckContentComponent } from './platform-check-content/platform-check-content.component';
import { PlatformCookieCreateComponent } from './platform-cookie/modal/create.component';
import { PlatformCookieEditComponent } from './platform-cookie/modal/edit.component';
import { PlatformCookieViewComponent } from './platform-cookie/modal/view.component';
import { PlatformCookieComponent } from './platform-cookie/platform-cookie.component';
import { SentenceArticleCreateComponent } from './sentence-article/modal/create.component';
import { SentenceArticleEditComponent } from './sentence-article/modal/edit.component';
import { SentenceArticleViewComponent } from './sentence-article/modal/view.component';
import { SentenceArticleComponent } from './sentence-article/sentence-article.component';
import { SentenceCreateComponent } from './sentence/modal/create.component';
import { SentenceEditComponent } from './sentence/modal/edit.component';
import { SentenceViewComponent } from './sentence/modal/view.component';
import { SentenceComponent } from './sentence/sentence.component';
import { SeoDomainProposalEditComponent } from './seo-domain-proposal/modal/edit.component';
import { SeoDomainProposalViewComponent } from './seo-domain-proposal/modal/view.component';
import { SeoDomainProposalComponent } from './seo-domain-proposal/seo-domain-proposal.component';
import { SeoDomainEditComponent } from './seo-domain/modal/edit.component';
import { SeoDomainViewComponent } from './seo-domain/modal/view.component';
import { SeoDomainComponent } from './seo-domain/seo-domain.component';
import { SeoTemplateEditComponent } from './seo-template/modal/edit.component';
import { SeoTemplateViewComponent } from './seo-template/modal/view.component';
import { SeoTemplateComponent } from './seo-template/seo-template.component';
import { ServerCreateComponent } from './server/modal/create.component';
import { ServerEditComponent } from './server/modal/edit.component';
import { ServerViewComponent } from './server/modal/view.component';
import { ServerComponent } from './server/server.component';
import { SpiderLogCreateComponent } from './spider-log/modal/create.component';
import { SpiderLogEditComponent } from './spider-log/modal/edit.component';
import { SpiderLogViewComponent } from './spider-log/modal/view.component';
import { SpiderLogComponent } from './spider-log/spider-log.component';
import { SprocketCreateComponent } from './sprocket/modal/create.component';
import { SprocketEditComponent } from './sprocket/modal/edit.component';
import { SprocketViewComponent } from './sprocket/modal/view.component';
import { SprocketComponent } from './sprocket/sprocket.component';
import { StarRingRoutingModule } from './star-ring-routing.module';
import { TargetDomainCreateComponent } from './target-domain/modal/create.component';
import { TargetDomainViewComponent } from './target-domain/modal/view.component';
import { TargetDomainComponent } from './target-domain/target-domain.component';
import { TemplateGroupCreateComponent } from './template-group/modal/create.component';
import { TemplateGroupEditComponent } from './template-group/modal/edit.component';
import { TemplateGroupViewComponent } from './template-group/modal/view.component';
import { TemplateGroupComponent } from './template-group/template-group.component';
import { TemplateUploadUserCreateComponent } from './template-upload-user/modal/create.component';
import { TemplateUploadUserEditComponent } from './template-upload-user/modal/edit.component';
import { TemplateUploadUserViewComponent } from './template-upload-user/modal/view.component';
import { TemplateUploadUserComponent } from './template-upload-user/template-upload-user.component';
import { TitleCreateComponent } from './title/modal/create.component';
import { TitleEditComponent } from './title/modal/edit.component';
import { TitleViewComponent } from './title/modal/view.component';
import { TitleComponent } from './title/title.component';

const icons: IconDefinition[] = [];

const COMPONENTS: Array<Type<void>> = [
  ArticleComponent,
  DomainFetchLogComponent,
  DownloadTaskComponent,
  JsGroupComponent,
  PlatformCheckContentComponent,
  PlatformCookieComponent,
  SeoDomainComponent,
  SeoDomainProposalComponent,
  SeoTemplateComponent,
  SpiderLogComponent,
  TargetDomainComponent,
  TemplateGroupComponent,
  TemplateUploadUserComponent,
  AcmeAccountComponent,
  AcmeOrderComponent,
  SentenceComponent,
  SentenceArticleComponent,
  TitleComponent,
  ServerComponent,
  SprocketComponent,
  ExemptDomainComponent
];

const COMPONENTS_NOROUNT: Array<Type<void>> = [
  ArticleViewComponent,
  ArticleEditComponent,

  DomainFetchLogEditComponent,
  DomainFetchLogViewComponent,

  DownloadTaskCreateComponent,
  DownloadTaskEditComponent,
  DownloadTaskViewComponent,

  JsGroupCreateComponent,
  JsGroupEditComponent,
  JsGroupViewComponent,

  PlatformCheckContentCreateComponent,
  PlatformCheckContentEditComponent,
  PlatformCheckContentViewComponent,

  PlatformCookieCreateComponent,
  PlatformCookieEditComponent,
  PlatformCookieViewComponent,

  SeoDomainProposalEditComponent,
  SeoDomainProposalViewComponent,

  SeoTemplateEditComponent,
  SeoTemplateViewComponent,

  SpiderLogCreateComponent,
  SpiderLogEditComponent,
  SpiderLogViewComponent,

  TargetDomainCreateComponent,
  TargetDomainViewComponent,

  TemplateGroupCreateComponent,
  TemplateGroupEditComponent,
  TemplateGroupViewComponent,

  TemplateUploadUserCreateComponent,
  TemplateUploadUserEditComponent,
  TemplateUploadUserViewComponent,

  SeoDomainEditComponent,
  SeoDomainViewComponent,

  AcmeAccountCreateComponent,
  AcmeAccountViewComponent,

  AcmeOrderCreateComponent,
  AcmeOrderEditComponent,
  AcmeOrderViewComponent,
  AcmeOrderBatchCreateComponent,

  SentenceCreateComponent,
  SentenceEditComponent,
  SentenceViewComponent,

  SentenceArticleCreateComponent,
  SentenceArticleEditComponent,
  SentenceArticleViewComponent,

  TitleCreateComponent,
  TitleEditComponent,
  TitleViewComponent,

  ServerCreateComponent,
  ServerEditComponent,
  ServerViewComponent,

  SprocketCreateComponent,
  SprocketEditComponent,
  SprocketViewComponent,

  ExemptDomainEditComponent,
  ExemptDomainCreateComponent,
  ExemptDomainViewComponent
];

@NgModule({
  imports: [SharedModule, StarRingRoutingModule, NzIconModule.forRoot(icons), ScrollingModule],
  declarations: [...COMPONENTS, ...COMPONENTS_NOROUNT],
  entryComponents: COMPONENTS_NOROUNT
})
export class StarRingModule {}
