import { Component, Input, OnInit } from '@angular/core';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { SFSchema } from '@delon/form';

@Component({
  selector: 'app-view-target-domain',
  templateUrl: './view.component.html',
})
export class TargetDomainViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      targetDomain: {
        type: 'string',
        title: '目标站',
        pattern: '^\\w+$',
        readOnly: true,
        ui: {
          widget: 'string',
        },
      },
      xinhuan: {
        type: 'boolean',
        title: '星环特有',
        enum: [
          { label: '是', value: true },
          { label: '否', value: false },
        ],
        default: true,
        readOnly: true,
        ui: { placeholder: '是否启用', widget: 'select' },
      },
      used: {
        type: 'boolean',
        title: '是否使用',
        enum: [
          { label: '是', value: true },
          { label: '否', value: false },
        ],
        default: true,
        readOnly: true,
        ui: { placeholder: '是否启用', widget: 'select' },
      },
      usedBy: {
        type: 'string',
        title: '使用人',
        pattern: '^\\w+$',
        readOnly: true,
        ui: {
          widget: 'string',
        },
      },
      usedTime: {
        type: 'string',
        title: '使用时间',
        format: 'date-time',
        readOnly: true,
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close() {
    this.modal.destroy();
  }
}
