import { Component, Input, OnInit } from '@angular/core';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { SFSchema } from '@delon/form';

@Component({
  selector: 'app-view-template-group',
  templateUrl: './view.component.html',
})
export class TemplateGroupViewComponent implements OnInit {
  @Input()
  record: any;

  schema: SFSchema = {
    properties: {
      group: {
        type: 'string',
        title: '组名',
        readOnly: true,
      },
      remark: {
        type: 'string',
        title: '备注',
        readOnly: true,
        ui: {
          widget: 'textarea',
          autosize: { minRows: 2, maxRows: 10 },
          placeholder: '添加描述',
        },
      },
    },
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(private modal: NzModalRef) {}

  ngOnInit(): void {}

  close(): void {
    this.modal.destroy();
  }
}
