import { Component, OnInit } from '@angular/core';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { _HttpClient } from '@delon/theme';
import { SFSchema } from '@delon/form';

@Component({
  selector: 'app-create-template-upload-user',
  templateUrl: './create.component.html',
})
export class TemplateUploadUserCreateComponent implements OnInit {
  rolePrefix = 'template-upload-user:';

  schema: SFSchema = {
    properties: {
      username: {
        type: 'string',
        title: '账号',
      },
      password: {
        type: 'string',
        title: '密码',
      },
    },
    required: ['username', 'password'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 },
    },
  };

  constructor(
    private modal: NzModalRef,
    private msgSrv: NzMessageService,

    public http: _HttpClient,
  ) {}

  ngOnInit(): void {}

  save(value: any): void {
    this.http.post(`/api/star-ring/template-upload-user/create`, value).subscribe((res) => {
      this.msgSrv.success('添加成功');
      this.modal.close(res);
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
