import { Component, OnInit } from '@angular/core';
import { SFSchema } from '@delon/form';
import { _HttpClient } from '@delon/theme';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';

@Component({
  selector: 'app-create-title',
  templateUrl: './create.component.html',
})
export class TitleCreateComponent implements OnInit {
  rolePrefix = 'title:';

  schema: SFSchema = {
    properties: {
      title: { type: 'string', title: 'title' },
    },
    required: ['title'],
    ui: {
      spanLabelFixed: 100,
      grid: { span: 24 }
    }
  };

  constructor(private modal: NzModalRef, private msgSrv: NzMessageService, public http: _HttpClient) {}

  ngOnInit(): void {}

  save(value: any): void {
    this.http.post(`/api/star-ring/title/create`, value).subscribe(res => {
      this.msgSrv.success('添加成功');
      this.modal.close(res);
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
