import {NzSafeAny} from "ng-zorro-antd/core/types";

export interface SvrEnum {
  label: string;
  value: string;
  css: string;

  [key: string]: NzSafeAny;
}

export const BetRecordStatus: SvrEnum[] = [
  { label: '已创建', value: 'CREATED', css: 'box-non' },
  { label: '投注失败', value: 'BET_FAIL', css: 'box-red' },
  { label: '已结算', value: 'SETTLED', css: 'box-green' },
];

export const CustomerAmtChgType: SvrEnum[] = [
  { label: '商户转用户(+)', value: 'FROM_MERCHANT', css: 'box-green' },
  { label: '投注中奖(+)', value: 'BET_REWARD', css: 'box-green' },
  { label: '提案加额(+)', value: 'PROPOSAL_PLUS', css: 'box-green' },
  { label: '夺宝成盘(+)', value: 'TREASURE_SUCCESS', css: 'box-green' },

  { label: '用户转商户(-)', value: 'TO_MERCHANT', css: 'box-red' },
  { label: '投注(-)', value: 'BET', css: 'box-red' },
  { label: '提案减额(-)', value: 'PROPOSAL_SUB', css: 'box-red' },
  { label: '夺宝开盘(-)', value: 'TREASURE_DEPOSIT', css: 'box-red' },
];

export const MerchantAmtChgType: SvrEnum[] = [
  { label: '从用户转入(+)', value: 'FROM_CUSTOMER', css: 'box-green' },
  { label: '提案加额(+)', value: 'PROPOSAL_PLUS', css: 'box-green' },
  { label: '转出到用户(-)', value: 'TO_CUSTOMER', css: 'box-red' },
  { label: '提案减额(-)', value: 'PROPOSAL_SUB', css: 'box-red' },
];

export const CustomerAmtChgProposalStatus: SvrEnum[] = [
  { label: '已接受', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'PASSED', css: 'box-green' },
  { label: '已拒绝', value: 'REJECTED', css: 'box-red' },
];

export const MoraType: SvrEnum[] = [
  { label: '通吃', value: 'TAKE_ALL', css: 'box-red' },
  { label: '石头', value: 'HAMMER', css: '' },
  { label: '剪刀', value: 'SCISSORS', css: '' },
  { label: '布', value: 'CLOTH', css: '' },
];

export const GameResult: SvrEnum[] = [
  { label: '未结算', value: 'NONE', css: '' },
  { label: '平局', value: 'DRAW', css: 'box-yellow' },
  { label: '赢', value: 'WIN', css: 'box-green' },
  { label: '输', value: 'LOSE', css: 'box-red' },
];

export const ValidAdvice: SvrEnum[] = [
  { label: '未知', value: 'UNKNOWN', css: 'box-yellow' },
  { label: '有效', value: 'VALID', css: 'box-green' },
  { label: '无效', value: 'INVALID', css: 'box-red' },
];

export const ContractType: SvrEnum[] = [
  { label: 'TRC20', value: 'TRC20', css: '' },
  { label: 'TRC10', value: 'TRC10', css: '' },
];

export const CrashFreeProposalStatus: SvrEnum[] = [
  { label: '已接受', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'PASSED', css: 'box-green' },
  { label: '已拒绝', value: 'REJECTED', css: 'box-red' },
];

export const MerchantAmtChgProposalStatus: SvrEnum[] = [
  { label: '已接受', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'PASSED', css: 'box-green' },
  { label: '已拒绝', value: 'REJECTED', css: 'box-red' },
];

export const AmtChgProposalStatus: SvrEnum[] = [
  { label: '已接受', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'PASSED', css: 'box-green' },
  { label: '已拒绝', value: 'REJECTED', css: 'box-red' },
];

export const GamblerApplyProposalStatus: SvrEnum[] = [
  { label: '已接受', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'PASSED', css: 'box-green' },
  { label: '已拒绝', value: 'REJECTED', css: 'box-red' },
];

export const FomoTicketType: SvrEnum[] = [
  {label: '紫金券', value: 'PURPLE_GOLD', css: 'box-purple'},
  {label: '黄金券', value: 'YELLOW_GOLD', css: 'box-yellow'},
];

export const FomoTicketOrigin: SvrEnum[] = [
  {label: '下线洗码', value: 'INVITE', css: 'box-none'},
  {label: '洗码', value: 'BET', css: 'box-none'},
  {label: '手动添加', value: 'MANUAL', css: 'box-yellow'},
];


export const CustomerStatus: SvrEnum[] = [
  { label: '正常', value: 'NORMAL', css: 'box-non' },
  { label: '禁用', value: 'DISABLED', css: 'box-red' },
];

export const PRODUCT: SvrEnum[] = [
  { label: 'HX1', value: 'HX1', css: 'box-non' }
];


export const QUOTA_TYPE: SvrEnum[] = [
  { label: '发币', value: 'ISSUE_COINS', css: 'box-non' },
  { label: '存款', value: 'DEPOSIT', css: 'box-non' },
  { label: '取款', value: 'WITHDRAW', css: 'box-non' },
  { label: '质押', value: 'PLEDGED', css: 'box-non' },
  { label: '解除质押', value: 'REDEEMED', css: 'box-non' },
  { label: '管理系统添加', value: 'OFFICE_ADMIN', css: 'box-non' },
  { label: '生成TOKEN', value: 'GEN_TOKEN', css: 'box-non' },
  { label: '取款失败退款', value: 'WITHDRAW_FAILURE', css: 'box-yellow'},
  { label: 'Swap', value: 'SWAP', css: 'box-non'},
  { label: 'VIP1', value: 'VIP1', css: 'box-non'},
  { label: '赌王活动', value: 'GAMBLER', css: 'box-non'}

];


export const SETTLED_STATUS: SvrEnum[] = [
  { label: '未结算', value: 'UNSETTLEMENT', css: 'box-green' },
  { label: '已结算', value: 'SETTLED', css: 'box-red' },
];


export const DIVIDEND_STATUS: SvrEnum[] = [
  { label: '未领取', value: 'RETRIEVABLE', css: 'box-red' },
  { label: '已领取', value: 'RECEIVED', css: 'box-green' },
];


export const INJECT_METHOD: SvrEnum[] = [
  { label: '增加', value: 'ADD', css: 'box-green' },
  { label: '减去', value: 'SUBTRACT', css: 'box-red' },
];

export const INJECT_TYPE: SvrEnum[] = [
  { label: '系统管理员添加', value: 'SYSTEM', css: 'box-none' },
  { label: '每日注入固定额度', value: 'INJECT_FIXED', css: 'box-none' },
  { label: '投注额产出', value: 'INJECT_BET_REBATE', css: 'box-none' },
  { label: '日投注额注入', value: 'DAILY_BET_INJECT', css: 'box-none' }
];


export const TRANSACTION_TYPE: SvrEnum[] = [
  { label: '转入', value: 'IN', css: 'box-green' },
  { label: '转出', value: 'OUT', css: 'box-red' },
];

export const AltcoinProposalStatus: SvrEnum[] = [
  { label: '未通过', value: 'REJECTED', css: 'box-non' },
  { label: '待审核', value: 'PENDING', css: 'box-yellow' },
  { label: '已通过', value: 'APPROVED', css: 'box-green' },
  { label: '以失败', value: 'EXPIRED', css: 'box-red' }
];

export const AltcoinType: SvrEnum[] = [
  {label: '质押', value: 'PLEDGED', css: 'box-green'},
  {label: '赎回', value: 'REDEEMED', css: 'box-red'}
];

export const PledgeType: SvrEnum[] = [
  {label: '质押', value: 'PLEDGED', css: 'box-green'},
  {label: '赎回', value: 'REDEEMED', css: 'box-red'}
];

export const PledgeStatus: SvrEnum[] = [
  {label: '质押中', value: 'LOCKED', css: 'box-green'},
  {label: '系统释放', value: 'SYS_RELEASE', css: 'box-non'},
  {label: '自己释放', value: 'SELF_RELEASE', css: 'box-non'}
];

export const GameType: SvrEnum[] = [
  {label: '合约类', value: 'CONTRACT', css: 'box-non'},
  {label: '哈希链', value: 'HASH_CHAIN', css: 'box-non'},
  {label: '随机哈希', value: 'RANDOM_HASH', css: 'box-non'},
];

export const ClientTechnology: SvrEnum[] = [
  {label: 'PC', value: 'PC', css: 'box-non'},
  {label: 'H5', value: 'H5', css: 'box-non'},
  { label: 'APP', value: 'APP', css: 'box-non' },
  { label: 'FLUSH', value: 'FLUSH', css: 'box-non' },
];

export const GameCategory: SvrEnum[] = [
  { label: '骰子', value: 'SLOT', css: 'box-non' },
  { label: '风靡', value: 'POPULAR', css: 'box-non' },
  { label: 'House', value: 'HOUSE_GAME', css: 'box-non' },
];


export const CallbackStatus: SvrEnum[] = [
  { label: '没回调', value: 'NO_CALLBACK', css: 'box-non' },
  { label: '回调中', value: 'IN_CALLBACK', css: 'box-yellow' },
  { label: '回调成功', value: 'CALLBACK_SUCCESS', css: 'box-green' },
  { label: '回调失败', value: 'CALLBACK_FAIL', css: 'box-red' },
];

export const GameStatus: SvrEnum[] = [
  { label: '上线', value: 'ONLINE', css: 'box-green' },
  { label: '开发中', value: 'DEV', css: 'box-yellow' },
  { label: '下线', value: 'OFFLINE', css: 'box-red' },
];

export const MerchantStatus: SvrEnum[] = [
  { label: '启用', value: 'ENABLED', css: 'box-green' },
  { label: '禁用', value: 'DISABLED', css: 'box-red' },
];

export const ScheduleStatus: SvrEnum[] = [
  { label: '正常', value: 'NORMAL', css: 'box-green' },
  { label: '暂停', value: 'PAUSE', css: 'box-red' },
];

export const TreasureStatus: SvrEnum[] = [
  { label: '已创建', value: 'CREATED', css: 'box-yellow' },
  { label: '流盘', value: 'STREAMING', css: 'box-red' },
  { label: '成盘', value: 'REWARD', css: 'box-green' },
];

export const TreasureUserStatus: SvrEnum[] = [
  { label: '真实数据', value: 'CREATED', css: 'box-green' },
  { label: '假数据', value: 'STREAMING', css: 'box-yellow' },
];

export const BlockChainToken: SvrEnum[] = [
  { label: 'J9币安代币', value: 'J9BC_BSC', css: '' },
  { label: 'BNB币安代币', value: 'BNB_BSC', css: '' },
  { label: 'DOGE币安代币', value: 'DOGE_BSC', css: '' },
  { label: 'LTC币安代币', value: 'LTC_BSC', css: '' },
  { label: 'SHIB币安代币', value: 'SHIB_BSC', css: '' },
  { label: 'AXS币安代币', value: 'AXS_BSC', css: '' },
  { label: 'LUNA以太坊代币', value: 'LUNA_ERC', css: '' },
  { label: 'USDT币安代币', value: 'USDT_BSC', css: '' },
];

export const TradePairChangeType: SvrEnum[] = [
  { label: '添加流动性', value: 'LIQUIDITY_ADD', css: 'box-green', in: true },
  { label: '交易增加', value: 'TRANSACTION_ADD', css: 'box-green', in: true },
  { label: '收回流动性', value: 'LIQUIDITY_TAKE_BACK', css: 'box-red', in: false },
  { label: '交易减少', value: 'TRANSACTION_SUB', css: 'box-red', in: false },
];


export const BlockChainProtocol: SvrEnum[] = [
  { label: 'ERC20', value: 'ERC20', css: 'box-green' },
  { label: 'TRC20', value: 'TRC20', css: 'box-blue' },
  { label: 'BEP20', value: 'BEP20', css: 'box-yellow' }
];

export const DepositDealStatus: SvrEnum[] = [
  { label: '等待', value: 'PENDING', css: 'box-yellow' },
  { label: '成功', value: 'SUCCESS', css: 'box-green' }
];

export const Currency: SvrEnum[] = [
  { label: 'J9BC', value: 'J9BC', css: 'box-yellow' },
  { label: 'USDT', value: 'USDT', css: 'box-green' },

  { label: 'BNB', value: 'BNB', css: 'box-yellow' },
  { label: 'DOGE', value: 'DOGE', css: 'box-green' },
  { label: 'LTC', value: 'LTC', css: 'box-yellow' },
  { label: 'SHIB', value: 'SHIB', css: 'box-green' },
  { label: 'AXS', value: 'AXS', css: 'box-yellow' },
  { label: 'LUNA', value: 'LUNA', css: 'box-green' },
];

export const CustomerWalletChangeType: SvrEnum[] = [
  { label: 'Swap交易增加(+)', value: 'SWAP_ADD', css: 'box-green' },
  { label: 'Swap交易减少(-)', value: 'SWAP_MINUS', css: 'box-red' },
  { label: '接收商户额度(+)', value: 'RECEIPT_FROM_MERCHANT', css: 'box-green' },
  { label: '转给商户(-)', value: 'TRANSFER_TO_MERCHANT', css: 'box-red' },
  { label: '赎回J9BC(+)', value: 'REDEEMED_J9BC', css: 'box-green' },
  { label: '质押J9BC(-)', value: 'PLEDGE_J9BC', css: 'box-red' },
  { label: '分红奖励(+)', value: 'RECEIPT_DIVIDEND', css: 'box-green' },
  { label: '活动加额(+)', value: 'VIP1_ADD', css: 'box-green'},
  { label: '活动减额(-)', value: 'VIP1_MINUS', css: 'box-red'},
  { label: '直接存款(+)', value: 'DEPOSIT', css: 'box-green'},
  { label: '直接取款(-)', value: 'WITHDRAW', css: 'box-red'},
  { label: '赌王活动(+)', value: 'GAMBLER', css: 'box-green'},
  { label: '取款失败(-)', value: 'WITHDRAW_FAILURE', css: 'box-red'},
  { label: '生成token(+)', value: 'GEN_TOKEN', css: 'box-green'},
  { label: '手续费(-)', value: 'FEE', css: 'box-red'},
  { label: '提案添加(+)', value: 'PROPOSAL_ADD', css: 'box-green'},
  { label: '提案减少(-)', value: 'PROPOSAL_MINUS', css: 'box-red'},
  { label: '未知加款(+)', value: 'UNKNOWN_ADD', css: 'box-green'},
  { label: '未知减款(-)', value: 'UNKNOWN_MINUS', css: 'box-red'}
];


export const JackpotStatus: SvrEnum[] = [
  { label: '未结算', value: 'UNSETTLEMENT', css: 'box-yellow' },
  { label: '已结算', value: 'SETTLED', css: 'box-green' },
];

export const MerchantWalletChangeType: SvrEnum[] = [
  { label: '从用户转入(+)', value: 'FROM_CUSTOMER', css: 'box-green' },
  { label: '提案加额(+)', value: 'PROPOSAL_PLUS', css: 'box-green' },
  { label: '转出到用户(-)', value: 'TO_CUSTOMER', css: 'box-red' },
  { label: '提案减额(-)', value: 'PROPOSAL_SUB', css: 'box-red' },
];

export const PaybackType: SvrEnum[] = [
  { label: '手动', value: 'MANUAL', css: 'box-yellow' },
  { label: '自动', value: 'AUTOMATIC', css: 'box-green' },
];

export const RISK_CONTROL: SvrEnum[] = [
  {label: '风控拒绝', value: 'RISK_CONTROL_REJECT', css: 'box-red'},
  {label: '风控状态', value: 'RISK_CONTROL', css: 'box-yellow'},
  {label: '等待', value: 'PENDING', css: 'box-none'},
  {label: '失败', value: 'FAILURE', css: 'box-red'},
  {label: '成功', value: 'SUCCESS', css: 'box-green'}
];

export const ExperienceStatus: SvrEnum[] = [
  {label: '未解锁', value: '0', css: 'box-yellow'},
  {label: '已解锁', value: '1', css: 'box-green'}
];

export const GreylistStatus: SvrEnum[] = [
  {label: '待审核', value: 'PENDING', css: 'box-yellow'},
  {label: '已通过', value: 'PASSED', css: 'box-green'},
  {label: '已拒绝', value: 'REJECTED', css: 'box-red'}
];

export const GreylistType: SvrEnum[] = [
  {label: '分红排行榜', value: 'DIVIDEND_RANK', css: 'box-none'}
];

export function boolVal(b: boolean): string {
  if(typeof b !== 'boolean') {
    return '';
  }
  return b ? '是' : '否';
}
export function boolCss(b: boolean): string {
  if(typeof b !== 'boolean') {
    return '';
  }
  return b ? 'box-green' : 'box-red';
}

export function label(arr: SvrEnum[], value: string): string {
  return fieldValue(arr, value, 'label', '');
}

export function fieldValue(arr: SvrEnum[], value: string, field: string, defaultFieldValue: any) {
  for (const item of arr) {
    // tslint:disable-next-line:triple-equals
    if (item.value == value) {
      return item[field];
    }
  }
  return defaultFieldValue;
}

export function css(arr: SvrEnum[], value: string): string {
  for (const item of arr) {
    // tslint:disable-next-line:triple-equals
    if (item.value == value) {
      return item.css;
    }
  }
  return '';
}
