/*
 *    Copyright (c) 2018-2025, lengleng All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: lengleng (wangiegie@gmail.com)
 */
package com.chuang.urras.common.crud.properties;

import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.boot.context.properties.ConfigurationProperties;

import java.util.ArrayList;
import java.util.List;

/**
 * SwaggerProperties
 *
 * @author lengleng
 * @date 2018/7/25 14:00
 */
@Data
@ConfigurationProperties("spring.urras.crud")
public class CrudProperties {

	private Reference reference = new Reference();

	private String encryptKey = "";

	@Data
	@NoArgsConstructor
	public static class Reference {

		/**
		 * work-id
		 **/
		private Long workId = 0L;

		/**
		 * data-center-id
		 **/
		private Long dataCenterId = 0L;

	}

}
