package com.chuang.urras.common.task;

import lombok.extern.slf4j.Slf4j;
import org.quartz.InterruptableJob;
import org.quartz.JobExecutionContext;
import org.springframework.stereotype.Component;

/**
 * @author Ives.l
 * @since 2021/11/29 9:26
 */
@Component
@Slf4j
public class TestJob implements InterruptableJob {

	private boolean interrupted = false;

	@Override
	public void interrupt() {
		interrupted = true;
	}

	@Override
	public void execute(JobExecutionContext context) {
		if (interrupted) {
			return;
		}
		// 业务逻辑 ...
		log.info("------执行###############" + context.getTrigger());

	}
}
