package com.chuang.urras.common.task.model;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.common.task.enums.SchedulerStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 调度任务信息表
 * </p>
 *
 * @author Ives.L
 * @since 2021-12-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_scheduler")
public class Scheduler implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * ID
	 */
	@TableId(value = "ID")
	private Long id;

	/**
	 * 任务名称
	 */
	@TableField("JOB_NAME")
	private String jobName;

	/**
	 * 分组名称
	 */
	@TableField("JOB_GROUP")
	private String jobGroup;

	/**
	 * 任务类全名
	 */
	@TableField("JOB_CLASS")
	private String jobClass;

	/**
	 * Cron表达式
	 */
	@TableField("CRON")
	private String cron;

	/**
	 * 开始时间
	 */
	@TableField("START_TIME")
	private LocalDateTime startTime;

	/**
	 * 结束时间
	 */
	@TableField("END_TIME")
	private LocalDateTime endTime;

	/**
	 * 任务描述
	 */
	@TableField("DESCRIPTION")
	private String description;

	/**
	 * 任务执行参数
	 */
	@TableField("PARAMS")
	private String params;

	/**
	 * 任务状态
	 */
	@TableField("STATE")
	private SchedulerStatus state;

	/**
	 * 创建人
	 */
	@TableField(value = "CREATOR", fill = FieldFill.INSERT)
	private String creator;

	/**
	 * 创建时间
	 */
	@TableField(value = "CREATED_TIME", fill = FieldFill.INSERT)
	private LocalDateTime createdTime;

	/**
	 * 更新人
	 */
	@TableField(value = "UPDATER", fill = FieldFill.INSERT_UPDATE)
	private String updater;

	/**
	 * 更新时间
	 */
	@TableField(value = "UPDATED_TIME", fill = FieldFill.INSERT_UPDATE)
	private LocalDateTime updatedTime;


}
