package com.chuang.urras.common.task.model.ro;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

/**
 * @author Ives.l
 * @since 2021/11/26 17:12
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@ApiModel(value = "返回结果任务VO")
public class QuartzJobRO implements Serializable {
	private static final long serialVersionUID = 2405038359807918022L;

	@ApiModelProperty(value = "任务名称")
	private String jobName;

	@ApiModelProperty(value = "任务组名称")
	private String jobGroup;

	@ApiModelProperty(value = "任务类的全路径名")
	private String jobClass;

	@ApiModelProperty(value = "cron表达式")
	private String cronExpression;

	@ApiModelProperty(value = "触发器状态")
	private String jobStatus;

	@ApiModelProperty(value = "触发器有效开始时间")
	private Date startAt;

	@ApiModelProperty(value = "触发器有效结束时间")
	private Date endAt;

	@ApiModelProperty(value = "任务描述")
	private String description;

	@ApiModelProperty(value = "上一次触发时间")
	private Date prevTime;

	@ApiModelProperty(value = "下一次触发时间")
	private Date nextTime;

	@ApiModelProperty(value = "执行任务的指定参数", example = "{param1:'123',param2:'456'}")
	private Map<String, Object> jobDataMap;
}
