package com.chuang.urras.common.task.model.ro;

import com.chuang.urras.common.task.enums.SchedulerStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 调度任务信息表
 * </p>
 *
 * @author Ives.L
 * @since 2021-12-09
 */
@Data
@EqualsAndHashCode
@Accessors(chain = true)
@ApiModel(value = "SchedulerRO对象", description = "调度任务信息表")
public class SchedulerRO implements Serializable {

	@ApiModelProperty(value = "ID")
	private Long id;
	@ApiModelProperty(value = "任务名称")
	private String jobName;
	@ApiModelProperty(value = "分组名称")
	private String jobGroup;
	@ApiModelProperty(value = "任务类全名")
	private String jobClass;
	@ApiModelProperty(value = "Cron表达式")
	private String cron;
	@ApiModelProperty(value = "开始时间")
	private LocalDateTime startTime;
	@ApiModelProperty(value = "结束时间")
	private LocalDateTime endTime;
	@ApiModelProperty(value = "任务描述")
	private String description;
	@ApiModelProperty(value = "任务执行参数")
	private String params;
	@ApiModelProperty(value = "任务状态")
	private SchedulerStatus state;
	@ApiModelProperty(value = "创建人")
	private String creator;
	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createdTime;
	@ApiModelProperty(value = "更新人")
	private String updater;
	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updatedTime;
}
