package com.chuang.urras.common.task.model.uo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * @author Ives.l
 * @since 2021/11/26 15:25
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel(value = "立马执行、暂停、恢复、中断任务VO")
public class QuartzJobStatusUO implements Serializable {
	private static final long serialVersionUID = -3834827117887331700L;

	@ApiModelProperty(value = "任务名称", required = true, example = "TestJob")
	@NotBlank(message = "任务名字不能为空")
	private String jobName;

	@ApiModelProperty(value = "任务组名称", required = true, example = "U06")
	@NotBlank(message = "任务组名称不能为空")
	private String jobGroup;

	@ApiModelProperty(value = "状态", required = true)
	@NotBlank(message = "状态不能为空")
	private JobStateEnum jobState;

	@ApiModelProperty(value = "执行任务的指定参数", example = "{param1:'123',param2:'456'}")
	private String jobDataMap;

	public enum JobStateEnum {
		/**
		 * 运行
		 */
		RUN(1),
		/**
		 * 暂停
		 */
		PAUSE(2),
		/**
		 * 恢复
		 */
		RESUME(3),
		/**
		 * 中止
		 */
		INTERRUPT(4);

		private final Integer code;

		JobStateEnum(Integer code) {
			this.code = code;
		}

		public Integer getCode() {
			return code;
		}
	}

}
