package com.chuang.urras.common.task.model.uo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * @author Ives.l
 * @since 2021/11/26 15:19
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel(value = "修改cron表达式VO")
public class QuartzJobUO implements Serializable {

	private static final long serialVersionUID = -7369145721244563648L;

	@ApiModelProperty(value = "任务名称", required = true, example = "TestJob")
	@NotBlank(message = "任务名字不能为空")
	private String jobName;

	@ApiModelProperty(value = "任务组名称", required = true)
	@NotBlank(message = "任务组名称不能为空")
	private String jobGroup;

	@ApiModelProperty(value = "cron表达式", required = true, example = "0 0/5 * * * ?")
	@NotBlank(message = "cron表达式不能为空")
	private String cronExpression;

	@ApiModelProperty(value = "执行任务的指定参数", example = "{param1:'123',param2:'456'}")
	private String jobDataMap;

}
