package com.chuang.urras.common.task.model.uo;

import com.chuang.urras.common.task.enums.SchedulerStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 调度任务信息表
 * </p>
 *
 * @author Ives.L
 * @since 2021-12-09
 */
@Data
@EqualsAndHashCode
@Accessors(chain = true)
@ApiModel(value = "SchedulerUO对象", description = "调度任务信息表")
public class SchedulerUO implements Serializable {

	private static final long serialVersionUID = 709131802738960731L;

	public final static String JOB_PARAM = "jobParam";

	@ApiModelProperty(value = "ID")
	@NotNull(message = "ID不能为空")
	private Long id;

	@ApiModelProperty(value = "任务名称")
	@NotBlank(message = "任务名称不能为空")
	private String jobName;

	@ApiModelProperty(value = "分组名称")
	@NotBlank(message = "分组名称不能为空")
	private String jobGroup;

	@ApiModelProperty(value = "任务类全名")
	@NotBlank(message = "任务类全名不能为空")
	private String jobClass;

	@ApiModelProperty(value = "Cron表达式")
	@NotBlank(message = "Cron表达式不能为空")
	private String cron;

	@ApiModelProperty(value = "任务描述")
	private String description;

	@ApiModelProperty(value = "任务执行参数")
	private String params;

	@ApiModelProperty(value = "任务状态")
	private SchedulerStatus state;

}
