package com.chuang.urras.generator;

import com.chuang.tauceti.generator.GenType;

/**
 * 自定义代码生成类型。每个类型都是 GenType 的实现。
 * order越小越先执行,
 * tau-ceti 默认顺序为：
 * entity > mapper > service > serviceImpl > controller
 * 加入自定义实现后的顺序为：
 * entity > mapper > service > serviceImpl > SQL > ro > co > uo > controller > angularTs > angularHtml
 * @author ATH
 */
public interface CustomGenTypes {
    GenType SQL = GenType.parse("SQL", GenType.CONTROLLER.order() - 4);
    GenType RO = GenType.parse("ro", GenType.CONTROLLER.order() - 3);
    GenType CO = GenType.parse("co", GenType.CONTROLLER.order() - 2);
    GenType UO = GenType.parse("uo", GenType.CONTROLLER.order() - 1);
    GenType ANGULAR_TS = GenType.parse("angular-component-ts", GenType.CONTROLLER.order() + 1);
    GenType ANGULAR_HTML = GenType.parse("angular-component-html", GenType.CONTROLLER.order() + 2);
    GenType ANGULAR_CREATE_TS = GenType.parse("angular-create-component-ts", GenType.CONTROLLER.order() + 3);
    GenType ANGULAR_CREATE_HTML = GenType.parse("angular-create-component-html", GenType.CONTROLLER.order() + 4);
    GenType ANGULAR_EDIT_TS = GenType.parse("angular-edit-component-ts", GenType.CONTROLLER.order() + 5);
    GenType ANGULAR_EDIT_HTML = GenType.parse("angular-edit-component-html", GenType.CONTROLLER.order() + 6);
    GenType ANGULAR_VIEW_TS = GenType.parse("angular-view-component-ts", GenType.CONTROLLER.order() + 7);
    GenType ANGULAR_VIEW_HTML = GenType.parse("angular-view-component-html", GenType.CONTROLLER.order() + 8);
}
