package com.chuang.urras.generator;


import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.core.exceptions.MybatisPlusException;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.generator.config.po.TableFill;
import com.baomidou.mybatisplus.generator.engine.VelocityTemplateEngine;
import com.chuang.tauceti.generator.GenType;
import com.chuang.tauceti.generator.Generator;
import com.chuang.tauceti.generator.config.GenConfig;
import com.chuang.tauceti.generator.convert.MyOracleTypeConvert;

import java.util.Arrays;
import java.util.Scanner;

/**
 * 本机生成代码
 * 自定义的Generator重写 initGlobalMap(GenConfig config) 产生的变量通过 cfg.global 访问
 * 自定义的Generator重写 initTableMap(GenConfig config, TableInfo tableInfo) 产生的变量通过 cfg.table 访问
 * 自定义的Generator重写 initContext(GenConfig config, TableInfo info) 产生的变量通过 cfg.tableGen 访问
 * <p>
 * 假设有 a,b,c 3张表
 * cfg.global 全局，3张表的所有生成器都能使用 比如 a 表的controller 生成器创建的变量能在 所有表的所有模板中使用
 * cfg.table  是同一张表的生成器之间共享。  比如 a 表的 controller 生成器创建的变量能在 a表的 controller，service，等所有模板中使用
 * cfg.tableGen 同一张表的同一个生成器使用。  比如 a 表的 controller 生成器创建的变量只能在 controller模板中使用
 *
 * @author ATH
 */
public class LocalGenerator {

	static Scanner scanner = new Scanner(System.in);
	/**
	 * <p>
	 * 读取控制台内容
	 * </p>
	 */
	public static String scanner(String tip) {

		System.out.println("请输入" + tip + "：");
		if (scanner.hasNext()) {
			String ipt = scanner.next();
			if (StringUtils.isNotBlank(ipt)) {
				return ipt;
			}
		}
		throw new MybatisPlusException("请输入正确的" + tip + "！");
	}

	public static void main(String[] args) throws IllegalAccessException, InstantiationException,
			ClassNotFoundException {

		System.out.print("请输入模块[PAYMENT, OTC]:");
		String module = scanner.next().trim();


		if("OTC".equalsIgnoreCase(module)) {
			GenConst.CURREN = GenConst.OTC;
		} else if("PAYMENT".equalsIgnoreCase(module)) {
			GenConst.CURREN = GenConst.PAYMENT;
		} else {
			GenConst.CURREN = GenConst.OTC;
		}

		gen();
	}

	private static void gen() throws ClassNotFoundException, IllegalAccessException, InstantiationException {
		String[] tables = scanner("表名，多个英文逗号分割").split(",");

		GenConfig.create()
				.author("Ives.L")
				.jdbcDriver("oracle.jdbc.driver.OracleDriver")
				.jdbcUrl("jdbc:oracle:thin:@//10.139.208.205:1521/orcl.com")
				.jdbcUsername("db1_pg_lobby")
				.jdbcPassword("ZDJiNDliZT")
				.rootPackage(GenConst.CURREN.getCorePackage())
				// 相加XXXXEntity后缀,填入 %sEntity
				.nameConvert(GenType.ENTITY, "%s")
				//表前缀，生成的对象都会去掉前缀
				.tablePrefix("t_", "sys_", "o_", "p_")
				.includeTables(tables)
				// 添加枚举字段的类型转化，如果生成的表格字段正好在下面的所有配置中，则会将类型改为相应的枚举类型

				.global(globalConfig -> {
					globalConfig.setFileOverride(true);
				})
				.packageCfg(packageConfig -> {
//                    packageConfig.setController("controller");
				})
				.strategy(strategyConfig -> {
					strategyConfig.setVersionFieldName("revision");
					strategyConfig.setTableFillList(Arrays.asList(
							new TableFill("updater", FieldFill.INSERT_UPDATE),
							new TableFill("updated_time", FieldFill.INSERT_UPDATE),
							new TableFill("creator", FieldFill.INSERT),
							new TableFill("created_time", FieldFill.INSERT),
							new TableFill("deleted", FieldFill.INSERT),
							new TableFill("revision", FieldFill.INSERT)
					));
				})
				.dataSource(dataSourceConfig -> dataSourceConfig.setTypeConvert(MyOracleTypeConvert.INSTANCE))
				// 是否为单maven工程。
				.mvn(false)
				// 是否打印debug日志
				.debug()
				//寻找Generator实现类
				.lookup("com.chuang.urras.generator.impl", Generator.class)
//                .addImpl(new AngularComponentTs()) // 直接扫描实现，不用加。
				.templateEngine(new VelocityTemplateEngine())
				// 生成代码
				.gen();
	}
}
