package com.chuang.urras.generator.impl;

import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.chuang.tauceti.generator.config.GenConfig;
import com.chuang.tauceti.generator.impl.ControllerGen;
import com.chuang.tauceti.tools.basic.StringKit;
import com.chuang.urras.generator.GenConst;

import java.util.HashMap;
import java.util.Map;

/**
 * Controller类生成器
 * @author ATH
 */
public class Controller extends ControllerGen {

    @Override
    public String template() {
        return "/templates/java/controller.java.vm";
    }

    @Override
    public Map<String, Object> initTableMap(GenConfig config, TableInfo tableInfo) {
        Map<String, Object> context = new HashMap<>();
        String role = "";
        if(StringKit.isNotBlank(config.getPackageCfg().getModuleName())) {
            role += config.getPackageCfg().getModuleName() + ":";
        }

        String name = tableNameWithoutPrefix(config, tableInfo);
        String code = name.replaceAll("_", "-");

        context.put("rolePrefix", (role + code + ":").toLowerCase());
        context.put("controllerPkg", pkg(config, tableInfo));
        return context;
    }

    @Override
    public String outputFile(GenConfig config, TableInfo info) {
        return GenConst.CURREN.getAdminPath() + super.outputFile(config, info);
    }

    @Override
    public String pkg(GenConfig genConfig, TableInfo info) {
	    return GenConst.CURREN.getControllerPackage();
    }
}
