package com.chuang.urras.generator.impl.model;

import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.chuang.tauceti.generator.GenType;
import com.chuang.tauceti.generator.JavaGenerator;
import com.chuang.tauceti.generator.config.GenConfig;
import com.chuang.urras.generator.CustomGenTypes;
import com.chuang.urras.generator.GenConst;

import java.util.HashMap;
import java.util.Map;

/**
 * CO类 生成器
 * @author ATH
 */
public class CoGen implements JavaGenerator {
    @Override
    public String template() {
        return "/templates/java/co.java.vm";
    }

    @Override
    public GenType type() {
        return CustomGenTypes.CO;
    }

    @Override
    public Map<String, Object> initTableMap(GenConfig config, TableInfo tableInfo) {
        Map<String, Object> tableContext = new HashMap<>();

        tableContext.put("packageCo", pkg(config, tableInfo));
        tableContext.put("classNameCo", tableInfo.getEntityName() + "CO");
        return tableContext;
    }

    @Override
    public String outputFile(GenConfig config, TableInfo info) {
	    return GenConst.CURREN.getAdminPath() + "/" + this.pkg(config, info).replaceAll("\\.", "/") + "/" + info.getEntityName() + "CO.java";
    }

    @Override
    public String pkg(GenConfig genConfig, TableInfo info) {
	    return GenConst.CURREN.getCoPackage();
    }
}
