package com.chuang.urras.sr.admin.controller;


import com.chuang.urras.sr.core.acme.AcmeManager;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Slf4j
@RestController
public class AcmeController {

    @Resource private AcmeManager acme;

    @RequestMapping("/.well-known/acme-challenge/{token}")
    public String challenge(@PathVariable("token") String token) {
        log.info("token:===> " + token);
        return acme.getToken(token)
                .map(thumbprint -> {
                    String r = token + "." + thumbprint;
                    log.info("r  ===> " + r);
                    return r;
                })
                .orElse("token error");
    }

}
