package com.chuang.urras.sr.admin.controller;

import com.chuang.tauceti.rowquery.controller.basic.ICrudController;
import com.chuang.tauceti.support.Result;
import com.chuang.urras.sr.admin.model.co.ExemptDomainCO;
import com.chuang.urras.sr.admin.model.ro.ExemptDomainRO;
import com.chuang.urras.sr.admin.model.uo.ExemptDomainUO;
import com.chuang.urras.sr.core.entity.ExemptDomain;
import com.chuang.urras.sr.core.service.IExemptDomainService;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author chuang
 * @since 2021-09-18
 */
@RestController
@RequestMapping("/star-ring/exempt-domain")
public class ExemptDomainController implements ICrudController<ExemptDomainCO, ExemptDomainRO, ExemptDomainUO, ExemptDomain, IExemptDomainService> {

    @Resource private IExemptDomainService service;

    @PostMapping("/batch-create")
    public Result<Void> batchCreate(@RequestBody @ApiParam @Valid List<String> domains) {
        List<ExemptDomain> list =
                domains.stream().map(s -> new ExemptDomain().setDomain(s)).collect(Collectors.toList());

        service.saveBatch(list);
        return Result.success();
    }

    @Override
    public IExemptDomainService service() {
        return service;
    }

    @Override
    public String basePermission() {
        return "exempt-domain:";
    }

}

