package com.chuang.urras.sr.admin.controller;

import com.chuang.tauceti.rowquery.controller.basic.ICrudController;
import com.chuang.urras.sr.admin.model.co.PlatformCookieCO;
import com.chuang.urras.sr.admin.model.ro.PlatformCookieRO;
import com.chuang.urras.sr.admin.model.uo.PlatformCookieUO;
import com.chuang.urras.sr.core.entity.PlatformCookie;
import com.chuang.urras.sr.core.service.single.IPlatformCookieService;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@RestController
@RequestMapping("/star-ring/platform-cookie")
public class PlatformCookieController implements ICrudController<PlatformCookieCO, PlatformCookieRO, PlatformCookieUO, PlatformCookie, IPlatformCookieService> {

    @Resource private IPlatformCookieService service;

    @GetMapping("/all")
    @ApiOperation("根据RowQuery对象进行查询")
    public List<PlatformCookie> all() {
        return service.list();
    }

    @Override
    public IPlatformCookieService service() {
        return service;
    }

    @Override
    public String basePermission() {
        return "platform-cookie:";
    }

}

