package com.chuang.urras.sr.admin.controller;

import com.chuang.tauceti.rowquery.controller.basic.ICrudController;
import com.chuang.tauceti.support.Result;
import com.chuang.tauceti.tools.basic.reflect.ConvertKit;
import com.chuang.urras.sr.admin.model.co.TemplateGroupCO;
import com.chuang.urras.sr.admin.model.ro.TemplateGroupRO;
import com.chuang.urras.sr.admin.model.uo.TemplateGroupUO;
import com.chuang.urras.sr.core.entity.TemplateGroup;
import com.chuang.urras.sr.core.service.single.ITemplateGroupService;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@RestController
@RequestMapping("/star-ring/template-group")
public class TemplateGroupController implements ICrudController<TemplateGroupCO, TemplateGroupRO, TemplateGroupUO, TemplateGroup, ITemplateGroupService> {

    @Resource private ITemplateGroupService service;

    @GetMapping("/query/all")
    @ApiOperation("查找所有group")
    @RequiresPermissions(value = {"template-group:query", "seo-template:group"}, logical = Logical.OR)
    public Result<List<TemplateGroupRO>> all() {
        return Result.success(service.list()).map(tgs -> ConvertKit.toBeans(tgs, TemplateGroupRO::new));
    }

    @Override
    public ITemplateGroupService service() {
        return service;
    }

    @Override
    public String basePermission() {
        return "template-group:";
    }

}

