package com.chuang.urras.sr.admin.model.co;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * <p>
 * ACME账号
 * </p>
 *
 * @author chuang
 * @since 2021-05-29
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeAccountCO对象", description="ACME账号")
public class AcmeAccountCO implements Serializable {

    @ApiModelProperty(value = "ACME账号")
    @NotBlank(message = "ACME账号不能为空")
    private String account;

    @ApiModelProperty(value = "联系email")
    @NotBlank(message = "联系email不能为空")
    private String contactEmail;

    @ApiModelProperty(value = "备注说明")
    private String remark;

}
