package com.chuang.urras.sr.admin.model.co;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * <p>
 * Acme订单
 * </p>
 *
 * @author chuang
 * @since 2021-05-31
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeOrderCO对象", description="Acme订单")
public class AcmeOrderCO implements Serializable {

    @ApiModelProperty(value = "acme账号")
    @NotBlank(message = "acme账号不能为空")
    private String account;


    @ApiModelProperty(value = "订单(可以用域名)")
    @NotBlank(message = "订单(可以用域名)不能为空")
    private String orderReference;

    @ApiModelProperty(value = "顶级域名")
    @NotBlank(message = "顶级域名不能为空")
    private String domain;

    @ApiModelProperty(value = "二级域名")
    @NotBlank(message = "二级域名不能为空")
    private String sec;

}
