package com.chuang.urras.sr.admin.model.co;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDate;

/**
 * <p>
 * 蜘蛛爬行日志
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SpiderLogCO对象", description="蜘蛛爬行日志")
public class SpiderLogCO implements Serializable {

    @ApiModelProperty(value = "百度蜘蛛个数")
    @NotNull(message = "百度蜘蛛个数不能为空")
    private Integer baidu;

    @ApiModelProperty(value = "360蜘蛛")
    @NotNull(message = "360蜘蛛不能为空")
    private Integer haosou;

    @ApiModelProperty(value = "搜狗")
    @NotNull(message = "搜狗不能为空")
    private Integer sogou;

    @ApiModelProperty(value = "易搜")
    @NotNull(message = "易搜不能为空")
    private Integer yisou;

    @ApiModelProperty(value = "其他")
    @NotNull(message = "其他不能为空")
    private Integer other;

    @ApiModelProperty(value = "日期")
    @NotNull(message = "日期不能为空")
    private LocalDate logDate;

}
