package com.chuang.urras.sr.admin.model.co;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 目标站记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="TargetDomainCO对象", description="目标站记录")
public class TargetDomainCO implements Serializable {

    @ApiModelProperty(value = "目标站")
    @NotBlank(message = "目标站不能为空")
    private String targetDomain;

    @ApiModelProperty(value = "星环特有")
    @NotNull(message = "星环特有不能为空")
    private Boolean xinhuan;

    @ApiModelProperty(value = "是否使用")
    @NotNull(message = "是否使用不能为空")
    private Boolean used;

    @ApiModelProperty(value = "使用人")
    private String usedBy = "";

    @ApiModelProperty(value = "使用时间")
    private LocalDateTime usedTime;

}
