package com.chuang.urras.sr.admin.model.ro;

import com.chuang.tauceti.acme.v2.Account;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * ACME账号
 * </p>
 *
 * @author chuang
 * @since 2021-05-29
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeAccountRO对象", description="ACME账号")
public class AcmeAccountRO implements Serializable {

    private Integer id;
    @ApiModelProperty(value = "ACME账号")
    private String account;
    @ApiModelProperty(value = "初始化IP")
    private String initialIp;
    @ApiModelProperty(value = "状态")
    private Account.Status status;
    @ApiModelProperty(value = "location")
    private String location;
    @ApiModelProperty(value = "联系email")
    private String contactEmail;
    @ApiModelProperty(value = "备注说明")
    private String remark;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "更新人")
    private String updater;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty("acme provider")
    private String provider;
}
