package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.AcmeOrderStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * Acme订单
 * </p>
 *
 * @author chuang
 * @since 2021-05-31
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeOrderRO对象", description="Acme订单")
public class AcmeOrderRO implements Serializable {

    @ApiModelProperty(value = "ID")
    private Integer id;
    @ApiModelProperty(value = "acme账号")
    private String account;
    @ApiModelProperty(value = "状态")
    private AcmeOrderStatus status;
    @ApiModelProperty(value = "acme提供者")
    private String provider;
    @ApiModelProperty(value = "订单(可以用域名)")
    private String orderReference;
    @ApiModelProperty(value = "顶级域名")
    private String domain;
    @ApiModelProperty(value = "二级域名")
    private String sec;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "更新人")
    private String updater;
    @ApiModelProperty(value = "申请时的消息")
    private String applyMsg;
    @ApiModelProperty(value = "申请成功的时间")
    private LocalDateTime lastRenewTime;
}
