package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.DomainType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 文章表
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="ArticleRO对象", description="文章表")
public class ArticleRO implements Serializable {

    @ApiModelProperty(value = "id")
    private Integer id;
    @ApiModelProperty(value = "标题")
    private String title;
    @ApiModelProperty(value = "文章")
    private String article;
    @ApiModelProperty(value = "是否使用")
    private Boolean used;
    @ApiModelProperty(value = "md5")
    private String md5;
    @ApiModelProperty(value = "所属网站")
    private String owner;
    @ApiModelProperty(value = "是否为菜单")
    private Boolean menu;
    @ApiModelProperty(value = "类型")
    private DomainType type;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "更新人")
    private String updater;
}
