package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.TaskStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 下载任务
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="DownloadTaskRO对象", description="下载任务")
public class DownloadTaskRO implements Serializable {

    @ApiModelProperty(value = "id")
    private Integer id;
    @ApiModelProperty(value = "资源站点")
    private String website;
    @ApiModelProperty(value = "资源url")
    private String url;
    @ApiModelProperty(value = "资源保存地址")
    private String savePath;
    @ApiModelProperty(value = "状态")
    private TaskStatus state;
    @ApiModelProperty(value = "错误")
    private String error;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "更新人")
    private String updater;
    @ApiModelProperty(value = "下载错误次数")
    private Integer failTimes;
}
