package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.DomainType;
import com.chuang.urras.sr.core.enums.ProposalStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 网站提案
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SeoDomainProposalRO对象", description="网站提案")
public class SeoDomainProposalRO implements Serializable {

    private Integer id;
    private String reference;
    @ApiModelProperty(value = "域名")
    private String domain;
    @ApiModelProperty(value = "站点模板")
    private String templateWebsite;
    @ApiModelProperty(value = "title")
    private String title;
    @ApiModelProperty(value = "关键词列表")
    private String keywords;
    @ApiModelProperty(value = "list页面的title")
    private String listPageTitle;
    @ApiModelProperty(value = "其他菜单名，用逗号隔开")
    private String otherMenus;
    @ApiModelProperty(value = "主关键词")
    private String mainKey;
    @ApiModelProperty(value = "类型")
    private DomainType type;
    @ApiModelProperty(value = "网站描述")
    private String description;
    @ApiModelProperty(value = "状态")
    private ProposalStatus state;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "更新人")
    private String updater;
    @ApiModelProperty(value = "审核人")
    private String auditor;
    @ApiModelProperty(value = "审核时间")
    private LocalDateTime auditedTime;
    @ApiModelProperty(value = "审核备注")
    private String remark;
    @ApiModelProperty(value = "服务器标记")
    private String serverTag;
}
