package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.DomainType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.time.LocalTime;

/**
 * <p>
 * 网站记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SeoDomainRO对象", description="网站记录")
public class SeoDomainRO implements Serializable {

    private Integer id;
    @ApiModelProperty(value = "模板网址")
    private String templateWebsite;
    @ApiModelProperty(value = "网站域名")
    private String domain;
    @ApiModelProperty(value = "标题")
    private String title;
    @ApiModelProperty(value = "关键词列表")
    private String keywords;
    @ApiModelProperty(value = "菜单列表")
    private String menus;
    @ApiModelProperty(value = "主关键词")
    private String mainKey;
    @ApiModelProperty(value = "类型")
    private DomainType type;
    @ApiModelProperty(value = "网站说明")
    private String description;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "更新人")
    private String updater;
    @ApiModelProperty(value = "服务器标记")
    private String serverTag;
    @ApiModelProperty(value = "网页后缀")
    private String suffix;
    @ApiModelProperty(value = "目录")
    private String dir;
    @ApiModelProperty(value = "句子目录")
    private String sentenceDir;

    @ApiModelProperty(value = "每天最多更新多少篇")
    private Integer dailyArticle;
    @ApiModelProperty(value = "文章更新时间")
    private LocalTime articleTime;
    @ApiModelProperty(value = "最后一次文章更新时间")
    private LocalDateTime lastArticleTime;
    @ApiModelProperty(value = "是否为新站")
    private Boolean newSite;
    @ApiModelProperty(value = "js分组")
    private String jsGroup;
    @ApiModelProperty(value = "提案编号")
    private String proposalReference;
}
