package com.chuang.urras.sr.admin.model.ro;

import com.chuang.urras.sr.core.enums.CheckedStatus;
import com.chuang.urras.sr.core.enums.TaskStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 网站模板
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SeoTemplateRO对象", description="网站模板")
public class SeoTemplateRO implements Serializable {

    @ApiModelProperty(value = "id")
    private Integer id;
    @ApiModelProperty(value = "模板域名")
    private String website;
    @ApiModelProperty(value = "模板类型")
    private String tpType;
    @ApiModelProperty(value = "index(ALT)")
    private Integer indexSubKeySize;
    @ApiModelProperty(value = "list(ALT)")
    private Integer listSubKeySize;
    @ApiModelProperty(value = "article(ALT)")
    private Integer articleSubKeySize;
    @ApiModelProperty(value = "index(A)")
    private Integer indexATagSize;
    @ApiModelProperty(value = "list(A)")
    private Integer listATagSize;
    @ApiModelProperty(value = "文章页(A)")
    private Integer articleATagSize;
    @ApiModelProperty(value = "内链数")
    private Integer interlinkSize;
    @ApiModelProperty(value = "审核状态")
    private CheckedStatus checked;
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
    @ApiModelProperty(value = "创建人")
    private String creator;
    @ApiModelProperty(value = "最后更新时间")
    private LocalDateTime updatedTime;
    @ApiModelProperty(value = "最后更新人")
    private String updater;
    @ApiModelProperty(value = "index页面的抓取状态")
    private TaskStatus indexState;
    @ApiModelProperty(value = "list页面的抓取状态")
    private TaskStatus listState;
    @ApiModelProperty(value = "文章页面的抓取状态")
    private TaskStatus articleState;
    @ApiModelProperty(value = "index(H)")
    private Integer indexHSize;
    @ApiModelProperty(value = "list(H)")
    private Integer listHSize;
    @ApiModelProperty(value = "article(H)")
    private Integer articleHSize;

    @ApiModelProperty(value = "index(句子)")
    private Integer indexSentenceSize;
    @ApiModelProperty(value = "list(句子)")
    private Integer listSentenceSize;
    @ApiModelProperty(value = "文章页(句子)")
    private Integer articleSentenceSize;

    @ApiModelProperty(value = "分组")
    private Integer groupId;
    @ApiModelProperty(value = "审核人")
    private String auditor;
    @ApiModelProperty(value = "审核备注")
    private String remark;
    @ApiModelProperty(value = "使用次数")
    private Integer useTimes;
    @ApiModelProperty(value = "审核时间")
    private LocalDateTime auditedTime;
}
