package com.chuang.urras.sr.admin.model.uo;

import com.chuang.tauceti.acme.v2.Account;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * ACME账号
 * </p>
 *
 * @author chuang
 * @since 2021-05-29
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeAccountUO对象", description="ACME账号")
public class AcmeAccountUO implements Serializable {

    @NotNull(message = "不能为空")
    private Integer id;

    @ApiModelProperty(value = "ACME账号")
    @NotBlank(message = "ACME账号不能为空")
    private String account;

    @ApiModelProperty(value = "初始化IP")
    @NotBlank(message = "初始化IP不能为空")
    private String initialIp;

    @ApiModelProperty(value = "状态")
    @NotNull(message = "状态不能为空")
    private Account.Status status;

    @ApiModelProperty(value = "location")
    @NotBlank(message = "location不能为空")
    private String location;

    @ApiModelProperty(value = "联系email")
    @NotBlank(message = "联系email不能为空")
    private String contactEmail;

    @ApiModelProperty(value = "备注说明")
    @NotBlank(message = "备注说明不能为空")
    private String remark;

}
