package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.AcmeOrderStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * Acme订单
 * </p>
 *
 * @author chuang
 * @since 2021-05-31
 */
@Data
@Accessors(chain = true)
@ApiModel(value="AcmeOrderUO对象", description="Acme订单")
public class AcmeOrderUO implements Serializable {

    @ApiModelProperty(value = "ID")
    @NotNull(message = "ID不能为空")
    private Integer id;

    @ApiModelProperty(value = "acme账号")
    @NotBlank(message = "acme账号不能为空")
    private String account;

    @ApiModelProperty(value = "状态")
    @NotNull(message = "状态不能为空")
    private AcmeOrderStatus status;

    @ApiModelProperty(value = "acme提供者")
    @NotBlank(message = "acme提供者不能为空")
    private String provider;

    @ApiModelProperty(value = "订单(可以用域名)")
    @NotBlank(message = "订单(可以用域名)不能为空")
    private String orderReference;

    @ApiModelProperty(value = "顶级域名")
    @NotBlank(message = "顶级域名不能为空")
    private String domain;

    @ApiModelProperty(value = "二级域名")
    @NotBlank(message = "二级域名不能为空")
    private String sec;

}
