package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.DomainType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 文章表
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="ArticleUO对象", description="文章表")
public class ArticleUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "标题")
    @NotBlank(message = "标题不能为空")
    private String title;

    @ApiModelProperty(value = "文章")
    @NotBlank(message = "文章不能为空")
    private String article;

    @ApiModelProperty(value = "是否使用")
    @NotNull(message = "是否使用不能为空")
    private Boolean used;


    @ApiModelProperty(value = "所属网站")
    private String owner;

    @ApiModelProperty(value = "是否为菜单")
    @NotNull(message = "是否为菜单不能为空")
    private Boolean menu;

    @ApiModelProperty(value = "类型")
    @NotNull(message = "类型不能为空")
    private DomainType type;

}
