package com.chuang.urras.sr.admin.model.uo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDate;

/**
 * <p>
 * 蜘蛛爬行记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="DomainFetchLogUO对象", description="蜘蛛爬行记录")
public class DomainFetchLogUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "域名")
    @NotBlank(message = "域名不能为空")
    private String domain;

    @ApiModelProperty(value = "抓取次数")
    @NotNull(message = "抓取次数不能为空")
    private Integer times;

    @ApiModelProperty(value = "更新时间")
    @NotNull(message = "更新时间不能为空")
    private LocalDate logDate;

    @ApiModelProperty(value = "是否为内部网站")
    @NotNull(message = "是否为内部网站不能为空")
    private Boolean internal;

}
