package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.TaskStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 下载任务
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="DownloadTaskUO对象", description="下载任务")
public class DownloadTaskUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "资源站点")
    @NotBlank(message = "资源站点不能为空")
    private String website;

    @ApiModelProperty(value = "资源url")
    @NotBlank(message = "资源url不能为空")
    private String url;

    @ApiModelProperty(value = "资源保存地址")
    @NotBlank(message = "资源保存地址不能为空")
    private String savePath;

    @ApiModelProperty(value = "状态")
    @NotNull(message = "状态不能为空")
    private TaskStatus state;

    @ApiModelProperty(value = "错误")
    @NotBlank(message = "错误不能为空")
    private String error;

    @ApiModelProperty(value = "下载错误次数")
    @NotNull(message = "下载错误次数不能为空")
    private Integer failTimes;

}
