package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.PlatformType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 搜索引擎检测内容
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="PlatformCheckContentUO对象", description="搜索引擎检测内容")
public class PlatformCheckContentUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "平台")
    @NotNull(message = "平台不能为空")
    private PlatformType platformType;

    @ApiModelProperty(value = "域名")
    @NotBlank(message = "域名不能为空")
    private String domain;

    @ApiModelProperty(value = "检测内容")
    private String checkContent;

    @ApiModelProperty(value = "账号")
    @NotBlank(message = "账号不能为空")
    private String username;

    @ApiModelProperty(value = "提交成功")
    @NotNull(message = "提交成功不能为空")
    private Boolean submitted;

    @ApiModelProperty(value = "返回结果")
    private String result;

    @ApiModelProperty(value = "缓存1")
    private String temp;

    @ApiModelProperty(value = "缓存2")
    private String temp2;

    @ApiModelProperty(value = "已发布")
    @NotNull(message = "已发布不能为空")
    private Boolean linkPublished;

}
