package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.PlatformType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 搜索引擎账号Cookie
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="PlatformCookieUO对象", description="搜索引擎账号Cookie")
public class PlatformCookieUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "平台")
    @NotNull(message = "平台不能为空")
    private PlatformType platformType;

    @ApiModelProperty(value = "是否有效")
    @NotBlank(message = "是否有效不能为空")
    private String cookie;

    @ApiModelProperty(value = "账号")
    @NotBlank(message = "账号不能为空")
    private String username;

    @ApiModelProperty(value = "是否检验")
    @NotNull(message = "是否检验不能为空")
    private Boolean valid;

    @ApiModelProperty(value = "是否自动")
    @NotNull(message = "是否自动不能为空")
    private Boolean auto;

}
