package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.PageType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 句子表
 * </p>
 *
 * @author chuang
 * @since 2021-06-10
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SentenceArticleUO对象", description="句子表")
public class SentenceArticleUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "域名")
    @NotBlank(message = "域名不能为空")
    private String domain;

    @ApiModelProperty(value = "标题")
    @NotBlank(message = "标题不能为空")
    private String title;

    @ApiModelProperty(value = "页面类型")
    @NotNull(message = "页面类型不能为空")
    private PageType page;

}
