package com.chuang.urras.sr.admin.model.uo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 句子库
 * </p>
 *
 * @author chuang
 * @since 2021-06-10
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SentenceUO对象", description="句子库")
public class SentenceUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "句子")
    @NotBlank(message = "句子不能为空")
    private String sentence;


}
