package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.DomainType;
import com.chuang.urras.sr.core.enums.ProposalStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 网站提案
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SeoDomainProposalUO对象", description="网站提案")
public class SeoDomainProposalUO implements Serializable {

    @NotNull(message = "不能为空")
    private Integer id;

    @ApiModelProperty(value = "域名")
    @NotBlank(message = "域名不能为空")
    private String domain;

    @ApiModelProperty(value = "站点模板")
    @NotBlank(message = "站点模板不能为空")
    private String templateWebsite;

    @ApiModelProperty(value = "title")
    @NotBlank(message = "title不能为空")
    private String title;

    @ApiModelProperty(value = "关键词列表")
    @NotBlank(message = "关键词列表不能为空")
    private String keywords;

    @ApiModelProperty(value = "list页面的title")
    @NotBlank(message = "list页面的title不能为空")
    private String listPageTitle;

    @ApiModelProperty(value = "其他菜单名，用逗号隔开")
    @NotBlank(message = "其他菜单名，用逗号隔开不能为空")
    private String otherMenus;

    @ApiModelProperty(value = "主关键词")
    @NotBlank(message = "主关键词不能为空")
    private String mainKey;

    @ApiModelProperty(value = "类型")
    @NotNull(message = "类型不能为空")
    private DomainType type;

    @ApiModelProperty(value = "网站描述")
    private String description;

    @ApiModelProperty(value = "状态")
    @NotNull(message = "状态不能为空")
    private ProposalStatus state;

    @ApiModelProperty(value = "审核备注")
    private String remark;

    @ApiModelProperty(value = "服务器标记")
    @NotBlank(message = "服务器标记不能为空")
    private String serverTag;

}
