package com.chuang.urras.sr.admin.model.uo;

import com.chuang.urras.sr.core.enums.CheckedStatus;
import com.chuang.urras.sr.core.enums.TaskStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 网站模板
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@Accessors(chain = true)
@ApiModel(value="SeoTemplateUO对象", description="网站模板")
public class SeoTemplateUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "模板域名")
    @NotBlank(message = "模板域名不能为空")
    private String website;

    @ApiModelProperty(value = "index(ALT)")
    @NotNull(message = "index(ALT)不能为空")
    private Integer indexSubKeySize;

    @ApiModelProperty(value = "list(ALT)")
    @NotNull(message = "list(ALT)不能为空")
    private Integer listSubKeySize;

    @ApiModelProperty(value = "模板类型")
    private String tpType;

    @ApiModelProperty(value = "article(ALT)")
    @NotNull(message = "article(ALT)不能为空")
    private Integer articleSubKeySize;

    @ApiModelProperty(value = "index(A)")
    @NotNull(message = "index(A)不能为空")
    private Integer indexATagSize;

    @ApiModelProperty(value = "list(A)")
    @NotNull(message = "list(A)不能为空")
    private Integer listATagSize;

    @ApiModelProperty(value = "文章页(A)")
    @NotNull(message = "文章页(A)不能为空")
    private Integer articleATagSize;

    @ApiModelProperty(value = "内链数")
    @NotNull(message = "内链数不能为空")
    private Integer interlinkSize;

    @ApiModelProperty(value = "index(句子)")
    @NotNull(message = "index(句子)不能为空")
    private Integer indexSentenceSize;

    @ApiModelProperty(value = "list(句子)")
    @NotNull(message = "list(句子)不能为空")
    private Integer listSentenceSize;

    @ApiModelProperty(value = "文章页(句子)")
    @NotNull(message = "文章页(句子)不能为空")
    private Integer articleSentenceSize;

    @ApiModelProperty(value = "审核状态")
    @NotNull(message = "审核状态不能为空")
    private CheckedStatus checked;

    @ApiModelProperty(value = "index页面的抓取状态")
    @NotNull(message = "index页面的抓取状态不能为空")
    private TaskStatus indexState;

    @ApiModelProperty(value = "list页面的抓取状态")
    @NotNull(message = "list页面的抓取状态不能为空")
    private TaskStatus listState;

    @ApiModelProperty(value = "文章页面的抓取状态")
    @NotNull(message = "文章页面的抓取状态不能为空")
    private TaskStatus articleState;

    @ApiModelProperty(value = "index(H)")
    @NotNull(message = "index(H)不能为空")
    private Integer indexHSize;

    @ApiModelProperty(value = "list(H)")
    @NotNull(message = "list(H)不能为空")
    private Integer listHSize;

    @ApiModelProperty(value = "article(H)")
    @NotNull(message = "article(H)不能为空")
    private Integer articleHSize;

    @ApiModelProperty(value = "分组")
    @NotNull(message = "分组不能为空")
    private Integer groupId;

    @ApiModelProperty(value = "审核人")
    private String auditor;

    @ApiModelProperty(value = "审核备注")
    private String remark;

    @ApiModelProperty(value = "使用次数")
    @NotNull(message = "使用次数不能为空")
    private Integer useTimes;

    @ApiModelProperty(value = "审核时间")
    private LocalDateTime auditedTime;

}
