package com.chuang.urras.sr.admin.model.uo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 服务器
 * </p>
 *
 * @author chuang
 * @since 2021-06-11
 */
@Data
@Accessors(chain = true)
@ApiModel(value="ServerUO对象", description="服务器")
public class ServerUO implements Serializable {

    @ApiModelProperty(value = "id")
    @NotNull(message = "id不能为空")
    private Integer id;

    @ApiModelProperty(value = "服务器名称")
    @NotBlank(message = "服务器名称不能为空")
    private String serverName;

    @ApiModelProperty(value = "服务器ip")
    @NotBlank(message = "服务器ip不能为空")
    private String serverIp;

    @NotNull(message = "服务器用户不能为空")
    private Integer sshPort;

    @NotBlank(message = "服务器用户不能为空")
    private String intranetIp;

    @ApiModelProperty(value = "服务器用户")
    @NotBlank(message = "服务器用户不能为空")
    private String serverUser;

    @ApiModelProperty(value = "服务器密码")
    @NotBlank(message = "服务器密码不能为空")
    private String serverPass;

}
