package com.chuang.urras.sr.admin.task.platform;

import com.chuang.tauceti.support.vg.OperatorManager;
import com.chuang.urras.sr.core.service.platform.IPushService;
import com.chuang.urras.sr.core.service.single.IPlatformCookieService;
import lombok.extern.slf4j.Slf4j;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.scheduling.quartz.QuartzJobBean;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
@Slf4j
public class SearchPlatformTasks extends QuartzJobBean {

    private static final String OPERATOR = "SearchPlatformTask";
    @Resource private OperatorManager operatorManager;

    @Resource private IPlatformCookieService platformCookieService;
    @Resource private IPushService pushService;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        operatorManager.temp(OPERATOR, this::touch);
    }

//    @Scheduled(cron = "0 */10 * * * ?")
    public void touch() {
//        log.info("开始touch");
//        platformCookieService.list().forEach(platformCookie -> {
//            pushService.touch(platformCookie).thenAccept(aBoolean -> {
//                platformCookie.setValid(aBoolean);
//                platformCookieService.updateById(platformCookie);
//            });
//        });
    }

//    @Scheduled(cron = "0 */10 * * * ?")
//    public void publish() {
//        log.info("开始publish");
//        Map<PlatformType, List<PlatformCookie>> cookieGroup = platformCookieService.lambdaQuery()
//                .eq(PlatformCookie::getAuto, true)
//                .eq(PlatformCookie::getValid, true)
//                .list().stream()
//                .collect(Collectors.groupingBy(PlatformCookie::getPlatformType));
//
//        if(cookieGroup.isEmpty()) {
//            log.info("没有任何cookie可用，放弃执行");
//            return;
//        }
//
//        platformCheckContentService.lambdaQuery()
//                .eq(PlatformCheckContent::getSubmitted, false)
//                .last(" limit 200 ")
//                .list().stream()
//                .collect(Collectors.groupingBy(PlatformCheckContent::getDomain))
//                .forEach((domain, pccs) -> {
//                    Optional<SeoDomain> opt = domainService.findByDomain(domain);
//                    if(!opt.isPresent()) {
//                        return;
//                    }
//                    Collection<String> links = articleService.links(opt.get());
//                    pccs.forEach(pcc -> {
//                        List<PlatformCookie> cookies = cookieGroup.get(pcc.getPlatformType());
//                        if(CollectionKit.isEmpty(cookies)) {
//                            return;
//                        }
//                        PlatformCookie cookie = CollectionKit.randomOne(CollectionKit.randomOne(cookies));
//                        log.info("domain:{}, type: {}, cookie:{}, ", pcc.getDomain(), pcc.getPlatformType(), cookie.getCookie());
//                        pcc.setUsername(cookie.getUsername());
//                        platformCheckContentService.updateById(pcc);
//                        Boolean success = pushService.addSite(cookie, pcc, platformCheckContentService::updateById).join();
//
//                        if(success) {
//                            log.info(pcc.getDomain() + "-> 成功");
//                            pushService.sitemapPush(cookie, pcc).join();
//                            pushService.linkPush(cookie, pcc, links, platformCheckContentService::updateById).join();
//                        } else {
//                            log.info(pcc.getDomain() + "-> 失败");
//                        }
//
//                    });
//                });
//    }
//
//    @Scheduled(cron = "0 */10 * * * ?")
//    public void publishLinks() {
//        log.info("开始publish sitemaps");
//
//        Map<String, List<PlatformCookie>> cookieGroup = platformCookieService.lambdaQuery()
//                .eq(PlatformCookie::getAuto, true)
//                .eq(PlatformCookie::getValid, true)
//                .list().stream()
//                .collect(Collectors.groupingBy(cookie -> cookie.getPlatformType() + ":" + cookie.getUsername()));
//
//        if(cookieGroup.isEmpty()) {
//            log.info("没有任何cookie可用，放弃执行");
//            return;
//        }
//
//        platformCheckContentService.lambdaQuery()
//                .eq(PlatformCheckContent::getSubmitted, true)
//                .eq(PlatformCheckContent::getLinkPublished, false)
//                .in(PlatformCheckContent::getPlatformType, Arrays.asList(PlatformType.SHENMA, PlatformType.TOU_TIAO))
//                .last(" limit 200 ")
//                .list().stream()
//                .collect(Collectors.groupingBy(PlatformCheckContent::getDomain))
//                .forEach((domain, pccs) -> {
//                    Optional<SeoDomain> opt = domainService.findByDomain(domain);
//                    if(!opt.isPresent()) {
//                        return;
//                    }
//                    Collection<String> links = articleService.links(opt.get());
//                    pccs.forEach(pcc -> {
//                        List<PlatformCookie> cookies = cookieGroup.get(pcc.getPlatformType() + ":" + pcc.getUsername());
//                        if(CollectionKit.isEmpty(cookies)) {
//                            return;
//                        }
//                        PlatformCookie cookie = CollectionKit.randomOne(cookies);
//                        pcc.setUsername(cookie.getUsername());
//                        pushService.sitemapPush(cookie, pcc).join();
//                        pushService.linkPush(cookie, pcc, links, platformCheckContentService::updateById).join();
//                    });
//                });
//
//    }
}
