package com.chuang.urras.sr.core.acme;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import java.util.function.Supplier;

@Slf4j
@Component
public class AcmeQueue {
    private final Executor executor = Executors.newSingleThreadExecutor();

    public <T> CompletableFuture<T> submit(Supplier<CompletableFuture<T>> task) {

        log.info("添加一个任务");
        CompletableFuture<T> future = new CompletableFuture<>();

        executor.execute(() -> {
            try {
                T value = task.get().join();
                future.complete(value);
            } catch (Throwable e) {
                future.completeExceptionally(e);
            }
        });

        return future;
    }
}
