package com.chuang.urras.sr.core.configuration;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.chuang.tauceti.acme.v2.store.AcmeStore;
import com.chuang.tauceti.acme.v2.store.FileStore;
import com.chuang.tauceti.rbac2.crud.Rbac2MybatisPlusConfiguration;
import com.chuang.urras.common.crud.annotations.MybatisPlusPackage;
import com.chuang.urras.sr.core.acme.AcmeProperties;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

@Configuration
@Import(Rbac2MybatisPlusConfiguration.class)
@MapperScan(
        basePackages= "com.chuang.urras.sr.core",
        markerInterface = BaseMapper.class
)
@ComponentScan("com.chuang.urras.sr.core")
@MybatisPlusPackage(aliases = "com.chuang.urras.sr.core.entity", enums = "com.chuang.urras.sr.core.enums")
public class CoreConfiguration {

    @Bean
    public AcmeStore acmeStore(AcmeProperties acmeProperties) {
        return new FileStore(acmeProperties.getWorkspace());
    }


}
