package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.tauceti.acme.v2.Account;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * ACME账号
 * </p>
 *
 * @author chuang
 * @since 2021-05-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_acme_account")
public class AcmeAccount implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * ACME账号
     */
    @TableField("account")
    private String account;

    /**
     * 初始化IP
     */
    @TableField("initial_ip")
    private String initialIp;

    /**
     * 状态
     */
    @TableField("status")
    private Account.Status status;

    /**
     * location
     */
    @TableField("location")
    private String location;

    /**
     * 联系email
     */
    @TableField("contact_email")
    private String contactEmail;

    /**
     * 备注说明
     */
    @TableField("remark")
    private String remark;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    @TableField("provider")
    private String provider;

}
