package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.sr.core.enums.AcmeOrderStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * Acme订单
 * </p>
 *
 * @author chuang
 * @since 2021-05-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_acme_order")
public class AcmeOrder implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * acme账号
     */
    @TableField("account")
    private String account;

    /**
     * 状态
     */
    @TableField("status")
    private AcmeOrderStatus status;

    /**
     * acme提供者
     */
    @TableField("provider")
    private String provider;

    /**
     * 订单(可以用域名)
     */
    @TableField("order_reference")
    private String orderReference;

    /**
     * 顶级域名
     */
    @TableField("domain")
    private String domain;

    /**
     * 二级域名
     */
    @TableField("sec")
    private String sec;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;

    @TableField("apply_msg")
    private String applyMsg;

    @TableField("last_renew_time")
    private LocalDateTime lastRenewTime;

}
