package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.sr.core.enums.DomainType;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 文章表
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_article")
public class Article implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 标题
     */
    @TableField("title")
    private String title;

    /**
     * 文章
     */
    @TableField("article")
    private String article;

    /**
     * 是否使用
     */
    @TableField("used")
    private Boolean used;

    /**
     * md5
     */
    @TableField("md5")
    private String md5;

    /**
     * 所属网站
     */
    @TableField("owner")
    private String owner;

    /**
     * 是否为菜单
     */
    @TableField("menu")
    private Boolean menu;

    /**
     * 类型
     */
    @TableField("type")
    private DomainType type;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;


}
