package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;

/**
 * <p>
 * 蜘蛛爬行记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_domain_fetch_log")
public class DomainFetchLog implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 域名
     */
    @TableField("domain")
    private String domain;

    /**
     * 抓取次数
     */
    @TableField("times")
    private Integer times;

    /**
     * 更新时间
     */
    @TableField("log_date")
    private LocalDate logDate;

    /**
     * 是否为内部网站
     */
    @TableField("internal")
    private Boolean internal;


}
