package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.sr.core.enums.TaskStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 下载任务
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_download_task")
public class DownloadTask implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 资源站点
     */
    @TableField("website")
    private String website;

    /**
     * 资源url
     */
    @TableField("url")
    private String url;

    /**
     * 资源保存地址
     */
    @TableField("save_path")
    private String savePath;

    /**
     * 状态
     */
    @TableField("state")
    private TaskStatus state;

    /**
     * 错误
     */
    @TableField("error")
    private String error;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;

    /**
     * 下载错误次数
     */
    @TableField("fail_times")
    private Integer failTimes;


}
