package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.chuang.urras.sr.core.enums.PlatformType;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 搜索引擎检测内容
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_platform_check_content")
public class PlatformCheckContent implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 平台
     */
    @TableField("platform_type")
    private PlatformType platformType;

    /**
     * 域名
     */
    @TableField("domain")
    private String domain;

    /**
     * 检测内容
     */
    @TableField("check_content")
    private String checkContent;

    /**
     * 账号
     */
    @TableField("username")
    private String username;

    /**
     * 提交成功
     */
    @TableField("submitted")
    private Boolean submitted;

    /**
     * 返回结果
     */
    @TableField("result")
    private String result;

    /**
     * 缓存1
     */
    @TableField("temp")
    private String temp;

    /**
     * 缓存2
     */
    @TableField("temp2")
    private String temp2;

    /**
     * 已发布
     */
    @TableField("link_published")
    private Boolean linkPublished;


}
