package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.chuang.urras.sr.core.enums.PlatformType;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 搜索引擎账号Cookie
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_platform_cookie")
public class PlatformCookie implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 平台
     */
    @TableField("platform_type")
    private PlatformType platformType;

    /**
     * 是否有效
     */
    @TableField("cookie")
    private String cookie;

    /**
     * 账号
     */
    @TableField("username")
    private String username;

    /**
     * 是否检验
     */
    @TableField("valid")
    private Boolean valid;

    /**
     * 是否自动
     */
    @TableField("auto")
    private Boolean auto;


}
