package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.sr.core.enums.DomainType;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.time.LocalTime;

/**
 * <p>
 * 网站记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_seo_domain")
public class SeoDomain implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 模板网址
     */
    @TableField("template_website")
    private String templateWebsite;

    /**
     * 网站域名
     */
    @TableField("domain")
    private String domain;

    /**
     * 标题
     */
    @TableField("title")
    private String title;

    /**
     * 关键词列表
     */
    @TableField("keywords")
    private String keywords;

    /**
     * 菜单列表
     */
    @TableField("menus")
    private String menus;

    /**
     * 主关键词
     */
    @TableField("main_key")
    private String mainKey;

    /**
     * 类型
     */
    @TableField("type")
    private DomainType type;

    /**
     * 网站说明
     */
    @TableField("description")
    private String description;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;

    /**
     * 服务器标记
     */
    @TableField("server_tag")
    private String serverTag;

    /**
     * 网页后缀
     */
    @TableField("suffix")
    private String suffix;

    /**
     * 文章目录
     */
    @TableField("dir")
    private String dir;

    /**
     * 句子目录
     */
    @TableField("sentence_dir")
    private String sentenceDir;

    /**
     * 每天最多更新多少篇
     */
    @TableField("daily_article")
    private Integer dailyArticle;

    /**
     * 文章更新时间
     */
    @TableField("article_time")
    private LocalTime articleTime;

    /**
     * 最后一次文章更新时间
     */
    @TableField("last_article_time")
    private LocalDateTime lastArticleTime;

    /**
     * 是否为新站
     */
    @TableField("new_site")
    private Boolean newSite;

    /**
     * js分组
     */
    @TableField("js_group")
    private String jsGroup;

    /**
     * 提案编号
     */
    @TableField("proposal_reference")
    private String proposalReference;


}
