package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.chuang.urras.sr.core.enums.DomainType;
import com.chuang.urras.sr.core.enums.ProposalStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 网站提案
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_seo_domain_proposal")
public class SeoDomainProposal implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("reference")
    private String reference;

    /**
     * 域名
     */
    @TableField("domain")
    private String domain;

    /**
     * 站点模板
     */
    @TableField("template_website")
    private String templateWebsite;

    /**
     * title
     */
    @TableField("title")
    private String title;

    /**
     * 关键词列表
     */
    @TableField("keywords")
    private String keywords;

    /**
     * list页面的title
     */
    @TableField("list_page_title")
    private String listPageTitle;

    /**
     * 其他菜单名，用逗号隔开
     */
    @TableField("other_menus")
    private String otherMenus;

    /**
     * 主关键词
     */
    @TableField("main_key")
    private String mainKey;

    /**
     * 类型
     */
    @TableField("type")
    private DomainType type;

    /**
     * 网站描述
     */
    @TableField("description")
    private String description;

    /**
     * 状态
     */
    @TableField("state")
    private ProposalStatus state;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;

    /**
     * 审核人
     */
    @TableField("auditor")
    private String auditor;

    /**
     * 审核时间
     */
    @TableField("audited_time")
    private LocalDateTime auditedTime;

    /**
     * 审核备注
     */
    @TableField("remark")
    private String remark;


    /**
     * 服务器标记
     */
    @TableField("server_tag")
    private String serverTag;


}
