package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 服务器
 * </p>
 *
 * @author chuang
 * @since 2021-06-11
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_server")
public class Server implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 服务器名称
     */
    @TableField("server_name")
    private String serverName;

    /**
     * 服务器ip
     */
    @TableField("server_ip")
    private String serverIp;

    @TableField("ssh_port")
    private Integer sshPort;

    @TableField("intranet_ip")
    private String intranetIp;

    /**
     * 服务器用户
     */
    @TableField("server_user")
    private String serverUser;

    /**
     * 服务器密码
     */
    @TableField("server_pass")
    private String serverPass;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;

    /**
     * 更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;

    /**
     * 更新人
     */
    @TableField(value = "updater", fill = FieldFill.INSERT_UPDATE)
    private String updater;


}
