package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 蜘蛛爬行日志
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_spider_log")
public class SpiderLog implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 百度蜘蛛个数
     */
    @TableField("baidu")
    private Integer baidu;

    /**
     * 360蜘蛛
     */
    @TableField("haosou")
    private Integer haosou;

    /**
     * 搜狗
     */
    @TableField("sogou")
    private Integer sogou;

    /**
     * 易搜
     */
    @TableField("yisou")
    private Integer yisou;

    /**
     * 其他
     */
    @TableField("other")
    private Integer other;

    /**
     * 日期
     */
    @TableField("log_date")
    private LocalDate logDate;

    /**
     * 最后更新时间
     */
    @TableField(value = "updated_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedTime;


}
