package com.chuang.urras.sr.core.entity;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 目标站记录
 * </p>
 *
 * @author chuang
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_target_domain")
public class TargetDomain implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 目标站
     */
    @TableField("target_domain")
    private String targetDomain;

    /**
     * 星环特有
     */
    @TableField("xinhuan")
    private Boolean xinhuan;

    /**
     * 是否使用
     */
    @TableField("used")
    private Boolean used;

    /**
     * 使用人
     */
    @TableField("used_by")
    private String usedBy;

    /**
     * 使用时间
     */
    @TableField("used_time")
    private LocalDateTime usedTime;

    /**
     * 创建时间
     */
    @TableField(value = "created_time", fill = FieldFill.INSERT)
    private LocalDateTime createdTime;

    /**
     * 创建人
     */
    @TableField(value = "creator", fill = FieldFill.INSERT)
    private String creator;


}
