package com.chuang.urras.sr.core.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.chuang.tauceti.acme.v2.model.enums.OrderStatus;

public enum AcmeOrderStatus {
    PENDING(0),
    PROCESSING(1),
    VALID(2),
    INVALID(3),
    RE_PENDING(4),
    READY(5),
    DOWNLOADED(6);

    @EnumValue
    private final byte code;

    AcmeOrderStatus(int code){
        this.code = (byte) code;
    }

    public static AcmeOrderStatus parse(OrderStatus orderStatus) {
        return AcmeOrderStatus.valueOf(orderStatus.name().toUpperCase());
    }

    public static AcmeOrderStatus parse(String orderStatus) {
        return AcmeOrderStatus.valueOf(orderStatus.toUpperCase());
    }

    public byte getCode() {
        return code;
    }
}
