package com.chuang.urras.sr.core.service;

import com.chuang.urras.sr.core.entity.SentenceArticleContent;
import com.chuang.tauceti.rowquery.IRowQueryService;

import java.util.Optional;
import java.util.Set;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author chuang
 * @since 2021-06-10
 */
public interface ISentenceArticleContentService extends IRowQueryService<SentenceArticleContent> {
    default boolean deleteBySentenceIds(Set<Integer> ids) {
        return lambdaUpdate().in(SentenceArticleContent::getSentenceArticleId, ids).remove();
    }

    default Optional<SentenceArticleContent> findBySentenceId(Integer id) {
        return lambdaQuery().eq(SentenceArticleContent::getSentenceArticleId, id).oneOpt();
    }

}
