package com.chuang.urras.sr.core.service.single;

import com.chuang.urras.sr.core.entity.PlatformCheckContent;
import com.chuang.urras.sr.core.enums.PlatformType;
import com.chuang.tauceti.rowquery.IRowQueryService;

import java.util.Optional;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author ath
 * @since 2020-12-13
 */
public interface IPlatformCheckContentService extends IRowQueryService<PlatformCheckContent> {

    default Optional<String> findCheckContent(PlatformType type, String domain) {
        return findOne(type, domain).map(PlatformCheckContent::getCheckContent);
    }

    default Optional<PlatformCheckContent> findOne(PlatformType type, String domain) {
        return lambdaQuery()
                .eq(PlatformCheckContent::getDomain, domain)
                .eq(PlatformCheckContent::getPlatformType, type)
                .oneOpt();
    }


    default PlatformCheckContent getOrCreate(PlatformType type, String domain) {
        return findOne(type, domain).orElseGet(() -> {
            PlatformCheckContent obj = new PlatformCheckContent()
                    .setDomain(domain)
                    .setPlatformType(type)
                    .setSubmitted(false)
                    .setLinkPublished(false)
                    .setResult("")
                    .setTemp("")
                    .setTemp2("")
                    .setCheckContent("")
                    .setUsername("");
            save(obj);
            return obj;
        });
    }
}
