package com.chuang.urras.sr.core.service.single;

import com.chuang.urras.sr.core.entity.SeoDomain;
import com.chuang.urras.sr.core.service.IRandomService;
import com.chuang.tauceti.tools.basic.collection.CollectionKit;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author ath
 * @since 2020-09-23
 */
public interface ISeoDomainService extends IRandomService<SeoDomain, SeoDomain> {

    default Optional<SeoDomain> findByDomain(String domain) {
        return lambdaQuery().eq(SeoDomain::getDomain, domain).oneOpt();
    }

    default Optional<SeoDomain> findByReference(String reference) {
        return lambdaQuery().eq(SeoDomain::getProposalReference, reference).oneOpt();
    }


    default boolean updateServer(String serverName, Collection<String> domains) {
        CollectionKit.split(domains, 500, ArrayList::new).forEach(strings -> {
            lambdaUpdate().set(SeoDomain::getServerTag, serverName).in(SeoDomain::getDomain, strings).update();
        });
        return true;
    }

}
