package com.chuang.urras.sr.core.service.single;

import com.chuang.urras.sr.core.entity.SpiderLog;
import com.chuang.urras.sr.core.mapper.SpiderLogMapper;
import com.chuang.tauceti.rowquery.IRowQueryService;

import java.time.LocalDate;
import java.util.Optional;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author ath
 * @since 2020-09-23
 */
public interface ISpiderLogService extends IRowQueryService<SpiderLog> {

    default Optional<SpiderLog> findByDate(LocalDate date){
        return lambdaQuery().eq(SpiderLog::getLogDate, date).oneOpt();
    }

    default boolean addSpider(int baidu, int haosou, int sogou, int yisou, int other, LocalDate logDate) {
        return ((SpiderLogMapper)getBaseMapper()).addSpider(baidu, haosou, sogou, yisou, other, logDate);
    }


    default boolean saveOrIgnore(SpiderLog spiderLog) {
        return ((SpiderLogMapper)getBaseMapper()).saveOrIgnore(spiderLog);
    }
}
