package com.chuang.urras.sr.core.service.single.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.chuang.urras.sr.core.entity.Article;
import com.chuang.urras.sr.core.enums.DomainType;
import com.chuang.urras.sr.core.mapper.ArticleMapper;
import com.chuang.urras.sr.core.service.single.IArticleService;
import com.chuang.tauceti.support.BiValue;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author ath
 * @since 2020-09-23
 */
@Service
public class ArticleServiceImpl extends ServiceImpl<ArticleMapper, Article> implements IArticleService {

    @Override
    public List<BiValue<DomainType, Integer>> statisticsNotUsed() {
        List<Map<Integer, Integer>> list = baseMapper.statisticsNotUsed();
        return list.stream()
                .map(bi -> new BiValue<>(DomainType.valueOf(bi.get("key").byteValue()), bi.get("value")))
                .collect(Collectors.toList());
    }
}
