package com.chuang.urras.sr.core.service.single.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.chuang.urras.sr.core.entity.Sentence;
import com.chuang.urras.sr.core.mapper.SentenceMapper;
import com.chuang.urras.sr.core.service.single.ISentenceService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * <p>
 * 句子库 服务实现类
 * </p>
 *
 * @author chuang
 * @since 2021-06-10
 */
@Service
public class SentenceServiceImpl extends ServiceImpl<SentenceMapper, Sentence> implements ISentenceService {

    @Override
    public boolean saveBatchSafe(Collection<Sentence> sentences) {
        Set<String> md5s = sentences.stream().map(Sentence::getMd5).collect(Collectors.toSet());
        Set<String> existedList = lambdaQuery().select(Sentence::getMd5).in(Sentence::getMd5, md5s).list() // 查找数据库中已经存在的MD5
                .stream().map(Sentence::getMd5).collect(Collectors.toSet()); //将已经存在的MD5放入集合

        if(!existedList.isEmpty()) {
            sentences = sentences.stream().filter(article -> !existedList.contains(article.getMd5())).collect(Collectors.toSet());
        }
        return this.baseMapper.saveOrIgnoreDuplicate(sentences) > 0;
    }
}
