package com.chuang.urras.sr.core.service.single.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.chuang.urras.sr.core.entity.Title;
import com.chuang.urras.sr.core.mapper.TitleMapper;
import com.chuang.urras.sr.core.service.single.ITitleService;
import com.chuang.tauceti.support.vg.OperatorManager;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.Collection;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author chuang
 * @since 2021-06-10
 */
@Service
public class TitleServiceImpl extends ServiceImpl<TitleMapper, Title> implements ITitleService {

    @Resource private OperatorManager operatorManager;

    @Override
    public boolean saveBatchSafe(Collection<Title> titles) {
        LocalDateTime now = LocalDateTime.now();
        titles.forEach(title -> title.setCreator(operatorManager.get().orElse("none")).setCreatedTime(now));

        return this.baseMapper.saveOrIgnoreDuplicate(titles) > 0;
    }
}
