package com.chuang.urras.sr.restapp;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.ISelectorFinder;
import com.chuang.tauceti.tools.basic.collection.DoubleKeyMap;
import com.chuang.urras.sr.restapp.model.SiteFetchSetting;

import java.util.Collections;
import java.util.List;


public class CachedSelectorFinder implements ISelectorFinder {

    private DoubleKeyMap<String, String, List<String>> cache = new DoubleKeyMap<>();

    public void push(SiteFetchSetting setting) {
        String website = setting.getWebsite();

        cache.put(website, Handler.free_mark_a_tag.name(), setting.getAtagGroup());
        cache.put(website, Handler.free_mark_article_content.name(), setting.getContentGroup());
        cache.put(website, Handler.free_mark_article_title.name(), setting.getTitleGroup());
        cache.put(website, Handler.free_mark_nav.name(), setting.getNavGroup());
        cache.put(website, Handler.free_mark_interlink.name(), setting.getInterlinkGroup());
        cache.put(website, Handler.delete.name(), setting.getRemoveGroup());
        cache.put(website, Handler.free_mark_keywords.name() + ":logo", setting.getLogoGroup());
    }

    @Override
    public List<String> getSelectorQuery(PageInfo info, String handName) {

        return cache.getOrDefault(info.getWebsite(), handName, Collections.emptyList());
    }

    public void release(String website) {
        cache.clear(website);
    }
}
