package com.chuang.urras.sr.restapp.controller;

import com.chuang.tauceti.support.exception.BusinessException;
import com.chuang.tauceti.tools.basic.StringKit;
import com.chuang.tauceti.tools.basic.collection.CollectionKit;
import com.chuang.tauceti.tools.third.servlet.HttpKit;
import com.chuang.urras.sr.core.entity.JsGroup;
import com.chuang.urras.sr.core.entity.SeoDomain;
import com.chuang.urras.sr.core.service.single.IJsGroupService;
import com.chuang.urras.sr.core.service.single.ISeoDomainService;
import com.chuang.urras.sr.restapp.HttpUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@RestController
public class JsController extends BaseController {

    @Resource private IJsGroupService jsGroupService;
    @Resource private ISeoDomainService seoDomainService;

    @GetMapping("/public/js/{jsName}")
    public void js(@PathVariable String jsName) {
        if(HttpKit.isSpider()) {
            HttpUtils.response("text/javascript;charset=UTF-8", "");
            return;
        }


        if(fromSearchPlatform() || systemSettingPolicy.getBoolean("JS_OPEN").orElse(true)) {
            String server = getServer();
            SeoDomain domain = seoDomainService.findByDomain(server)
                    .orElseThrow(() -> new BusinessException(404, "找不到文件"));

            String jsGroup = domain.getJsGroup();
            JsGroup group = jsGroupService.findByName(jsGroup)
                    .orElseThrow(() -> new BusinessException(404, "找不到" + jsName + ".js文件"));

            String game = group.getGamePlatform();
            if(StringKit.isBlank(game)){
                game = "leyu";
            }

            String code = randomCode(game);
            String ldy = HttpUtils.getScheme()  + "://www." + domain.getDomain() + "/auto-reg/" + game + "/" + code + "/index";

            String js = group.getJs()
                    .replaceAll("\\{\\{\\{i_code}}}", code)
                    .replaceAll("\\{\\{\\{落地页}}}", ldy);
            HttpUtils.response("text/javascript;charset=UTF-8", js);
        } else {
            HttpUtils.response("text/javascript;charset=UTF-8", "document.write('网站维护中...')");
        }
//        log.info("js->" + jsName);

    }


    private String randomCode(String game){
        return CollectionKit.randomOne(codes(game));
    }

    private List<String> codes(String game) {
        String lc = systemSettingPolicy.get(game.toUpperCase() + "_CODES").orElse("");
        List<String> codes;
        if(StringKit.isBlank(lc)) {
//            codes = registerProperties.getLeyu().getEden().getCodes();
            return Collections.emptyList();
        } else {
            codes = Arrays.asList(lc.split(","));
        }
        return codes;
    }
}
