package com.chuang.urras.sr.restapp.controller;

import com.chuang.eden.template.fetch.WebsiteMapping;
import com.chuang.tauceti.support.vg.OperatorManager;
import com.chuang.urras.sr.core.entity.SeoTemplate;
import com.chuang.urras.sr.core.service.single.ISeoDomainProposalService;
import com.chuang.urras.sr.core.service.single.ISeoTemplateService;
import com.chuang.urras.sr.restapp.model.Item;
import com.chuang.urras.sr.restapp.model.MenuItem;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.function.Function;

@RequestMapping("/test")
@Controller
@Slf4j
public class TestController {

    @Resource private OperatorManager operatorGetter;
    @Resource private WebsiteMapping websiteMapping;
    @Resource private ISeoTemplateService seoTemplateService;
    @Resource private ISeoDomainProposalService seoDomainProposalService;

//    @RequestMapping(value = "/test/test")
//    public ModelAndView tes() {
//        ModelAndView view = new ModelAndView();
//        view.setViewName("test");
//        view.addObject("msg", "hello");
//        return view;
//    }
//
//    @RequestMapping(value = "/repair")
//    @ResponseBody
//    public String repair() {
//        LocalDateTime time = LocalDateTime.of(2020, 10, 26, 0, 0, 0);
//        List<SeoDomainProposal> list = seoDomainProposalService.lambdaQuery().gt(SeoDomainProposal::getCreatedTime, time).list();
//        list.forEach(seoDomainProposal -> {
//            String domain = seoDomainProposal.getDomain();
//            if(domain.contains(",")) {
//                domain = domain.split(",")[0].trim();
//                seoDomainProposal.setDomain(domain);
//            }
//        });
//
//        seoDomainProposalService.updateBatchById(list);
//        return "success";
//    }
//
//    private void hand(SeoTemplate tmp) {
//        try {// subkey =>  alt
//
//            getHtml("/opt/templates/fetch/" + websiteMapping.mapping(tmp.getWebsite()) + "/index.ftl").ifPresent(html -> {
//                int keySize = html.split("<img").length - 1;
//                tmp.setIndexSubKeySize(keySize);
//                log.info("{} idx img > {}", tmp.getWebsite(), keySize);
//            });
//
//
//            getHtml("/opt/templates/fetch/" + websiteMapping.mapping(tmp.getWebsite()) + "/list.ftl").ifPresent(html -> {
//                int keySize = html.split("<img").length - 1;
//                tmp.setListSubKeySize(keySize);
//                log.info("{} list img > {}", tmp.getWebsite(), keySize);
//            });
//
//
//            getHtml("/opt/templates/fetch/" + websiteMapping.mapping(tmp.getWebsite()) + "/article.ftl").ifPresent(html -> {
//                int keySize = html.split("<img").length - 1;
//                int randomSize = html.split("randomKey\\[").length - 1;
//                int articleSize = html.split("articles\\[").length - 1;
//                log.info("{} art > {}", tmp.getWebsite(), keySize);
//                tmp.setArticleSubKeySize(keySize);
//                tmp.setArticleHSize(randomSize);
//                tmp.setArticleATagSize(articleSize);
//            });
//
//
//
//
//        } catch (Exception e) {
//           log.error("", e);
//        }
//
//    }
//
//    private Optional<String> getHtml(String file) {
//        try {
//            return Optional.of(FileKit.readString(file));
//        } catch (IOException e) {
//            return Optional.empty();
//        }
//    }

    @RequestMapping(value = "/{domain}/index")
    public ModelAndView index(@PathVariable(name = "domain") String domain) {
        return query(domain, "index");
    }

    @RequestMapping(value = "/{domain}/list")
    public ModelAndView list(@PathVariable(name = "domain") String domain) {
        return query(domain, "list");
    }

    @RequestMapping(value = "/{domain}/article")
    public ModelAndView detail(@PathVariable(name = "domain") String domain) {
        return query(domain, "article");
    }

    private ModelAndView query(String domain, String page) {
        Function<SeoTemplate, Integer> keySize;
        Function<SeoTemplate, Integer> tagSize;
        Function<SeoTemplate, Integer> randomSize;
        Function<SeoTemplate, Integer> sentenceSize;
        if("article".equalsIgnoreCase(page)) {
            keySize = SeoTemplate::getArticleSubKeySize;
            tagSize = SeoTemplate::getArticleATagSize;
            randomSize = SeoTemplate::getArticleHSize;
            sentenceSize = SeoTemplate::getArticleSentenceSize;
        } else if("list".equalsIgnoreCase(page)) {
            keySize = SeoTemplate::getListSubKeySize;
            tagSize = SeoTemplate::getListATagSize;
            randomSize = SeoTemplate::getListHSize;
            sentenceSize = SeoTemplate::getListSentenceSize;
        } else {
            keySize = SeoTemplate::getIndexSubKeySize;
            tagSize = SeoTemplate::getIndexATagSize;
            randomSize = SeoTemplate::getIndexHSize;
            sentenceSize = SeoTemplate::getIndexSentenceSize;
        }

        return operatorGetter.temp("sys", () -> {
            ModelAndView view = new ModelAndView();
            view.setViewName("/fetch/" + websiteMapping.mapping(domain) + "/" + page);
            view.addObject("title", "test-title");
            view.addObject("mainKey", "Main-Key");
            view.addObject("keywords", "k1, k2, k3");
            view.addObject("description", "d1,d2,d3");
            view.addObject("subKey", subKeys(domain, keySize));
            view.addObject("articles", articles(domain, tagSize));
            view.addObject("interlinks", interlinks(domain));
            view.addObject("randomKey", randomKeys(domain, randomSize));
            view.addObject("list", list0());
            view.addObject("menus", nav0());
            view.addObject("sentences", sentences(domain, sentenceSize));
            view.addObject("articleTitle", "文章title");
            view.addObject("articleContent", "文章内容");
            return view;
        });
    }



    private List<String> randomKeys(String domain, Function<SeoTemplate, Integer> randomSize) {

        return seoTemplateService.findByWebsite(domain).map(seoTemplate -> {
            int size = randomSize.apply(seoTemplate);
            List<String> list=  new ArrayList<>();
            for (int i = 0; i < size; i++) {
                list.add("randomKey-" + i);
            }
            return list;
        }).orElse(Collections.emptyList());
    }

    private List<Item> interlinks(String domain) {
        return seoTemplateService.findByWebsite(domain).map(seoTemplate -> {
            int size = seoTemplate.getInterlinkSize();
            List<Item> list=  new ArrayList<>();
            for (int i = 0; i < size; i++) {
                Item item = new Item();
                item.setHref("http://www.test.com/interlink-" + i + ".html")
                        .setImg("")
                        .setTitle("interlink-title-" + i);
                list.add(item);
            }
            return list;
        }).orElse(Collections.emptyList());
    }

    private List<String> subKeys(String domain, Function<SeoTemplate, Integer> keySize) {
        return seoTemplateService.findByWebsite(domain).map(seoTemplate -> {
            int size = keySize.apply(seoTemplate);
            List<String> list=  new ArrayList<>();
            for (int i = 0; i < size; i++) {
                list.add("sub" + i);
            }
            return list;
        }).orElse(Collections.emptyList());
    }

    private List<Item> articles(String domain, Function<SeoTemplate, Integer> tagSize) {
        return seoTemplateService.findByWebsite(domain).map(seoTemplate -> {
            int size = tagSize.apply(seoTemplate);
            size = Math.max(size, seoTemplate.getInterlinkSize());
            List<Item> list=  new ArrayList<>();
            for (int i = 0; i < size; i++) {
                Item item = new Item();
                item.setHref("http://www.test.com/tag" + i + ".html")
                        .setImg("")
                        .setTitle("atag-title" + i);
                list.add(item);
            }
            return list;
        }).orElse(Collections.emptyList());
    }

    private List<Item> sentences(String domain, Function<SeoTemplate, Integer> sentenceSize) {
        return seoTemplateService.findByWebsite(domain).map(seoTemplate -> {
            int size = sentenceSize.apply(seoTemplate);
            List<Item> list=  new ArrayList<>();
            for (int i = 0; i < size; i++) {
                Item item = new Item();
                item.setHref("http://www.test.com/sentence-" + i + ".html")
                        .setImg("")
                        .setTitle("sentence-title" + i);
                list.add(item);
            }
            return list;
        }).orElse(Collections.emptyList());

    }

    private static List<Item> list0() {
        List<Item> list= new ArrayList<>();
        list.add(new Item().setTitle("title_1").setHref("http://www.test.com/a1").setImg("/img1.jpg"));
        list.add(new Item().setTitle("title_2").setHref("http://www.test.com/a2").setImg("/img2.jpg"));
        list.add(new Item().setTitle("title_3").setHref("http://www.test.com/a3").setImg("/img3.jpg"));
        list.add(new Item().setTitle("title_4").setHref("http://www.test.com/a4").setImg("/img4.jpg"));
        list.add(new Item().setTitle("title_5").setHref("http://www.test.com/a5").setImg("/img5.jpg"));
        return list;
    }

    private static List<MenuItem> nav0() {
        List<MenuItem> list= new ArrayList<>();
        list.add(new MenuItem().setName("菜单_1").setHref("http://www.test.com/caidan1"));
        list.add(new MenuItem().setName("菜单_2").setHref("http://www.test.com/caidan2"));
        list.add(new MenuItem().setName("菜单_3").setHref("http://www.test.com/caidan3"));
        list.add(new MenuItem().setName("菜单_4").setHref("http://www.test.com/caidan4"));
        list.add(new MenuItem().setName("菜单_5").setHref("http://www.test.com/caidan5"));
        return list;
    }

}
