package com.chuang.urras.sr.restapp.handlers;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.IPreHandler;
import com.chuang.eden.template.fetch.handler.ISaveBeforeHandler;
import com.chuang.tauceti.support.exception.BusinessException;
import com.chuang.tauceti.tools.basic.FutureKit;
import com.chuang.urras.sr.restapp.Handler;
import org.jsoup.nodes.Document;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Component
public class CheckHandler implements IPreHandler, ISaveBeforeHandler {
    @Override
    public String name() {
        return Handler.check.name();
    }

    @Override
    public CompletableFuture<Document> hand(PageInfo info, Document doc, Map<String, Object> context) {
        int size = getBody(info.getWebsite(), doc).select("a").size();
        if(size < 10) {
            return FutureKit.error(new BusinessException(-1, "a 标签太少，放弃~"));
        }
//        Element ele = doc.selectFirst("noscript");
//        if(null != ele) {
//            return FutureKit.error(new SystemWarnException(-1, "这个网站有noscript标签，会导致所有顺序出错，放弃抓取。"));
//        }

        // 将包含google字符的所有script 标签删掉
        doc.select("script").forEach(element -> {
            if(element.toString().contains("google")) {
                element.remove();
            }
        });
//
//        doc.select("link").forEach(element -> {
//            String href = element.attr("href");
//            if(href.contains("google") && href.contains("font")) {
//                element.remove();
//            }
//        });

        return CompletableFuture.completedFuture(doc);
    }

    @Override
    public String hand(String doc) {
        return doc.replace("<head>", "<head>\n${headBegin!\"\"}")
                .replace("</head>", "\n${headEnd!\"\"}</head>")
                .replace("<body>", "<body>\n${bodyBegin!\"\"}")
                .replace("</body>", "\n${bodyEnd!\"\"}</body>\n${bodyNext!\"\"}");
    }
}
