package com.chuang.urras.sr.restapp.handlers;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.IPreHandler;
import com.chuang.eden.template.fetch.handler.ISelectorFinder;
import com.chuang.urras.sr.restapp.Handler;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Component
public class FreeMarkArticleTitleHandler implements IPreHandler {
    @Resource private ISelectorFinder finder;
    @Override
    public CompletableFuture<Document> hand(PageInfo info, Document doc, Map<String, Object> context) {
        List<String> queries = finder.getSelectorQuery(info, name());
        queries.forEach(query -> {
            Element title = doc.selectFirst(query);
            if(null != title) {
                title.text("${articleTitle}");
            }
        });

        return CompletableFuture.completedFuture(doc);
    }

    @Override
    public String name() {
        return Handler.free_mark_article_title.name();
    }
}
