package com.chuang.urras.sr.restapp.handlers;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.IPreHandler;
import com.chuang.eden.template.fetch.handler.ISelectorFinder;
import com.chuang.urras.sr.restapp.Handler;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Component
public class FreeMarkInterlinkHandler implements IPreHandler {

    private static final String INTERLINK_TAG_ATTR_KEY = "select-interlink";
    private static final int TEXT_MIN_SIZE = 3;

    @Resource private ISelectorFinder finder;

//    @Resource private ISeoTemplateService seoTemplateService;

    @Override
    public CompletableFuture<Document> hand(PageInfo info, Document doc, Map<String, Object> context) {
        Element body = getBody(info.getWebsite(), doc);

        List<String> listSelectors = finder.getSelectorQuery(info, name());

        listSelectors.forEach(query -> {
            Element e = body.selectFirst(query);
            if(null == e) {
                return;
            }
            e.select("a").forEach(element -> tagArticleATag(element, INTERLINK_TAG_ATTR_KEY, TEXT_MIN_SIZE));
        });

        Elements aTags = body.select("a[" + INTERLINK_TAG_ATTR_KEY + "]");
        for (int i = 0; i < aTags.size(); i++) {
            handArticleATag(aTags.get(i), INTERLINK_TAG_ATTR_KEY ," interlinks", i);
        }
//        saveInterlinkNum(info, aTags.size());
        context.put("interlinks", aTags.size());

        return CompletableFuture.completedFuture(doc);
    }

    @Override
    public String name() {
        return Handler.free_mark_interlink.name();
    }


//    private void saveInterlinkNum(PageInfo info, int num) {
//        seoTemplateService.findByWebsite(info.getWebsite()).ifPresent(seoTemplate -> {
//            seoTemplate.setInterlinkSize(num);
//            seoTemplateService.updateById(seoTemplate);
//        });
//    }
}
