package com.chuang.urras.sr.restapp.handlers;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.IPreHandler;
import com.chuang.urras.sr.restapp.Handler;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.RandomStringUtils;
import org.jsoup.nodes.Document;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Component
@Slf4j
public class GenJsHandler implements IPreHandler {

    @Override
    public String name() {
        return Handler.gen_js.name();
    }

    @Override
    public CompletableFuture<Document> hand(PageInfo info, Document doc, Map<String, Object> context) {

        String jsName = RandomStringUtils.randomAlphabetic(3,8);
        String jsPath = "/public/js/" + jsName + ".js";

        doc.head().append("<script src=\"" + jsPath+"\" da=\"da\"></script>");

        return CompletableFuture.completedFuture(doc);
    }

}
