package com.chuang.urras.sr.restapp.handlers;

import com.chuang.eden.template.fetch.PageInfo;
import com.chuang.eden.template.fetch.handler.IPreHandler;
import com.chuang.urras.sr.restapp.Handler;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Component
public class PluginUIRemoveHandler implements IPreHandler {
    @Override
    public CompletableFuture<Document> hand(PageInfo info, Document doc, Map<String, Object> context) {
        Element ele = doc.selectFirst("#eden_seo_wnd");
        if(null != ele) {
            ele.remove();
        }
        doc.select("[old-outline]").forEach(element -> {
            if(element.hasAttr("old-outline")) {
                element.removeAttr("old-outline");
            }
            if(element.hasAttr("old-outlineoffset")) {
                element.removeAttr("old-outlineoffset");
            }
        });

        doc.select("#eden_seo_styles").remove();
        doc.select("#fatkun-drop-panel").remove();
        return CompletableFuture.completedFuture(doc);
    }

    @Override
    public String name() {
        return Handler.plugin_ui_remove.name();
    }
}
